/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SAMPLE_GRAPHICS_INL
#define __SAMPLE_GRAPHICS_INL

namespace magnum { namespace sample {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void GraphicsView::setTranslation(const Vector3<float>& t) {
	m_Gui->setTranslation(t);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Vector3<float> GraphicsView::getTranslation() const {
	return m_Gui->getTranslation();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& GraphicsView::getTransform() const {
	return m_Gui->getTransform();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Context* GraphicsView::getContext() const {
	return m_Context;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MatrixStack* GraphicsView::getMatrixStack() const {
	return m_MatrixStack;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Gui* GraphicsView::getGui() const {
	return m_Gui;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MainWindow* GraphicsView::getWindow() const {
	return m_Window;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Timer* GraphicsView::getTimer() const {
	return &m_Timer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Model* GraphicsView::getModel() const {
	return m_Model;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline PerspectiveCamera* GraphicsView::getCamera() {
	return &m_Camera;
}

}; };

#endif
