/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SAMPLE_MODELS_H
#define __SAMPLE_MODELS_H

#include "magnum.graphics.h"
#include "magnum.graphics3d.h"
#include "magnum.io.h"


namespace magnum { namespace sample {
using magnum::graphics3d::Shader;
using magnum::graphics3d::Texture;
using magnum::graphics3d::Model;
using magnum::graphics3d::StaticModel;
using magnum::graphics3d::BoneModel;
using magnum::graphics3d::FrameModel;
using magnum::graphics3d::MeshList;
using magnum::io::File;
using magnum::io::FileFactory;
using magnum::io::SystemFile;
using magnum::io::SystemFileFactory;


void applySkins(const MeshList& ,FileFactory* ,const char* );



template<class T,class M> M* createModel(const char* fname) {
	AutoPointer<File> file = SystemFile::open(fname);
	if (file == NULL)
		return NULL;

	String str(fname);
	int idx = str.lastIndexOf('\\');
	idx = max(idx, str.lastIndexOf('/'));
	str = str.substring(0,idx-1);
		
	SystemFileFactory ff(str);
	TextureManager mgr;
	mgr.getFactory()->setFileFactory(&ff);

	T t;
	t.attachTextureManager(&mgr);

	M* model = static_cast<M*>(t.decode(file->getInputStream()));
//	printBounds(model);
	
	return model;
}

}; };

#endif
