/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SAMPLE_WINDOW_H
#define __SAMPLE_WINDOW_H

#include "magnum.gui.h"
#include "magnum.application.h"


namespace magnum { namespace sample {
using magnum::gui::Window;
using magnum::application::Message;

class GraphicsView;
class ViewerApplication;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MainWindow : public Window {
DeclareClass(MainWindow, Window);
public:
	enum Command {
		LoadModel = 1,
	};
	
public:
	MainWindow(ViewerApplication* );
	~MainWindow();
	
	bool				loadModel();

protected:
	virtual bool		onHandleMessage(const Message& );
	virtual bool		onRequestClose(void);
	
private:
	template<class T>
	bool				loadModel(const char* );
	
private:	
	GraphicsView*		m_Graphics;
	ViewerApplication*	m_Application;
};

}; };

#endif
