/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SAMPLE_GUI_INL
#define __SAMPLE_GUI_INL


namespace magnum { namespace sample {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Point<float>& Gui::getMouse() const {
	return m_Mouse;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& Gui::getTransform() const {
	return m_Navigator.getTransform();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Font* Gui::getFont() const {
	return m_Font;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Gui::getMotionSpeed() const {
	return m_Trackball.getSpeed();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Gui::setMotionSpeed(float s) {
	m_Trackball.setSpeed(s);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Vector3<float> Gui::getTranslation() const {
	return m_Fixed.getTranslation();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Gui::setTranslation(const Vector3<float>& t) {
	m_Fixed.setTranslation(t);
	m_Navigator.update();
}

}; };

#endif
