/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/


#include "sky.h"


namespace magnum { namespace sample {
using namespace magnum::graphics3d;
using namespace magnum::graphics;
using namespace magnum::object;
using namespace magnum::io;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
SkyModel* createSky() {
	SkyModel* model = new SkyModel(SkyModel::Box,1000.0f, 20);
	
//	AutoPointer<File> file = SystemFile::open("data\\CloudyHillsCubemap2.dds");
	AutoPointer<File> file = SystemFile::open("data\\stpeters_cross.dds");
//	AutoPointer<File> file = SystemFile::open("data\\lobby.dds");
//	AutoPointer<File> file = SystemFile::open("data\\uffizi_cross.dds");
	AutoPointer<Image> img = TranslatorDDS().decode(file->getInputStream());
	AutoPointer<Texture> texture = CubeTexture::create(img, Texture::GenerateAll);
	texture->setFilter(Texture::Nearest, Texture::Linear);

	AutoPointer<ColourMaterial> material = new ColourMaterial();
	material->setAmbient(Colour<float>(1.0f, 1.0f, 1.0f));
	material->setDiffuse(Colour<float>(0.8f, 0.8f, 0.9f));
	material->setSpecular(Colour<float>(0.8f, 0.8f, 0.9f));
	material->setEmission(Colour<float>(0.0f, 0.0f, 0.0f));

	AutoPointer<Appearance> appearance = new Appearance();
	AutoPointer<Shader> shader = new CubeTextureShader(FixedShader::Plain);
	appearance->attachShader(shader);
	appearance->attachTexture(texture);
	appearance->attachMaterial(material);
	
	model->attachAppearance(appearance);
		
	return model;
}

}; };

