/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __ALGORITHM_FIND_INL
#define __ALGORITHM_FIND_INL

namespace magnum { namespace algorithm {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class I, class T> I find(const I& begin, const I& end, const T& key) {
    I mid;
	I lo = begin;
	I hi = end;
    int half;
	int num = (int)(hi - lo);

    while (lo < hi) {
        if (half = num / 2) {
            mid = lo + (num & 1 ? half : (half - 1));
            if (*mid == key)
				return mid;
            else if (*mid > key) {
				hi = mid;
                num = num & 1 ? half : half-1;
            } else {
                lo = mid + 1;
                num = half;
            }
        } else if (num)
			return (*lo == key ? lo : end);
		else
            break;
	}

    return end;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class I, class T> I findfirst(const I& begin, const I& end, const T& key) {
	I iter = find(begin, end, key);
	if (iter == end)
		return end;

	I tmp;
	while(iter > begin) {
		tmp = iter--;
		if (*iter != key)
			return tmp;
	}
	return iter;		
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class I, class T> I findlast(const I& begin, const I& end, const T& key) {
	I iter = find(begin, end, key);
	if (iter == end)
		return end;

	I tmp;
	while(iter < end) {
		tmp = iter++;
		if (*iter != key)
			return tmp;
	}
	return iter;		
}

}; };

#endif
