/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __APPLICATION_HANDLER_INL
#define __APPLICATION_HANDLER_INL

namespace magnum { namespace application {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Handler::Handler() {
	m_Messenger = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Handler::Handler(const Handler& ) {
	m_Messenger = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Handler::~Handler() {
	if (m_Messenger != NULL) {
		m_Messenger->remove(this);
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Messenger* Handler::getMessenger() const {
	return m_Messenger;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Handler::handleMessage(const Message& msg) {
	return onHandleMessage(msg);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Handler& Handler::operator=(const Handler& ) {
	return *this;
}

}; };
#endif
