/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __APPLICATION_LOOPER_H
#define __APPLICATION_LOOPER_H

#include "application.messenger.h"

# if defined (__FORX11__)
#	include <X11/Xlib.h>
# endif


namespace magnum { namespace application {
using magnum::object::Object;
using magnum::types::String;
using magnum::system::Thread;

class Message;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Looper : public Messenger {
DeclareClass(Looper, Messenger);
#if defined(__FORX11__)
public:
	static Atom		g_SystemMessage;
	static Atom		g_QuitMessage;
	static Atom		g_ViewPointer;
	static Atom		g_WindowPointer;
	static Atom		g_LooperPointer;
	static Atom		g_IntegerType;
#endif

public:
	Looper();
	~Looper();

	bool			start();
	bool			stop();

protected:
#if defined(__FORX11__)
	virtual bool	dispatchEvent(const XEvent& event);
#endif

private:
	bool			onSynchronize();
	bool			onSendMessage(Message* );
	bool			onPostMessage(Message* );
	
	bool			sysStop();
	bool			sysLoop();
	
private:
	magnum::system::Signal m_Signal;

private:
	class LooperThread : public Thread {
	DeclareClass(LooperThread, Thread);
	private:
		Looper*	m_Looper;

	public:
		LooperThread(Looper* );
		~LooperThread();

	protected:
		bool		run();
	};
	friend class LooperThread;
	

#if defined(__FORX11__)
	class StartupX : public Object {
	DeclareClass(StartupX, Object);
	public:
		StartupX();
		~StartupX();
	};

	static StartupX	g_StartupX;
	static Display*	g_MessageConnection;

protected:
    Window			m_MessageQueue;
	Display*		m_Display;
#endif
};

}; };
#endif
