/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __APPLICATION_MESSAGEQUEUE_H
#define __APPLICATION_MESSAGEQUEUE_H

#include "application.message.h"

namespace magnum { namespace application {
using magnum::container::Queue;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MessageQueue : public Object {
DeclareClass(MessageQueue, Object);
private:
	Queue<Message>	m_Queue;

public:
	typedef magnum::container::Queue<Message>::Iterator	Iterator;

public:
	inline bool		insert(Message* );
	inline bool		insertHead(Message* );
	inline void		clear();
	
	inline Message*	removeHead();
	inline Message*	peekHead() const;
	inline Message*	removeTail();
	inline Message*	peekTail() const;

	inline bool		isEmpty() const;
	inline unsigned int	getSize() const;
};

}; };

#endif
