/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __APPLICATION_MESSENGER_INL
#define __APPLICATION_MESSENGER_INL

namespace magnum { namespace application {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Messenger::Iterator Messenger::begin() const {
	return m_Handlers.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Messenger::Iterator Messenger::end() const {
	return m_Handlers.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Messenger::Iterator Messenger::at(const Handler* hnd) const {
	return m_Handlers.at(hnd);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Messenger::contains(const Handler* hnd) const {
	return m_Handlers.contains(hnd);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Messenger::getSize() const {
	return m_Handlers.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	Messenger::isEmpty() const {
	return m_Handlers.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Messenger::isAlive() const {
	if (m_Thread == NULL)
		return false;
	else
		return m_Thread->isAlive();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Handler* Messenger::getPreferredHandler() const {
	return m_PreferredHandler;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Messenger::setPreferredHandler(Handler* hnd) {
	ASSERT(hnd != NULL);
	ASSERT(hnd->m_Messenger == this);
	m_PreferredHandler = hnd;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Messenger::synchronize() {
	return onSynchronize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Thread* Messenger::getThread() const {
	return m_Thread;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Messenger::attachThread(Thread* thread) {
	ASSERT(thread != NULL);
	m_Thread = thread;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Messenger::detachThread() {
	m_Thread = NULL;
}

}; };

#endif
