/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __APPLICATION_OBSERVER_H
#define __APPLICATION_OBSERVER_H

#include "container.list.h"

namespace magnum { namespace application {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::List;

template<class T> class Observer;
template<class T> class Observable;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Observer : public Object {
DeclareClass(Observer, Object);
friend class Observable<T>;
public:
	~Observer();
	
	void			subscribe(T* );
	void			unsubscribe(T* );
	void			unsubscribe();

protected:	
	virtual void	onNotify(T* );
	
private:
	List<T*>		m_Observables;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Observable {
friend class Observer<T>;
public:
	~Observable();
	
	void			notifyObservers();

private:
	List<Observer<T>*> m_Observers;
};

}; };

#endif
