/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __APPLICATION_PERFORMER_INL
#define __APPLICATION_PERFORMER_INL

namespace magnum { namespace application {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline PerformerThread::PerformerThread(Performer* l) {
	m_Performer = l;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Performer* PerformerThread::getPerformer() const {
	return m_Performer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Performer::Iterator Performer::begin() const {
	return m_Tasks.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Performer::Iterator	Performer::at(const Task* t) const {
	return m_Tasks.at(t);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Performer::Iterator	Performer::end() const {
	return m_Tasks.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Thread* Performer::getThread() const {
	return m_Thread;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Performer::isSuspended() const {
	return !m_PauseSignal.isRaised();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Performer::isStarted() const {
	return (m_Thread != NULL);
}

}; };

#endif
