/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __APPLICATION_TASK_H
#define __APPLICATION_TASK_H

#include "system.thread.h"
#include "container.chain.h"

namespace magnum { namespace application {
using magnum::system::Thread;
using magnum::container::Chainable;
using magnum::types::String;

class Performer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Task : public Thread, public Chainable<Task> {
DeclareClass(Task, Thread);
friend class Performer;
public:
	inline Task();
	inline ~Task();
	
	inline Performer*		getPerformer() const;
	
protected:
	virtual void			onStart();
	virtual void			onStop();
	virtual void			onSync();
	virtual void			onProcess();
	
private:
	virtual bool			run();
};

}; };

#endif
