/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __AUDIO3D_BUFFER_H
#define __AUDIO3D_BUFFER_H

#include "audio3d.device.h"
#include "audio3d.resource.h"
#include "container.array.h"

namespace magnum { namespace audio3d {
using magnum::container::Array;

class Source;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Buffer : public Resource {
DeclareClass(Buffer, Resource);
friend class Source;
public:
	enum Format {
		Mono8 = AL_FORMAT_MONO8,
		Mono16 = AL_FORMAT_MONO16,
		Stereo8 = AL_FORMAT_STEREO8,
		Stereo16 = AL_FORMAT_STEREO16,
	};

public:						
	Buffer(Format ,unsigned int );
	~Buffer();				
							
	bool					setBuffer(const void* ,unsigned int );
							
	inline unsigned int		getFrequency() const;
	inline Format			getFormat() const;
	inline unsigned int		getSize() const;

private:
	unsigned int			m_Buffer;
	Format					m_Format;
	unsigned int			m_Frequency;
};

}; };

#endif
