/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __AUDIO3D_BUFFERGROUP_H
#define __AUDIO3D_BUFFERGROUP_H

#include "audio3d.buffer.h"
#include "container.array.h"

namespace magnum { namespace audio3d {
using magnum::container::Array;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class BufferGroup : public Resource {
DeclareClass(BufferGroup, Resource);
public:
	typedef magnum::container::Array<Buffer*>::Iterator Iterator;
	
public:
	BufferGroup();
	~BufferGroup();	

	void				clear();
	inline unsigned int getSize() const;
	inline bool			isEmpty() const;

	inline Iterator		begin() const;
	inline Iterator		at(unsigned int ) const;
	inline Iterator		end() const;

	inline unsigned int	insert(Buffer* );
	void				remove(Buffer* );
	void				remove(const Iterator& iter);
	bool				contains(Buffer* ) const;

private:
	Array<Buffer*>		m_Buffers;
};

}; };

#endif
