/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __AUDIO3D_BUFFERGROUP_INL
#define __AUDIO3D_BUFFERGROUP_INL

namespace magnum { namespace audio3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int BufferGroup::getSize() const {
	return m_Buffers.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool BufferGroup::isEmpty() const {
	return m_Buffers.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BufferGroup::Iterator BufferGroup::begin() const {
	return m_Buffers.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BufferGroup::Iterator BufferGroup::at(unsigned int n) const {
	return m_Buffers.at(n);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BufferGroup::Iterator BufferGroup::end() const {
	return m_Buffers.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int BufferGroup::insert(Buffer* b) {
	b->refer();
	m_Buffers.insert(b);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BufferGroup::remove(const BufferGroup::Iterator& iter) {
	(*iter)->release();
	m_Buffers.remove(iter);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool BufferGroup::contains(Buffer* b) const {
	return m_Buffers.contains(b);
}

}; };

#endif
