/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __BASE_INTRINSICS_H
#define __BASE_INTRINSICS_H

#if defined(__FORWINDOWS__)
	extern "C" {
	LONG  __cdecl _InterlockedIncrement(LONG volatile *Addend);
	LONG  __cdecl _InterlockedDecrement(LONG volatile *Addend);
	LONG  __cdecl _InterlockedCompareExchange(LPLONG volatile Dest, LONG Exchange, LONG Comp);
	LONG  __cdecl _InterlockedExchange(LPLONG volatile Target, LONG Value);
	LONG  __cdecl _InterlockedExchangeAdd(LPLONG volatile Addend, LONG Value);
	}

	#pragma intrinsic (_InterlockedCompareExchange)
	#define InterlockedCompareExchange _InterlockedCompareExchange

	#pragma intrinsic (_InterlockedExchange)
	#define InterlockedExchange _InterlockedExchange 

	#pragma intrinsic (_InterlockedExchangeAdd)
	#define InterlockedExchangeAdd _InterlockedExchangeAdd

	#pragma intrinsic (_InterlockedIncrement)
	#define InterlockedIncrement _InterlockedIncrement

	#pragma intrinsic (_InterlockedDecrement)
	#define InterlockedDecrement _InterlockedDecrement
#endif

#endif
