/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __BASE_NUMBER_INL
#define __BASE_NUMBER_INL

namespace magnum { namespace types {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline TypedNumber<T>::TypedNumber() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline TypedNumber<T>::TypedNumber(const T& t) {
	m_Number = t;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline unsigned char TypedNumber<T>::byteValue() const {
	return (unsigned char)m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline short TypedNumber<T>::shortValue() const {
	return (short)m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline int TypedNumber<T>::intValue() const {
	return (int)m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline long TypedNumber<T>::longValue() const {
	return (long)m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline float TypedNumber<T>::floatValue() const {
	return (float)m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline double TypedNumber<T>::doubleValue() const {
	return (double)m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline bool TypedNumber<T>::boolValue() const {
	return (bool)m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> template<class S>
inline bool TypedNumber<T>::operator==(const TypedNumber<S>& n) const {
	return m_Number == (T)n.m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> template<class S>
inline bool TypedNumber<T>::operator!=(const TypedNumber<S>& n) const {
	return m_Number != (T)n.m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> template<class S>
inline bool TypedNumber<T>::operator>(const TypedNumber<S>& n) const {
	return m_Number > (T)n.m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> template<class S>
inline bool TypedNumber<T>::operator<(const TypedNumber<S>& n) const {
	return m_Number < (T)n.m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> template<class S>
inline bool TypedNumber<T>::operator>=(const TypedNumber<S>& n) const {
	return m_Number >= (T)n.m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> template<class S>
inline bool TypedNumber<T>::operator<=(const TypedNumber<S>& n) const {
	return m_Number <= (T)n.m_Number;
}

}; };
#endif
