/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __CONTAINER_ITEM_H
#define __CONTAINER_ITEM_H

namespace magnum { namespace container {

/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T> class Item {
public:
	inline Item();
	inline Item(const T& );
	inline Item(const Item<T>& );
	
	inline		operator T&();
	inline		operator const T&() const;
	
	inline const Item<T>&	operator=(const Item<T>& );
	inline const Item<T>&	operator=(const T& );

	inline bool	operator==(const Item<T>& ) const;
	inline bool	operator!=(const Item<T>& ) const;
	inline bool	operator<(const Item<T>& ) const;
	inline bool	operator>(const Item<T>& ) const;
	inline bool	operator<=(const Item<T>& ) const;
	inline bool	operator>=(const Item<T>& ) const;
	
private:
	T			m_Item;
};

}; };

#endif
