/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __CONTAINER_ITEM_INL
#define __CONTAINER_ITEM_INL

namespace magnum { namespace container {

/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline Item<T>::Item() {
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline Item<T>::Item(const T& t) {
	m_Item = t;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline Item<T>::Item(const Item<T>& i) {
	m_Item = i.m_Item;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline const Item<T>& Item<T>::operator=(const Item<T>& i) {
	m_Item = i.m_Item;
	return *this;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline const Item<T>& Item<T>::operator=(const T& t) {
	m_Item = t;
	return *this;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline Item<T>::operator T&() {
	return m_Item;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline Item<T>::operator const T&() const {
	return m_Item;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline bool	Item<T>::operator==(const Item<T>& i) const {
	return !memcmp(&m_Item, i.m_Item, sizeof(T));
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline bool	Item<T>::operator!=(const Item<T>& i) const{
	return memcmp(&m_Item, i.m_Item, sizeof(T));
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline bool	Item<T>::operator<(const Item<T>& i) const {
	return (memcmp(&m_Item, i.m_Item, sizeof(T)) < 0);
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline bool	Item<T>::operator>(const Item<T>& i) const {
	return (memcmp(&m_Item, i.m_Item, sizeof(T)) > 0);
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline bool	Item<T>::operator<=(const Item<T>& i) const {
	return (memcmp(&m_Item, i.m_Item, sizeof(T)) <= 0);
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T>
inline bool	Item<T>::operator>=(const Item<T>& i) const {
	return (memcmp(&m_Item, i.m_Item, sizeof(T)) >= 0);
}

}; };

#endif
