/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __CONTAINER_ITERATORBASE_H
#define __CONTAINER_ITERATORBASE_H

#include "object.h"

namespace magnum { namespace container {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class IteratorBase {
public:
	inline bool operator!=(const T& iter) const;
	inline bool operator>=(const T& iter) const;
	inline bool operator<=(const T& iter) const;
	inline bool operator<(const T& iter) const;

	inline T& operator+=(int n);
	inline T& operator-=(int n);
	inline T operator+(int n) const;
	inline T operator-(int n) const;
};

}; };
#endif
