/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __CONTAINER_PAIR_INL
#define __CONTAINER_PAIR_INL

namespace magnum { namespace container {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline Pair<T1,T2>::Pair(void) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline Pair<T1,T2>::Pair(const T1& f, const T2& s) {
	first = f;
	second = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline bool Pair<T1,T2>::operator==(const Pair<T1,T2>& e) const {
	return ((first == e.first) && (second == e.second));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline bool Pair<T1,T2>::operator!=(const Pair<T1,T2>& e) const {
	return ((first != e.first) || (second != e.second));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline bool Pair<T1,T2>::operator<(const Pair<T1,T2>& e) const {
	if (first != e.first)
		return (first < e.first);
	return (second < e.second);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline bool Pair<T1,T2>::operator<=(const Pair<T1,T2>& e) const {
	if (first != e.first)
		return (first < e.first);
	return (second <= e.second);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline bool Pair<T1,T2>::operator>(const Pair<T1,T2>& e) const {
	if (first != e.first)
		return (first > e.first);
	return (second > e.second);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T1, class T2> inline bool Pair<T1,T2>::operator>=(const Pair<T1,T2>& e) const {
	if (first != e.first)
		return (first > e.first);
	return (second >= e.second);
}

}; };

#endif
