/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __CONTAINER_TUPLE_H
#define __CONTAINER_TUPLE_H

#include "base.h"

namespace magnum { namespace container {

/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
template<class T, unsigned int n> class Tuple {
private:
	T		m_Tuple[n];

public:
	inline Tuple();
	inline Tuple(const T* );

	inline bool		contains(const T& ) const;

	inline T		min() const;
	inline T		max() const;

	inline bool		operator==(const Tuple& ) const;
	inline bool		operator!=(const Tuple& ) const;
	inline bool		operator<(const Tuple& ) const;
	inline bool		operator<=(const Tuple& ) const;
	inline bool		operator>(const Tuple& ) const;
	inline bool		operator>=(const Tuple& ) const;

	inline			operator const T*() const;
	inline			operator T*();
};


}; };

#endif
