/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __DEBUG_ASSERT_H
#define __DEBUG_ASSERT_H

#if !defined(__FORDEBUG__)
#	define ASSERT(a)
#	define PRINT(a)
#	define PRINT1(a,b)
#	define PRINT2(a,b,c)
#	define PRINT3(a,b,c,d)
#	define PRINT4(a,b,c,d,e)
#	define PRINT5(a,b,c,d,e,f)
#elif defined(__FORWINDOWS__)
#	include <crtdbg.h>
#	include <stdio.h>
#	define ASSERT(a) \
	if (!(a)) { \
		_CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_WNDW); \
		_CrtDbgReport(_CRT_ASSERT, __FILE__,__LINE__,"magnum",#a "\n"); \
	}
#	define PRINT(a) \
		_CrtDbgReport(_CRT_WARN, __FILE__,__LINE__,"magnum",a "\n"); 
#	define PRINT1(a,b) \
		_CrtDbgReport(_CRT_WARN, __FILE__,__LINE__,"magnum",a "\n",b); 
#	define PRINT2(a,b,c) \
		_CrtDbgReport(_CRT_WARN, __FILE__,__LINE__,"magnum",a "\n",b,c); 
#	define PRINT3(a,b,c,d) \
		_CrtDbgReport(_CRT_WARN, __FILE__,__LINE__,"magnum",a "\n",b,c,d); 
#	define PRINT4(a,b,c,d,e) \
		_CrtDbgReport(_CRT_WARN, __FILE__,__LINE__,"magnum",a "\n",b,c,d,e); 
#	define PRINT5(a,b,c,d,e,f) \
		_CrtDbgReport(_CRT_WARN, __FILE__,__LINE__,"magnum",a "\n",b,c,d,e,f); 
#else
#	include <stdio.h>
#	define ASSERT(a) \
	if (!(a)) { printf("ASSERTION FAILED: %s@%d",__FILE__,__LINE__); printf(#a "\n"); }
#	define PRINT(a) \
	printf("%s@%d: ",__FILE__,__LINE__); \
	printf(a "\n");
#	define PRINT1(a,b) \
	printf("%s@%d: ",__FILE__,__LINE__); \
	printf(a "\n",b);
#	define PRINT2(a,b,c) \
	printf("%s@%d: ",__FILE__,__LINE__); \
	printf(a "\n",b,c);
#	define PRINT3(a,b,c,d) \
	printf("%s@%d: ",__FILE__,__LINE__); \
	printf(a "\n",b,c,d);
#	define PRINT4(a,b,c,d,e) \
	printf("%s@%d: ",__FILE__,__LINE__); \
	printf(a "\n",b,c,d,e);
#	define PRINT5(a,b,c,d,e,f) \
	printf("%s@%d: ",__FILE__,__LINE__); \
	printf(a "\n",b,c,d,e,f);
#endif


#endif
