/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_COUNTER_H
#define __DEBUG_COUNTER_H

#include "debug.instrument.h"

namespace magnum { namespace debug {
class Profiler;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Counter : public Instrument {
DeclareClass(Counter, Instrument);
friend class Profiler;
private:
	unsigned int		m_Current;
	unsigned int		m_Minimum;
	unsigned int		m_Maximum;
	unsigned int		m_Average;
	unsigned int		m_Loops;

protected:
	inline Counter(const char* );
	
public:
	inline void			increment();
	inline void			decrement();
	
	inline unsigned int	getValue() const;
	inline unsigned int	getMinimum() const;
	inline unsigned int	getMaximum() const;
	inline float		getAverage() const;
	
protected:
	virtual void		onReset();
	virtual void		onProceed();
};

}; };

#endif
