/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_COUNTER_INL
#define __DEBUG_COUNTER_INL

namespace magnum { namespace debug {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Counter::Counter(const char* n) : Instrument(n) {
	onReset();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Counter::increment() {
	m_Current++;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Counter::decrement() {
	m_Current--;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int	Counter::getValue() const {
	return m_Current;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int	Counter::getMinimum() const {
	return m_Minimum;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int	Counter::getMaximum() const {
	return m_Maximum;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Counter::getAverage() const {
	return (float)m_Average / (float)m_Loops;
}

}; };

#endif
