/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_INSTRUMENT_H
#define __DEBUG_INSTRUMENT_H

#include "container.chain.h"

namespace magnum { namespace debug {
using magnum::container::Chainable;
using magnum::object::Object;
using magnum::types::String;

class Profiler;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Instrument : public Object, private Chainable<Instrument> {
DeclareClass(Instrument, Object);
friend class Profiler;
private:
	String				m_Name;
	
protected:
	inline Instrument(const char* );
		
public:
	inline String		getName() const;
	
	inline void			reset();
	inline void			proceed();

protected:
	virtual void		onReset();
	virtual void		onProceed();
};

}; };

#endif