/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_LOGGER_H
#define __DEBUG_LOGGER_H

#include "system.timestamp.h"
#include "system.mutex.h"

namespace magnum { namespace debug {
using magnum::object::Object;
using magnum::object::Noncopyable;
using magnum::types::String;
using magnum::system::Timestamp;
using magnum::system::Mutex;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Logger : public Object, private Noncopyable {
DeclareClass(Logger, Object);
public:
	void				info(const char* );
	void				warn(const char* );
	void				error(const char* );
	
protected:
	virtual void		onInfo(const Timestamp& ,const char* );
	virtual void		onWarn(const Timestamp& ,const char* );
	virtual void		onError(const Timestamp& ,const char* );
	virtual void		onPrint(const String& );
	
private:
	Timestamp			m_Timestamp;
	Mutex				m_Mutex;
};

inline Logger& operator<<(Logger& ,const char* str);
inline Logger& operator<<(Logger& ,const String& str);

}; };

#endif
