/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_PROFILER_H
#define __DEBUG_PROFILER_H

#include "container.chain.h"

namespace magnum { namespace debug {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Chain;

class Timer;
class Counter;
class Instrument;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Profiler : public Object {
DeclareClass(Profiler, Object);
public:
	typedef Chain<Instrument>::Iterator Iterator;
	
private:
	Chain<Instrument>	m_Instruments;

public:
	Timer*				createTimer(const char* );
	Timer*				getTimer(const char* ) const;
	
	Counter*			createCounter(const char* );
	Counter*			getCounter(const char* ) const;
	
	inline Instrument* 	getInstrument(const char* ) const;
	
	inline void			clear();
	inline bool			isEmpty() const;
	inline unsigned int	getSize() const;
	
	inline Iterator		begin() const;
	inline Iterator		end() const;
	
private:
	Instrument*			findInstrument(const char* ) const;	
};

}; };

#endif
