/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_PROFILER_INL
#define __DEBUG_PROFILER_INL

namespace magnum { namespace debug {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Instrument* Profiler::getInstrument(const char* n) const {
	return findInstrument(n);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Profiler::Iterator Profiler::begin() const {
	return m_Instruments.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Profiler::Iterator Profiler::end() const {
	return m_Instruments.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Profiler::clear() {
	m_Instruments.clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Profiler::isEmpty() const {
	return m_Instruments.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int	Profiler::getSize() const {
	return m_Instruments.getSize();
}

}; };

#endif
