/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_STREAMLOGGER_H
#define __DEBUG_STREAMLOGGER_H

#include "object.pointer.h"
#include "debug.logger.h"
#include "io.outputstream.h"
#include "io.file.h"

namespace magnum { namespace debug {
using magnum::object::Pointer;
using magnum::io::File;
using magnum::io::OutputStream;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StreamLogger : public Logger {
DeclareClass(StreamLogger, Logger);
public:
	StreamLogger(OutputStream* );
	StreamLogger(File* );
	StreamLogger(const char* );
	~StreamLogger();
	
	inline OutputStream*	getStream() const;
	
protected:	
	virtual void			onPrint(const String& );

private:
	Pointer<OutputStream>	m_Stream;
	Pointer<File>			m_File;
};

}; };

#endif
