/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_TIMER_H
#define __DEBUG_TIMER_H

#include "debug.instrument.h"

namespace magnum { namespace debug {
using magnum::types::int64;

class Profiler;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Timer : public Instrument {
DeclareClass(Timer, Instrument);
friend class Profiler;
private:
	class Startup {
	public:
		Startup();
	};
	friend class Startup;
	static Startup	g_Startup;

#if defined(__FORWINDOWS__)
	static int64	g_Frequency;
	static float	g_FrequencyFlt;
	static double	g_FrequencyDbl;
#endif	
	int64			m_Current;
	int64			m_Minimum;
	int64			m_Maximum;
	int64			m_Average;
	unsigned int	m_Loops;

protected:
	inline Timer(const char* );
	
public:
	inline void		enter();
	inline void		exit();
	
	inline float	getValue() const;
	inline float	getMinimum() const;
	inline float	getMaximum() const;
	inline float	getAverage() const;

protected:
	virtual void	onReset();
	virtual void	onProceed();
};

}; };

#endif
