/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __DEBUG_TIMER_INL
#define __DEBUG_TIMER_INL

namespace magnum { namespace debug {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Timer::Timer(const char* n) : Instrument(n) {
	onReset();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Timer::getValue() const {
	return (float)m_Current / g_FrequencyFlt;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Timer::getMinimum() const {
	return (float)m_Minimum / g_FrequencyFlt;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Timer::getMaximum() const {
	return (float)m_Maximum / g_FrequencyFlt;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Timer::getAverage() const {
	return (float)m_Average / ((float)m_Loops * g_Frequency);
}
}; };

#endif
