/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __FREETYPE_DESCRIPTOR_INL
#define __FREETYPE_DESCRIPTOR_INL

namespace magnum { namespace freetype {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Descriptor::getName() const {
	return m_Family + " " + m_Style;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Descriptor::setFamily(const char* f) {
	m_Family = f;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const String& Descriptor::getFamily() const {
	return m_Family;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Descriptor::setStyle(const char* s) {
	m_Style = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const String& Descriptor::getStyle() const {
	return m_Style;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Descriptor::setSize(float w) {
	m_Size.setWidth(w);
	m_Size.setHeight(w);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Descriptor::setSize(float w, float h) {
	m_Size.setWidth(w);
	m_Size.setHeight(h);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Descriptor::setSize(const Dimension<float>& size) {
	m_Size = size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Dimension<float>& Descriptor::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Descriptor::getWidth() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Descriptor::getHeight() const {
	return m_Size.getHeight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Descriptor::setEncoding(Encoding::Type e) {
	m_Encoding = e;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Encoding::Type Descriptor::getEncoding() const {
	return m_Encoding;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Descriptor::setKerning(bool k) {
	m_Kerning = k;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Descriptor::getKerning() const {
	return m_Kerning;
}


}; };

#endif
