/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __FREETYPE_FONT_INL
#define __FREETYPE_FONT_INL

namespace magnum { namespace freetype {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Image* Font::getBitmap() const {
	return &m_Image;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Image* Font::getBitmap() {
	return &m_Image;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Glyph& Font::operator[](char c) const {
	return m_Glyphs[(unsigned int)(unsigned char)c];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Glyph& Font::operator[](char c) {
	return m_Glyphs[(unsigned int)(unsigned char)c];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Descriptor& Font::getDescriptor() const {
	return m_Descriptor;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Font::getName() const {
	return m_Descriptor.getName();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const String& Font::getFamily() const {
	return m_Descriptor.getFamily();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const String& Font::getStyle() const {
	return m_Descriptor.getStyle();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Dimension<float>& Font::getSize() const {
	return m_Descriptor.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Encoding::Type Font::getEncoding() const {
	return m_Descriptor.getEncoding();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Font::getKerning() const {
	return m_Descriptor.getKerning();
}


}; };

#endif
