/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __FREETYPE_GLYPH_H
#define __FREETYPE_GLYPH_H

#include "graphics.rectangle.h"
#include "graphics.dimension.h"
#include "graphics.point.h"

namespace magnum { namespace freetype {
using magnum::graphics::Rectangle;
using magnum::graphics::Dimension;
using magnum::graphics::Point;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Glyph {
private:
	Rectangle<int>				m_Location;
	Dimension<float>			m_Size;
	Point<float>				m_Bearing;

public:
	inline void					setLocation(const Rectangle<int>& );
	inline void					setLocation(int ,int, int, int );
	inline void					setSize(const Dimension<float>& );
	inline void					setSize(float ,float );
	inline void					setBearing(const Point<float>& );
	inline void					setBearing(float ,float );

	inline const Dimension<float>& getSize() const;
	inline float				getWidth() const;
	inline float				getHeight() const;
	inline const Rectangle<int>& getLocation() const;
	inline const Point<float>&	getBearing() const;
};

}; };

#endif
