/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __FUNCTION_DELEGATE_H
#define __FUNCTION_DELEGATE_H

namespace magnum { namespace function {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class R>
class Delegate {
public:
	inline Delegate();
	inline Delegate(R (*)());
	template<class T>
	inline Delegate(T*, R (T::*)());
	
	inline R operator()() const;
	
private:
	typedef R (*Stub)(void* obj);
	
	void*		m_Object;
	Stub*		m_Stub;
	
	template<class T,R (T::*method)()>
	static R method_stub(void* );
   	
	template<R (*method)()>
   	static R function_stub(void* );
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class R,class A1>
class Delegate1 {
public:
	inline Delegate1();
	inline Delegate1(R (*)(A1));
	template<class T>
	inline Delegate1(T*, R (T::*)(A1));

	inline R operator()(A1& ) const;
	
private:
	typedef R (*Stub)(void* obj, A1);
	
	Object*		m_Object;
	Stub*		m_Stub;
	
	template<class T,R (T::*method)(A1)>
	static R method_stub(void* ,A1& );

	template<R (*method)(A1)>
   	static R function_stub(void* ,A1& );
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class R,class A1,class A2>
class Delegate2 {
public:
	inline Delegate2();
	inline Delegate2(R (*)(A1 ,A2 ));
	template<class T>
	inline Delegate2(T*, R (T::*)(A1 ,A2 ));

	inline R operator()(A1& ,A2& ) const;
	
private:
	typedef R (*Stub)(void* obj,A1 ,A2 );
	
	Object*		m_Object;
	Stub*		m_Stub;
	
	template<class T,R (T::*method)(A1 ,A2 )>
	static R method_stub(void* ,A1& ,A2& );

	template<R (*method)(A1 ,A2 )>
   	static R function_stub(void* ,A1& ,A2& );
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class R,class A1,class A2,class A3>
class Delegate3 {
public:
	inline Delegate3();
	inline Delegate3(R (*)(A1 ,A2 ,A3 ));
	template<class T>
	inline Delegate3(T*, R (T::*)(A1 ,A2 ,A3 ));

	inline R operator()(A1& ,A2& ,A3& ) const;
	
private:
	typedef R (*Stub)(void* obj,A1 ,A2 ,A3 );
	
	Object*		m_Object;
	Stub*		m_Stub;
	
	template<class T,R (T::*method)(A1 ,A2 ,A3 )>
	static R method_stub(void* ,A1& ,A2& ,A3& );

	template<R (*method)(A1 ,A2 ,A3 )>
   	static R function_stub(void* ,A1& ,A2& ,A3&);
};

}; };

#endif
