/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __CONTAINER_SEQUENCE_H
#define __CONTAINER_SEQUENCE_H

#include "container.array.h"

namespace magnum { namespace container {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Sequence : public Object {
DeclareClass(Sequence, Object);
public:
	template<class T>
	void	insert(T* ,void (T::*)(void)); 
	template<class T,class P1>
	void	insert(T* ,void (T::*)(P1),const P1& ); 
	template<class T,class P1,class P2>
	void	insert(T* ,void (T::*)(P1,P2),const P1& ,const P2& ); 
	template<class T,class P1,class P2,class P3>
	void	insert(T* ,void (T::*)(P1,P2,P3),const P1& ,const P2& ,const P3& ); 
	
	inline void		clear();
	inline bool		isEmpty() const;
	
	void			execute();

private:
	Array<intptr_t>	m_Sequence;

	template<class T> class Executor0 {
	public:
		static const intptr_t*	execute(const intptr_t* );
	};

	template<class T,class P1> class Executor1 {
	public:
		static const intptr_t*	execute(const intptr_t* );
	};

	template<class T,class P1,class P2> class Executor2 {
	public:
		static const intptr_t*	execute(const intptr_t* );
	};

	template<class T,class P1,class P2,class P3> class Executor3 {
	public:
		static const intptr_t*	execute(const intptr_t* );
	};
};

}; };

#endif
