/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_BINORMALGENERATOR_H
#define __GEOMETRY_BINORMALGENERATOR_H

#include "geometry.attributegenerator.h"

namespace magnum { namespace geometry {
using magnum::math::Vector2;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T,class I> class BinormalGenerator : public AttributeGenerator<T,I> {
//DeclareClass(BinormalGenerator, AttributeGenerator);
public:
	BinormalGenerator();

	inline unsigned int getNormalStride() const;
	inline const Vector3<T>* getNormals() const;
	inline void			setNormals(const Vector3<T>* ,unsigned int = sizeof(Vector3<T>));

	inline unsigned int getTextureStride() const;
	inline const Vector2<T>* getTextures() const;
	inline void			setTextures(const Vector2<T>* ,unsigned int = sizeof(Vector2<T>));

	inline unsigned int getBinormalStride() const;
	inline Vector3<T>*	getBinormals() const;
	inline void			setBinormals(Vector3<T>* ,unsigned int = sizeof(Vector3<T>));

	inline unsigned int getTangentStride() const;
	inline Vector3<T>*	getTangents() const;
	inline void			setTangents(Vector3<T>* ,unsigned int = sizeof(Vector3<T>));

	void				generate();

protected:
	inline const Vector3<T>& getNormal(unsigned int );
	inline const Vector2<T>& getTexture(unsigned int );
	inline Vector3<T>&	getBinormal(unsigned int );
	inline Vector3<T>&	getTangent(unsigned int );

private:
	const Vector3<T>*	m_Normals;
	unsigned int		m_NormalStride;
	const Vector2<T>*	m_Textures;
	unsigned int		m_TextureStride;
	Vector3<T>*			m_Tangents;
	unsigned int		m_TangentStride;
	Vector3<T>*			m_Binormals;
	unsigned int		m_BinormalStride;
};

}; };

#endif
