/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_BODYCOLLIDER_H
#define __GEOMETRY_BODYCOLLIDER_H

#include "geometry.collider.h"

namespace magnum { namespace geometry {

/*--------------------------------------------------------------------------*/
/**
 */
template<class T> class BodyCollider : public Collider<typename T::Scalar, T::Dimension> {
DeclareClass(BodyCollider, Collider);
public:
	inline BodyCollider();
	inline BodyCollider(const T& );
	
	inline				operator T&();
	inline				operator const T&() const;
	
	inline const BodyCollider<T>& operator=(const T& );
	
protected:
	virtual bool		onIntersect(const Line<typename T::Scalar,T::Dimension>& l,Intersection<typename T::Scalar,T::Dimension>* i) const {
		return m_Body.intersect(l,i);
	}
	virtual bool		onIntersect(const Segment<typename T::Scalar,T::Dimension>& s,Intersection<typename T::Scalar,T::Dimension>* i) const {
		return m_Body.intersect(s,i);
	}
	virtual bool		onIntersect(const Ray<typename T::Scalar,T::Dimension>& r,Intersection<typename T::Scalar,T::Dimension>* i) const {
		return m_Body.intersect(r,i);
	}
	
private:
	T					m_Body;	
};

}; };

#endif
