/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_BODYCOLLIDER_INL
#define __GEOMETRY_BODYCOLLIDER_INL

namespace magnum { namespace geometry {


/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
inline BodyCollider<T>::BodyCollider() {
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
inline BodyCollider<T>::BodyCollider(const T& t) : m_Body(t) {
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
inline BodyCollider<T>::operator T&() {
	return m_Body;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
inline BodyCollider<T>::operator const T&() const {
	return m_Body;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
inline const BodyCollider<T>& BodyCollider<T>::operator=(const T& t) {
	m_Body = t;
	return *this;
}

#if 0
/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
bool BodyCollider<T>::onIntersect(const Line<typename T::Scalar,T::Dimension>& l,Intersection<typename T::Scalar,T::Dimension>* is) const {
	return m_Body.intersect(l, is);
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
bool BodyCollider<T>::onIntersect(const Segment<typename T::Scalar,T::Dimension>& s,Intersection<typename T::Scalar,T::Dimension>* is) const {
	return m_Body.intersect(s, is);
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T> 
bool BodyCollider<T>::onIntersect(const Ray<typename T::Scalar,T::Dimension>& r,Intersection<typename T::Scalar,T::Dimension>* is) const {
	return m_Body.intersect(r, is);
}
#endif

}; };

#endif
