/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_COLLIDER_H
#define __GEOMETRY_COLLIDER_H

#include "object.h"

namespace magnum { namespace geometry {
using magnum::object::Object;
using magnum::types::String;

template<class T,int dim> class Line;
template<class T,int dim> class Ray;
template<class T,int dim> class Segment;
template<class T,int dim> class Intersection;

/*--------------------------------------------------------------------------*/
/**
 */
template<class T, int dim> class Collider : public Object {
DeclareClass(Collider, Object);
public:
	static const int	Dimension = dim;
	typedef	T			Scalar;

public:
	inline bool			intersect(const Line<T,dim>& ,Intersection<T,dim>* = NULL) const;
	inline bool			intersect(const Segment<T,dim>& ,Intersection<T,dim>* = NULL) const;
	inline bool			intersect(const Ray<T,dim>& ,Intersection<T,dim>* = NULL) const;

protected:
	virtual bool		onIntersect(const Line<T,dim>& ,Intersection<T,dim>* ) const;
	virtual bool		onIntersect(const Segment<T,dim>& ,Intersection<T,dim>* ) const;
	virtual bool		onIntersect(const Ray<T,dim>& ,Intersection<T,dim>* ) const;
};

}; };

#endif
