/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_COLLIDER_INL
#define __GEOMETRY_COLLIDER_INL

namespace magnum { namespace geometry {

/*--------------------------------------------------------------------------*/
/**
 */
template<class T, int dim>
inline bool Collider<T,dim>::intersect(const Line<T,dim>& l,Intersection<T,dim>* is) const {
	return onIntersect(l,is);
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T, int dim>
inline bool Collider<T,dim>::intersect(const Segment<T,dim>& s,Intersection<T,dim>* is) const {
	return onIntersect(s,is);
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T, int dim>
inline bool Collider<T,dim>::intersect(const Ray<T,dim>& r,Intersection<T,dim>* is) const {
	return onIntersect(r,is);
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T, int dim>
bool Collider<T,dim>::onIntersect(const Line<T,dim>& ,Intersection<T,dim>* ) const {
	ASSERT(false);
	return false;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T, int dim>
bool Collider<T,dim>::onIntersect(const Segment<T,dim>& ,Intersection<T,dim>* ) const {
	ASSERT(false);
	return false;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T, int dim>
bool Collider<T,dim>::onIntersect(const Ray<T,dim>& ,Intersection<T,dim>* ) const {
	ASSERT(false);
	return false;
}

}; };

#endif
