/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_CONE_INL
#define __GEOMETRY_CONE_INL

namespace magnum { namespace geometry {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Cone3<T>::setOrigin(const Vector3<T>& o) {
	m_Origin = o;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline const Vector3<T>& Cone3<T>::getOrigin() const {
	return m_Origin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Cone3<T>::setDirection(const Vector3<T>& d) {
	m_Direction = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline const Vector3<T>& Cone3<T>::getDirection() const {
	return m_Direction;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline void Cone3<T>::setLength(const T& l) {
	m_Direction *= l / m_Direction.length();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> inline T Cone3<T>::getLength() const {
	return m_Direction.length();
}


template<class T> inline bool Cone3<T>::isEmpty() const;

template<class T> inline bool Cone3<T>::isInside(const Vector3<T>& ) const;
template<class T> inline T Cone3<T>::getDistance2(const Vector3<T>& ) const;


}; };

#endif
