/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_DIRECTIONBOXCONSTRAINT_H
#define __GEOMETRY_DIRECTIONBOXCONSTRAINT_H

#include "math.vector2.h"
#include "math.vector3.h"
#include "geometry.transformconstraints.h"

namespace magnum { namespace geometry {
using magnum::math::Vector2;
using magnum::math::Vector3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class DirectionBoxConstraint3 : public TransformConstraint<T,3> {
public:
	inline DirectionBoxConstraint3();
	
	inline void			setDirection(const Vector3<T>& );
	inline void			setDirection(const Vector3<T>& ,const Vector2<float>& );
	inline const Vector3<T>& getDirection() const;
	inline const Vector2<float>& getDirectionRange() const;
	
	inline void			setUp(const Vector3<T>& );
	inline void			setUp(const Vector3<T>& ,float );
	inline const Vector3<T>& getUp() const;
	inline float		getUpRange() const;

    inline void			setCenter(const Vector3<T>& );
    inline const Vector3<T>& getCenter() const;

protected:
	virtual bool		onConstrain(Transform<T,3>& );

private:
	Vector3<T>			m_Dir;
	Vector2<float>		m_DirRange;
	Vector3<T>			m_Up;	
	float				m_UpRange;
	Vector3<T>			m_Right;
	Vector3<T>			m_Center;
};


}; };

#endif
