/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_DIRECTIONCONECONSTRAINT_H
#define __GEOMETRY_DIRECTIONCONECONSTRAINT_H

#include "math.vector3.h"
#include "geometry.transformconstraints.h"

namespace magnum { namespace geometry {
using magnum::math::Vector3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class DirectionConeConstraint3 : public TransformConstraint<T,3> {
public:
	inline DirectionConeConstraint3();

	void				setDirection(const Vector3<T>& );
	void				setDirection(const Vector3<T>& ,float );
	inline const Vector3<T>& getDirection() const;
	inline float		getDirectionRange() const;
	
	void				setUp(const Vector3<T>& );
	void				setUp(const Vector3<T>& ,float );
	inline const Vector3<T>& getUp() const;
	inline float		getUpRange() const;

    inline void			setCenter(const Vector3<T>& );
    inline const Vector3<T>& getCenter() const;

protected:
	virtual bool		onConstrain(Transform<T,3>& );

private:
	Vector3<T>			m_Center;	
	Vector3<T>			m_Dir;
	float				m_DirRange;
	Vector3<T>			m_Up;	
	float				m_UpRange;
};

}; };

#endif
