/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_INTERSECTION_H
#define __GEOMETRY_INTERSECTION_H

#include "math.vector.h"

namespace magnum { namespace geometry {
using magnum::math::Vector;

/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> class Intersection {
public:
	inline Intersection();
	inline Intersection(const Vector<T,dim>& );
	inline Intersection(const Vector<T,dim>& ,const Vector<T,dim>& );
	
	inline void			setPosition(const Vector<T,dim>& );
	inline const Vector<T,dim>& getPosition() const;
	
	inline void			setNormal(const Vector<T,dim>& );
	inline const Vector<T,dim>& getNormal() const;	
	
	inline void			setParameter(const T& );
	inline const T&		getParameter() const;
	
private:
	Vector<T,dim>		m_Position;
	Vector<T,dim>		m_Normal;
	T					m_Parameter;
};

}; };

#endif
