/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_INTERSECTION_INL
#define __GEOMETRY_INTERSECTION_INL

namespace magnum { namespace geometry {

/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline Intersection<T,dim>::Intersection() {
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline Intersection<T,dim>::Intersection(const Vector<T,dim>& p)
	: m_Position(p) {
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline Intersection<T,dim>::Intersection(const Vector<T,dim>& p,const Vector<T,dim>& n) 
	: m_Position(p), m_Normal(n) {
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline void Intersection<T,dim>::setPosition(const Vector<T,dim>& p) {
	m_Position = p;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline const Vector<T,dim>& Intersection<T,dim>::getPosition() const {
	return m_Position;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline void Intersection<T,dim>::setNormal(const Vector<T,dim>& n) {
	m_Normal = n;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline const Vector<T,dim>& Intersection<T,dim>::getNormal() const {
	return m_Normal;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline void Intersection<T,dim>::setParameter(const T& t) {
	m_Parameter = t;
}


/*--------------------------------------------------------------------------*/
/**
 */
template<class T,int dim> 
inline const T& Intersection<T,dim>::getParameter() const {
	return m_Parameter;
}

}; };

#endif
