/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_NORMALGENERATOR_H
#define __GEOMETRY_NORMALGENERATOR_H

#include "geometry.attributegenerator.h"

namespace magnum { namespace geometry {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, class I> class NormalGenerator : public AttributeGenerator<T,I> {
//DeclareClass(NormalGenerator, AttributeGenerator);
public:
	NormalGenerator();
	
	inline unsigned int getNormalStride() const;
	inline Vector3<T>*	getNormals() const;
	inline void			setNormals(Vector3<T>* ,unsigned int = sizeof(Vector3<T>));
	
	void				generate();
	
protected:
	inline Vector3<T>&	getNormal(unsigned int );

private:
	Vector3<T>*			m_Normals;
	unsigned int		m_NormalStride;
};

}; };

#endif
