/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_PLANE_H
#define __GEOMETRY_PLANE_H

#include "math.vector.h"

namespace magnum { namespace geometry {
using magnum::math::Vector;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, int dim> class Plane {
private:
	Vector<T,dim>	m_Origin;
	Vector<T,dim>	m_Normal;
	T				m_OriginNormal;

public:
	inline Plane();
	inline Plane(const Vector<T,dim>& ,const Vector<T,dim>& );

	inline void		set(const Vector<T,dim>& ,const Vector<T,dim>& );

	inline void		setOrigin(const Vector<T,dim>& );
	inline Vector<T,dim> getOrigin() const;

	inline void		setNormal(const Vector<T,dim>& );
	inline Vector<T,dim> getNormal() const;
	
	inline T		getOffset() const;

	inline bool		isInside(const Vector<T,dim>& ) const; 
	inline T		getDistance2(const Vector<T,dim>& ) const;
	inline T		getDistance(const Vector<T,dim>& ) const;
};


}; };

#endif
