/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GEOMETRY_TRANSLATIONCONSTRAINTS_H
#define __GEOMETRY_TRANSLATIONCONSTRAINTS_H

#include "geometry.transformconstraints.h"

namespace magnum { namespace geometry {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T,int dim>
class TranslationConstraint : public TransformConstraint<T,dim> {
private:
	Vector<T,dim>		m_Min;
	Vector<T,dim>		m_Max;
	
public:
	inline TranslationConstraint();
	inline TranslationConstraint(const Vector<T,dim>& ,const Vector<T,dim>& );
	
	inline const Vector<T,dim>&	getMinimum() const;
	inline const Vector<T,dim>&	getMaximum() const;
	inline void					setMinimum(const Vector<T,dim>& );
	inline void					setMaximum(const Vector<T,dim>& );
	inline void					setRange(const Vector<T,dim>& ,const Vector<T,dim>& );
	
protected:
	bool						onConstrain(Transform<T,dim>& );	
};

}; };

#endif
