/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPH_EDGE_H
#define __GRAPH_EDGE_H

namespace magnum { namespace graph {

template<class N,class E> class Graph;
template<class N,class E> class Node;
template<class N,class E> class NodeIterator;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E> class Edge {
friend Graph<N,E>;
friend Node<N,E>;
friend NodeIterator<N,E>;
private:
	inline Edge();
	inline Edge(unsigned int s,unsigned int e);
	inline Edge(unsigned int s,unsigned int e,const E& elem);
	
public:
	inline unsigned int		getStart() const;
	inline unsigned int		getEnd() const;
	
	inline E*				operator->();
	inline const E*			operator->() const;
	inline E&				operator*();
	inline const E&			operator*() const;

	inline void				mark();
	inline void				unmark();
	inline bool				isMarked() const;

private:
	E						m_Edge;
	bool					m_Marker;
	unsigned int			m_Start;
	unsigned int			m_End;
	Edge*					m_Prev;
	Edge*					m_Next;
};

}; };

#endif