/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPH_EDGE_INL
#define __GRAPH_EDGE_INL

namespace magnum { namespace graph {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline Edge<N,E>::Edge() {
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline Edge<N,E>::Edge(unsigned int s,unsigned int e) {
	m_Start = s;
	m_End = e;
	m_Marker = false;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline Edge<N,E>::Edge(unsigned int s,unsigned int e,const E& elem) {
	m_Start = s;
	m_End = e;
	m_Edge = elem;
	m_Marker = false;
};



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline unsigned int Edge<N,E>::getStart() const {
	return m_Start;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline unsigned int Edge<N,E>::getEnd() const {
	return m_End;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline E* Edge<N,E>::operator->() {
	return &m_Edge;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline const E* Edge<N,E>::operator->() const {
	return &m_Edge;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline E& Edge<N,E>::operator*() {
	return m_Edge;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline const E& Edge<N,E>::operator*() const {
	return m_Edge;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline void Edge<N,E>::mark() {
	m_Marker = true;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline void Edge<N,E>::unmark() {
	m_Marker = false;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class N, class E>
inline bool Edge<N,E>::isMarked() const {
	return m_Marker;
};

}; };

#endif
