/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_BITMAP_H
#define __GRAPHICS_BITMAP_H

#include "graphics.image.h"

namespace magnum { namespace graphics {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Bitmap : public Image {
DeclareClass(Bitmap, Image);
private:
	Palette<byte>*			m_Palette;
	void*					m_Pixels;

public:
	Bitmap();
	Bitmap(Type type, const Dimension<int>& size);
	Bitmap(Type type, int w, int h);
	Bitmap(const Image* );
	Bitmap(const Image& );
    ~Bitmap();

protected:
	virtual void*			onLock();
	virtual void			onUnlock();
	virtual bool			onGetPalette(Palette<byte>* ) const;
	virtual bool			onSetPalette(const Palette<byte>&);
};


}; };

#endif
