/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_FILTER_RESAMPLE_H
#define __GRAPHICS_FILTER_RESAMPLE_H

#include "graphics.filter.h"
#include "graphics.dimension.h"


namespace magnum {namespace graphics {
using magnum::io::Filter;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FilterResample : public FilterImage {
DeclareClass(FilterResample, FilterImage);
public:
	enum Sampler {
		Point = 1,
		Linear = 2,
		Quadartic = 3
	};

private:
	Dimension<int>	m_Size;
	Sampler			m_Sampler;

public:
	inline FilterResample(const Dimension<int>& );

	inline Dimension<int>	getSize() const;
	inline int				getWidth() const;
	inline int				getHeight() const;
	inline void				setSize(const Dimension<int>& );
	inline void				setSize(int , int );

	inline Sampler			getSampler() const;
	inline void				setSampler(Sampler s);

protected:
	Image*				onProcess(const Image* );

private:
	static Image*		resize8(Image* ,int , int );
	static Image*		resize16(Image* ,int , int );
	static Image*		resize24(Image* ,int , int );
	static Image*		resize32(Image* ,int , int );

	static Image*		resample8(Image* ,int , int );
	static Image*		resample16(Image* ,int , int );
	static Image*		resample24(Image* ,int , int );
	static Image*		resample32(Image* ,int , int );
};


}; };

#endif
