/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_FILTER_RESIZE_H
#define __GRAPHICS_FILTER_RESIZE_H

#include "graphics.filter.h"
#include "graphics.dimension.h"


namespace magnum {namespace graphics {
using magnum::io::Filter;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FilterResize : public FilterImage {
DeclareClass(FilterResize, FilterImage);
private:
	Dimension<int>	m_Size;

public:
	inline FilterResize();
	inline FilterResize(int, int );
	inline FilterResize(const Dimension<int>& );

	inline Dimension<int>	getSize() const;
	inline int				getWidth() const;
	inline int				getHeight() const;
	inline void				setSize(const Dimension<int>& );
	inline void				setSize(int , int );

protected:
	Image*				onProcess(const Image* );

private:
	template<class T>
	static Image*		resize(Image* ,int , int );
};


}; };

#endif
