/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_FILTER_RESIZE_INL
#define __GRAPHICS_FILTER_RESIZE_INL


namespace magnum {namespace graphics {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FilterResize::FilterResize() {
	m_Size.setWidth(1);
	m_Size.setHeight(1);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FilterResize::FilterResize(int w, int h) {
	m_Size.setWidth(w);
	m_Size.setHeight(h);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FilterResize::FilterResize(const Dimension<int>& d) {
	m_Size = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> FilterResize::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int FilterResize::getWidth() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int FilterResize::getHeight() const {
	return m_Size.getHeight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FilterResize::setSize(const Dimension<int>& d) {
	m_Size = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FilterResize::setSize(int w, int h) {
	m_Size.setWidth(w);
	m_Size.setHeight(h);
}

}; };

#endif
