/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_FILTER_SHRINK_H
#define __GRAPHICS_FILTER_SHRINK_H

#include "graphics.filter.h"
#include "graphics.dimension.h"


namespace magnum {namespace graphics {
using magnum::io::Filter;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FilterShrink : public FilterImage {
DeclareClass(FilterShrink, FilterImage);
public:
	inline FilterShrink();

protected:
	Image*				onProcess(const Image* );

private:
	template<class T>
	static Image*		resize(Image* );

	static Image*		resample8(Image* );
	static Image*		resample16(Image* );
	static Image*		resample24(Image* );
	static Image*		resample32(Image* );
};


}; };

#endif
