/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_PALETTE_H
#define __GRAPHICS_PALETTE_H

#include "object.h"
#include "graphics.colour.h"

namespace magnum { namespace graphics {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Palette : public Object {
DeclareClass(Palette, Object);
protected:
	Colour<T> 	m_Colour[256];

public:
	Palette<T> 			operator+ (const Colour<T> &col) const;
	Palette<T> 			operator- (const Colour<T> &col) const;
	const Palette<T>&	operator+=(const Colour<T> &col);
	const Palette<T>&	operator-=(const Colour<T> &col);
	const Palette<T>&	operator= (const Palette<T> &);
	bool				operator==(const Palette<T> &) const;
	bool				operator!=(const Palette<T> &) const;

	inline void			setColours(const Palette<T>& ,int i=0,int count=256);
	inline void			setColour(const Colour<T>& ,int );
	inline Colour<T>	getColour(int ) const;

	inline	Colour<T>&	operator [](int );
	inline	Colour<T>	operator [](int ) const;
};

}; };
#endif
