/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_POLYGON_H
#define __GRAPHICS_POLYGON_H

#include "graphics.point.h"
#include "container.array.h"


namespace magnum { namespace graphics {
using magnum::object::Object;
using magnum::container::Array;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Polygon : public Object {
DeclareClass(Polygon, Object);
private:
	typedef Point<T>	V;
	Array<V>			m_Vertices;

public:
	inline void			addVertex(const Point<T>& v);
	inline void			removeVertex(const Point<T>& v);
	inline void			removeVertex(int );
	inline Point<T>		getVertex(int ) const;
	inline int			getSize() const;

	inline Point<T>&	operator[](int );
	inline Point<T>		operator[](int ) const;
};


}; };


#endif
