/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_TRANSLATOR_BMP_H
#define __GRAPHICS_TRANSLATOR_BMP_H

#include "graphics.image.h"
#include "io.translator.h"


namespace magnum { namespace graphics {
using magnum::object::Object;
using magnum::types::String;
using magnum::io::File;
using magnum::io::InputStream;
using magnum::io::OutputStream;
using magnum::io::Translator;
using magnum::types::byte;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class TranslatorBMP : public Translator<Image> {
DeclareClass(TranslatorBMP, Translator<Image>);
protected:
	Image*		onDecode(InputStream* ,size_t size = Autosize);
	size_t		onEncode(OutputStream* ,const Image* );
	bool		onIdentify(File* );

private:
	void		decodeRle4(Image* ,const byte* in );
	void		decodeRle8(Image* ,const byte* in );
	void		decodeRgb1(Image* ,const byte* in );
	void		decodeRgb4(Image* ,const byte* in );
	void		decodeRgb8(Image* ,const byte* in );
	void		decodeRgb16(Image* ,const byte* in );
	void		decodeRgb24(Image* ,const byte* in );
};


}; };

#endif
