/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS_TRANSLATOR_HDR_H
#define __GRAPHICS_TRANSLATOR_HDR_H

#include "graphics.image.h"
#include "io.translator.h"


namespace magnum { namespace graphics {
using magnum::object::Object;
using magnum::types::String;
using magnum::io::File;
using magnum::io::InputStream;
using magnum::io::OutputStream;
using magnum::io::Translator;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class TranslatorHDR : public Translator<Image> {
DeclareClass(TranslatorHDR, Translator<Image>);
protected:
	Image*			onDecode(InputStream* ,size_t size = Autosize);
	size_t			onEncode(OutputStream* ,const Image* );
	bool			onIdentify(File* );
	
private:
	void			readHeader();
	void			readPixels(float* ,unsigned int );
	void			readPixelsRLE(float* );

private:
	enum {
		RGBE_VALID_PROGRAMTYPE = 0x01,
		RGBE_VALID_GAMMA       = 0x02,
		RGBE_VALID_EXPOSURE    = 0x04
	};

	InputStream*	m_Input;
	size_t			m_Size;
	unsigned int	m_Width;
	unsigned int	m_Height;
	String			m_ProgramType;
	float			m_Gamma;
	float			m_Exposure;
	unsigned int	m_Valid;
	byte*			m_Buffer;
};


}; };

#endif
