/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_ACCELERATOR_INL
#define __GRAPHICS3D_ACCELERATOR_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Context* Accelerator::getContext() const {
	return m_Context;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::select(const Camera* cam) {
	cam->select();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::select(const Appearance* app) {
	app->select();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::deselectAppearance() {
	Appearance::selectDefault();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::select(const Shader* sh) {
	sh->select();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::deselectShader() {
	Shader::selectNone();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::select(const Texture* tex,unsigned int i) {
	tex->select(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::deselectTexture(unsigned int i) {
	Texture::selectNone(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::select(const Material* mat) {
	mat->select();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::deselectMaterial() {
	Material::selectDefault();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::select(const Light* lgt,unsigned int i) {
	lgt->select(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::deselectLight(unsigned int i) {
	Light::selectNone(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::select(FrameBuffer* fb) {
	fb->select();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::deselectFrameBuffer() {
	FrameBuffer::selectDefault();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Accelerator::render(const Model* mdl,const ParameterBuffer* p) {
	mdl->render(p);
}

}; };

#endif
