/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_AMBIENTLIGHT_INL
#define __GRAPHICS3D_AMBIENTLIGHT_INL


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline AmbientLight::AmbientLight() {
	m_Ambient = Colour<float>(0.2f,0.2f,0.2f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& AmbientLight::getAmbient() const {
	return m_Ambient;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void AmbientLight::setAmbient(const Colour<float>& c) {
	m_Ambient = c;
}



}; };

#endif
