/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_BACKGROUNDLAYER_H
#define __GRAPHICS3D_BACKGROUNDLAYER_H

#include "graphics.colour.h"
#include "graphics3d.layer.h"
#include "graphics3d.context.h"

namespace magnum { namespace graphics3d {
using magnum::graphics::Colour;

/*--------------------------------------------------------------------------*/
/**
 */
class BackgroundLayer : public Layer {
DeclareClass(BackgroundLayer, Layer);
public:
	typedef Context::ClearFlag	ClearFlag;
	
public:
	BackgroundLayer();
	
	inline void			setDepthClear(bool );
	inline bool			getDepthClear() const;
	inline void			setDepthValue(float );
	inline float		getDepthValue() const;
	
	inline void			setStencilClear(bool );
	inline bool			getStencilClear() const;
	inline void			setStencilValue(unsigned int );
	inline unsigned int	getStencilValue() const;

	inline void			setAccumClear(bool );
	inline bool			getAccumClear() const;
	inline void			setAccumValue(const Colour<float>& );
	inline const Colour<float>& getAccumValue() const;

protected:
	virtual void		onRender();	
	
	inline unsigned int	getClearFlags() const;
	inline void			setClearFlags(unsigned int );
	inline void			setClearFlag(ClearFlag );
	inline void			resetClearFlag(ClearFlag );
	
private:
	unsigned int		m_ClearFlags;
	float				m_DepthValue;
	unsigned int		m_StencilValue;
	Colour<float>		m_AccumValue;
};

}; };

#endif
