/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_BACKGROUNDLAYER_INL
#define __GRAPHICS3D_BACKGROUNDLAYER_INL

namespace magnum { namespace graphics3d {

/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setDepthClear(bool b) {
	if (b)
		m_ClearFlags |= Context::ClearDepth;
	else
		m_ClearFlags &= ~Context::ClearDepth;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool BackgroundLayer::getDepthClear() const {
	return ((m_ClearFlags & Context::ClearDepth) != 0);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setDepthValue(float v) {
	m_DepthValue = v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline float BackgroundLayer::getDepthValue() const {
	return m_DepthValue;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setStencilClear(bool b) {
	if (b)
		m_ClearFlags |= Context::ClearStencil;
	else
		m_ClearFlags &= ~Context::ClearStencil;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool BackgroundLayer::getStencilClear() const {
	return ((m_ClearFlags & Context::ClearStencil) != 0);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setStencilValue(unsigned int i) {
	m_StencilValue = i;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int BackgroundLayer::getStencilValue() const {
	return m_StencilValue;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setAccumClear(bool b) {
	if (b)
		m_ClearFlags |= Context::ClearAccum;
	else
		m_ClearFlags &= ~Context::ClearAccum;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool BackgroundLayer::getAccumClear() const {
	return ((m_ClearFlags & Context::ClearAccum) != 0);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setAccumValue(const Colour<float>& c) {
	m_AccumValue = c;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Colour<float>& BackgroundLayer::getAccumValue() const {
	return m_AccumValue;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int	BackgroundLayer::getClearFlags() const {
	return m_ClearFlags;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setClearFlags(unsigned int c) {
	m_ClearFlags = c;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::setClearFlag(ClearFlag c) {
	m_ClearFlags |= c;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void BackgroundLayer::resetClearFlag(ClearFlag c) {
	m_ClearFlags &= ~c;
}

}; };

#endif
