/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_FRAMEANIMATION_INL
#define __GRAPHICS3D_FRAMEANIMATION_INL

namespace magnum { namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneAnimation::BoneAnimation(Skeleton* s) {
	m_Skeleton = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneAnimation::BoneAnimation(Skeleton* s,const char* n) : Animation(n), m_Skeleton(s) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Skeleton* BoneAnimation::getSkeleton() const {
	return m_Skeleton;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneAnimation::insert(const Frame& f) {
	m_Frames.insert(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneAnimation::remove(const Frame& f) {
	remove(f.getTime());
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneAnimation::remove(const Iterator& i) {
	m_Frames.remove(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int BoneAnimation::getSize() const {
	return m_Frames.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const BoneAnimation::Frame& BoneAnimation::operator[](unsigned int i) const {
	return m_Frames[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneAnimation::Frame& BoneAnimation::operator[](unsigned int i) {
	return m_Frames[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneAnimation::Iterator	BoneAnimation::begin() const {
	return m_Frames.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneAnimation::Iterator	BoneAnimation::at(unsigned int f) const {
	return m_Frames.at(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneAnimation::Iterator BoneAnimation::end() const {
	return m_Frames.end();
}

}; };

#endif
