/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_BONEMODEL_INL
#define __GRAPHICS3D_BONEMODEL_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneModel::BoneModel() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BoneModel::~BoneModel() {
	clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::insertMesh(Mesh* m) {
	publishMesh(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::removeMesh(Mesh* m) {
	unpublishMesh(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::insertAnimation(BoneAnimation* m) {
	publishAnimation(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::removeAnimation(BoneAnimation* m) {
	unpublishAnimation(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::attachSkeleton(Skeleton* s) {
	ASSERT(s != NULL);
	m_Skeleton = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::detachSkeleton() {
	m_Skeleton.setNull();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Skeleton* BoneModel::getSkeleton() const {
	return m_Skeleton;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::attachWeightBuffer(WeightBuffer* s) {
	ASSERT(s != NULL);
	m_Weights = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BoneModel::detachWeightBuffer() {
	m_Weights.setNull();
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline WeightBuffer* BoneModel::getWeightBuffer() const {
	return m_Weights;
}

}; };

#endif
