/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_CAPABILITIES_H
#define __GRAPHICS3D_CAPABILITIES_H

#include "graphics.dimension.h"
#include "graphics3d.texture.h"

namespace magnum { namespace graphics3d {
using magnum::graphics::Dimension;

class Context;
class Texture1D;
class Texture2D;
class Texture3D;
class DepthTexture;
class CubeTexture;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Capabilities : public Object, private magnum::object::Noncopyable {
friend Context;
private:
	Capabilities();
	
public:
	inline int			getMaxTextures() const;
	inline unsigned int	getTexture1DMaxSize() const;
	inline unsigned int	getTexture1DMinSize() const;
	inline const Dimension<int>& getTexture2DMaxSize() const;
	inline const Dimension<int>& getTexture2DMinSize() const;

private:
	unsigned int		m_MaxTexture1DSize;
	unsigned int		m_MinTexture1DSize;
	Dimension<int>		m_MaxTexture2DSize;
	Dimension<int>		m_MinTexture2DSize;
	int					m_MaxTextures;
};

}; };

#endif