/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_PLAINMATERIAL_H
#define __GRAPHICS3D_PLAINMATERIAL_H

#include "graphics.colour.h"
#include "graphics3d.material.h"


namespace magnum { namespace graphics3d {
using magnum::graphics::Colour;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ColourMaterial : public Material {
DeclareClass(ColourMaterial, Material);
private:
	Colour<float>		m_Ambient;
	Colour<float>		m_Diffuse;
	Colour<float>		m_Specular;
	Colour<float>		m_Emission;
	float				m_Shininess;

public:
	ColourMaterial();

	inline Colour<float> getAmbient() const;
	inline void			setAmbient(const Colour<float>& );
	inline Colour<float> getDiffuse() const;
	inline void			setDiffuse(const Colour<float>& );
	inline Colour<float> getSpecular() const;
	inline void			setSpecular(const Colour<float>& );
	inline Colour<float> getEmission() const;
	inline void			setEmission(const Colour<float>& );
	inline float		getShininess() const;
	inline void			setShininess(float );

protected:
	virtual void		onSelect() const;
	virtual bool		onCompileSelect(Assembler& ) const;

	inline void			selectAmbient() const;
	inline void			selectDiffuse() const;
	inline void			selectSpecular() const;
	inline void			selectEmission() const;
	inline void			selectShininess() const;
};


}; };

#endif