/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_CUBETEXTURE_INL
#define __GRAPHICS3D_CUBETEXTURE_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> CubeTexture::getMinSize() {
	return Context::getCurrent()->getCapabilities()->getTexture2DMinSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> CubeTexture::getMaxSize() {
	return Context::getCurrent()->getCapabilities()->getTexture2DMaxSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> CubeTexture::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int CubeTexture::getWidth() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int CubeTexture::getHeight() const {
	return m_Size.getHeight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int CubeTexture::getLevels() const {
	return m_Levels;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool CubeTexture::isLocked() const {
	return m_Locked;
}


}; };

#endif
