/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_DEFEREDMESH_INL
#define __GRAPHICS3D_DEFEREDMESH_INL

namespace magnum { namespace graphics3d {

/*--------------------------------------------------------------------------*/
/**
 */
inline const Mesh* DeferedMesh::getMesh() const {
	return m_Mesh;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const BlendMode* DeferedMesh::getBlendMode() const {
	return m_BlendMode;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const PolygonMode* DeferedMesh::getPolygoneMode() const {	
	return m_PolygonMode;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const StencilMode* DeferedMesh::getStencilMode() const {
	return m_StencilMode;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const DepthMode* DeferedMesh::getDepthMode() const {
	return m_DepthMode;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Shader* DeferedMesh::getShader() const {
	return m_Shader;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Material* DeferedMesh::getMaterial() const {
	return m_Material;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Texture* DeferedMesh::getTexture(unsigned int i) const {
	ASSERT(i < Texture::MaxTextures);
	return m_Texture[i];
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Bounds3<float>& DeferedMesh::getBounds() const {
	return m_Bounds;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Matrix4<float>& DeferedMesh::getMatrix() const {
	return m_ModelView;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline float DeferedMesh::getKey() const {
	return m_Key;
}

}; };

#endif
