/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_FRAMEANIMATION_H
#define __GRAPHICS3D_FRAMEANIMATION_H

#include "container.array.h"
#include "graphics3d.animation.h"
#include "graphics3d.keyframe.h"

namespace magnum { namespace graphics3d {
using magnum::container::Array;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FrameAnimation : public Animation {
DeclareClass(FrameAnimation, Animation);
public:
	typedef Keyframe<unsigned int>	Frame;
	typedef Array<Frame>::Iterator	Iterator;
	
public:
	inline FrameAnimation();
	inline explicit FrameAnimation(const char* );
	
	inline void			insert(float ,unsigned int );
	inline void			insert(const Frame& );
	inline void			remove(const Iterator& );
	inline void			remove(const Frame& );
	void				remove(float );
	
	inline unsigned int getSize() const;
	inline const Frame& operator[](unsigned int ) const;
	inline Frame&		operator[](unsigned int );
	
	void				clear();
	void				finish();
	
	inline Iterator		begin() const;
	inline Iterator		at(unsigned int ) const;
	inline Iterator 	end() const;
	
protected:
	virtual void		onAnimate(float t,void* ) const;

private:	
	Array<Frame>		m_Frames;
};

}; };

#endif
