/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_FRAMEANIMATION_INL
#define __GRAPHICS3D_FRAMEANIMATION_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameAnimation::FrameAnimation() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameAnimation::FrameAnimation(const char* n) : Animation(n) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FrameAnimation::insert(float t,unsigned int k) {
	m_Frames.insert(Frame(t,k));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FrameAnimation::insert(const Frame& f) {
	m_Frames.insert(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FrameAnimation::remove(const Frame& f) {
	remove(f.getTime());
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FrameAnimation::remove(const Iterator& i) {
	m_Frames.remove(i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int FrameAnimation::getSize() const {
	return m_Frames.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const FrameAnimation::Frame& FrameAnimation::operator[](unsigned int i) const {
	return m_Frames[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameAnimation::Frame& FrameAnimation::operator[](unsigned int i) {
	return m_Frames[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameAnimation::Iterator	FrameAnimation::begin() const {
	return m_Frames.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameAnimation::Iterator	FrameAnimation::at(unsigned int f) const {
	return m_Frames.at(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameAnimation::Iterator FrameAnimation::end() const {
	return m_Frames.end();
}

}; };

#endif
