/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_FRAMEBUFFER_INL
#define __GRAPHICS3D_FRAMEBUFFER_INL

#include "graphics3d.context.h"

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameBuffer* FrameBuffer::getDefault() {
	return &getContext()->m_DefaultFrameBuffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> FrameBuffer::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int FrameBuffer::getWidth() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int FrameBuffer::getHeight() const {
	return m_Size.getHeight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameBuffer::Iterator FrameBuffer::begin() const {
	return m_Bindings.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameBuffer::Iterator FrameBuffer::end() const {
	return m_Bindings.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameBuffer::Binding::Binding() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameBuffer::Binding::Binding(RenderTarget* rt,RenderTarget::Attachment att) {
	m_Target = rt;
	m_Attachment = att;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline RenderTarget* FrameBuffer::Binding::getTarget() const {
	return m_Target;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline RenderTarget::Attachment FrameBuffer::Binding::getAttachment() const {
	return m_Attachment;
}

}; };

#endif
