/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_INTERSECTION_H
#define __GRAPHICS3D_INTERSECTION_H

#include "geometry.intersection.h"

namespace magnum { namespace graphics3d {

class Model;

/*--------------------------------------------------------------------------*/
/**
 */
class Intersection : public magnum::geometry::Intersection<float,3> {
public:
	inline Intersection();
	
	inline void			setModel(const Model* );
	inline const Model*	getModel() const;
	
	inline void			setMesh(const Mesh* );
	inline const Mesh*	getMesh() const;
	
private:
	const Model*		m_Model;
	const Mesh*			m_Mesh;
};

}; };

#endif
