/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_JOINT_H
#define __GRAPHICS3D_JOINT_H

#include "container.list.h"

namespace magnum { namespace graphics3d {
using magnum::container::List;
using magnum::container::ListAllocator;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Joint {
public:
	typedef intptr_t	Handle;
	
public:
	inline Joint();
	inline Joint(const char* name, Handle );

	inline const char*	getName() const;
	inline Handle		getHandle() const;

private:
	char				m_Name[64];
	Handle				m_Handle;
};

typedef List<Joint,ListAllocator<Joint,8> > JointList;

}; };

#endif
