/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_LAYERGROUP_H
#define __GRAPHICS3D_LAYERGROUP_H

#include "container.chain.h"
#include "graphics3d.resource.h"

namespace magnum { namespace graphics3d {
using magnum::container::Chain;

class Layer;

/*--------------------------------------------------------------------------*/
/**
 */
class LayerGroup : public Resource {
DeclareClass(LayerGroup, Resource);
public:
	typedef Chain<Layer>::Iterator	Iterator;
	
public:
	inline void			render();
	
	inline void			insertFirst(Layer* );
	inline void			insertLast(Layer* );
	inline void			insertBefore(Layer* ,const Layer* );
	inline void			insertAfter(Layer* ,const Layer* );
	inline void			remove(Layer* );
	inline void			clear();
	
	inline unsigned int	getSize() const;
	inline Iterator		begin() const;
	inline Iterator		end() const;
	
protected:
	virtual void		onRender();
	
private:
	Chain<Layer>		m_Layers;
};

}; };

#endif
