/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_LAYERGROUP_INL
#define __GRAPHICS3D_LAYERGROUP_INL

#include "graphics3d.layer.h"

namespace magnum { namespace graphics3d {

/*--------------------------------------------------------------------------*/
/**
 */
inline void LayerGroup::render() {
	onRender();
}

/*--------------------------------------------------------------------------*/
/**
 */
inline void LayerGroup::insertFirst(Layer* l) {
	m_Layers.insertFirst(l);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void LayerGroup::insertLast(Layer* l) {
	m_Layers.insert(l);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void LayerGroup::insertBefore(Layer* l,const Layer* p) {
	m_Layers.insertBefore(l,p);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void LayerGroup::insertAfter(Layer* l,const Layer* p) {
	m_Layers.insertAfter(l,p);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void LayerGroup::remove(Layer* l) {
	m_Layers.remove(l);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void LayerGroup::clear() {
	m_Layers.clear();
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int	LayerGroup::getSize() const {
	return m_Layers.getSize();
}


/*--------------------------------------------------------------------------*/
/**
 */
inline LayerGroup::Iterator LayerGroup::begin() const {
	return m_Layers.begin();
}


/*--------------------------------------------------------------------------*/
/**
 */
inline LayerGroup::Iterator LayerGroup::end() const {
	return m_Layers.end();
}
	
}; };

#endif
