/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_LIGHT_H
#define __GRAPHICS3D_LIGHT_H

#include "graphics3d.resource.h"

namespace magnum { namespace graphics3d {

class LightStack;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Light : public Resource {
DeclareClass(Light, Resource);
public:
	enum {
		MaxLights = 8,
	};

protected:
	inline Light();

public:
	~Light();

	inline void			select(unsigned int i = 0) const;
	inline void			forceSelect(unsigned int i = 0) const;
	inline void			deselect(unsigned int i = 0) const;
	static inline void	selectNone(unsigned int i = 0);

protected:
	virtual void		onSelect(unsigned int i = 0) const = 0;
};

}; };

#endif
