/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_LIGHT_INL
#define __GRAPHICS3D_LIGHT_INL


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Light::Light() {
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Light::select(unsigned int i) const {
	ASSERT(i < Light::MaxLights);
	LightStack* ls = getContext()->getLightStack();
	if (ls->m_Light[i] == NULL)
		glEnable(GL_LIGHT0 + i);
	ls->m_Light[i] = this;
	onSelect();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Light::deselect(unsigned int i) const {
	ASSERT(i < Light::MaxLights);
	LightStack* ls = getContext()->getLightStack();
	if (ls->m_Light[i] != this)
		return;
	ls->m_Light[i] = NULL;
	glDisable(GL_LIGHT0 + i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Light::forceSelect(unsigned int i) const {
	ASSERT(i < Light::MaxLights);
	LightStack* ls = getContext()->getLightStack();
	ls->m_Light[i] = this;
	glEnable(GL_LIGHT0 + i);
	onSelect();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Light::selectNone(unsigned int i) {
	ASSERT(i < Light::MaxLights);
	LightStack* ls = getContext()->getLightStack();
	ls->m_Light[i] = NULL;
	glDisable(GL_LIGHT0 + i);
}

}; };

#endif

