/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_MATERIAL_H
#define __GRAPHICS3D_MATERIAL_H

#include "system.assembler.h"
#include "graphics3d.resource.h"


namespace magnum { namespace graphics3d {
using magnum::system::Assembler;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Material : public Resource {
DeclareClass(Material, Resource);
protected:
	inline				Material();

public:
	~Material();

	inline void			select() const;
	inline void			deselect() const;
	inline void			forceSelect() const;
	static inline void	selectNone();
	static inline void	selectDefault();
	static inline Material* getDefault();

	void				compileSelect(Assembler& ) const;
	void				compileDeselect(Assembler& ) const;

protected:
	virtual void		onSelect() const;
	virtual bool		onCompileSelect(Assembler& ) const;
};


}; };

#endif
