/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_MESHSPLITTER_H
#define __GRAPHICS3D_MESHSPLITTER_H

#include "graphics3d.mesh.h"

namespace magnum { namespace graphics3d {

class IndexMesh;
class VertexMesh;
class VertexBuffer;
class IndexBuffer;
class VertexFormat;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MeshSplitter : public Object, private magnum::object::Noncopyable {
DeclareClass(MeshSplitter, Object);
public:
	MeshSplitter();

	inline void			setVertexSize(unsigned int );
	inline unsigned int	getVertexSize() const;

	inline void			setIndexSize(unsigned int );
	inline unsigned int	getIndexSize() const;
	
	MeshList			split(const Mesh* );
	MeshList			split(const IndexMesh* );
	MeshList			split(const VertexMesh* );

private:
	VertexMesh*			cloneMesh(const VertexMesh* );
	IndexMesh*			cloneMesh(const IndexMesh* );
	void				copyVertexBuffer(VertexMesh* ,const VertexMesh* ,unsigned int , unsigned int );
	unsigned int		copyIndexBuffer(IndexMesh* ,const IndexMesh* ,unsigned int , unsigned int );
	template<class T>
	unsigned int		copyIndexBufferT(IndexMesh* ,const IndexMesh* ,unsigned int , unsigned int );
	
private:
	unsigned int		m_VertexSize;
	unsigned int		m_IndexSize;
};

}; };

#endif
