/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_ORTHOCAMERA_H
#define __GRAPHICS3D_ORTHOCAMERA_H

#include "graphics.rectangle.h"
#include "graphics3d.camera.h"


namespace magnum { namespace graphics3d {
using magnum::graphics::Rectangle;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class OrthoCamera : public Camera {
DeclareClass(OrthoCamera, Camera);
public:
	inline OrthoCamera();

	inline void			setViewWindow(const Rectangle<float>& );
	inline const Rectangle<float>& getViewWindow() const;

protected:
	virtual void		onSelect() const;
	virtual Ray<float,3> onCreateRay(float ,float ) const;

private:
	float				m_NearPlane;
	float				m_FarPlane;
	Rectangle<float>	m_ViewWindow;
};

}; };

#endif
