/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_PERSPECTIVECAMERA_H
#define __GRAPHICS3D_PERSPECTIVECAMERA_H

#include "math.matrix.h"
#include "graphics.rectangle.h"
#include "graphics3d.camera.h"


namespace magnum { namespace graphics3d {
using magnum::graphics::Rectangle;
using magnum::math::Matrix;
using magnum::math::Matrix3;
using magnum::math::Matrix4;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class PerspectiveCamera : public Camera {
DeclareClass(PerspectiveCamera, Camera);
public:
	inline PerspectiveCamera();

	inline void			setViewWindow(const Rectangle<float>& );
	inline const Rectangle<float>& getViewWindow() const;

	inline void			setTransform(const Matrix4<float>& );
	inline void			setTransform(const Matrix3<float>& );
	inline void			setPosition(const Vector3<float>& );

protected:
	virtual void		onSelect() const;
	virtual Ray<float,3> onCreateRay(float ,float ) const;

private:
	float				m_NearPlane;
	float				m_FarPlane;
	Rectangle<float>	m_ViewWindow;
	Matrix4<float>		m_Matrix;
};

}; };

#endif
