/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_PERSPECTIVECAMERA_INL
#define __GRAPHICS3D_PERSPECTIVECAMERA_INL


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline PerspectiveCamera::PerspectiveCamera() {
	m_Matrix.identity();
	m_ViewWindow = Rectangle<float>(-10,-10,20,20);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	PerspectiveCamera::setViewWindow(const Rectangle<float>& r) {
	m_ViewWindow = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Rectangle<float>& PerspectiveCamera::getViewWindow() const {
	return m_ViewWindow;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	PerspectiveCamera::setTransform(const Matrix4<float>& r) {
	m_Matrix = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	PerspectiveCamera::setTransform(const Matrix3<float>& r) {
	for (int i = 0; i < 3; i++)
		for (int j = 0; j < 3; j++)
			m_Matrix[i][j] = r[i][j];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	PerspectiveCamera::setPosition(const Vector3<float>& p) {
	m_Matrix[0][3] = p.x;
	m_Matrix[1][3] = p.y;
	m_Matrix[2][3] = p.z;
}

}; };

#endif
