/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_POINTLIGHT_H
#define __GRAPHICS3D_POINTLIGHT_H

#include "math.vector3.h"
#include "graphics.colour.h"
#include "graphics3d.light.h"


namespace magnum { namespace graphics3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::graphics::Colour;
using magnum::math::Vector3;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class PointLight : public Light {
DeclareClass(PointLight, Light);
protected:
	Colour<float>				m_Ambient;
	Colour<float>				m_Diffuse;
	Colour<float>				m_Specular;
	Vector3<float>				m_Position;
	Vector3<float>				m_Attenuation;

public:
	inline PointLight();

	inline const Colour<float>& getAmbient() const;
	inline void 				setAmbient(const Colour<float>& );
	inline const Colour<float>& getDiffuse() const;
	inline void					setDiffuse(const Colour<float>& );
	inline const Colour<float>& getSpecular() const;
	inline void					setSpecular(const Colour<float>& );

	inline const Vector3<float>& getPosition() const;
	inline void					setPosition(const Vector3<float>& );

	inline const Vector3<float>& getAttenuation() const;
	inline void					setAttenuation(const Vector3<float>& );

protected:
	virtual void				onSelect(unsigned int i) const;
};

}; };

#endif
