/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_PROGRAMSHADER_INL
#define __GRAPHICS3D_PROGRAMSHADER_INL

namespace magnum { namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ProgrammableShader::contains(ShaderProgram* s) const {
	return m_Programs.contains(s);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ProgrammableShader::Iterator ProgrammableShader::begin() const {
	return m_Programs.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ProgrammableShader::Iterator ProgrammableShader::end() const {
	return m_Programs.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ProgrammableShader::getSize() const {
	return m_Programs.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ProgrammableShader::isEmpty() const {
	return m_Programs.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ProgrammableShader::isLinked() const {
	GLint val;
	glGetProgramiv(m_OglProgramHandle, GL_LINK_STATUS, &val);
	return (val == GL_TRUE);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String ProgrammableShader::getLog() const {
	char buffer[1024];
	buffer[0] = 0;
	glGetProgramInfoLog(m_OglProgramHandle, 1024, NULL, buffer);
	return String(buffer);
}

}; };

#endif
