/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_RENDERSTREAM_H
#define __GRAPHICS3D_RENDERSTREAM_H

#include "graphics3d.mesh.h"
#include "container.array.h"
#include "object.pointer.h"
#include "system.program.h"

namespace magnum {namespace graphics3d {
using magnum::container::Array;
using magnum::object::Pointer;
using magnum::system::Program;

class Compiler;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class RenderStream : public Resource {
DeclareClass(RenderStream, Resource);
friend Compiler;
private:
	typedef Pointer<Resource> ResPtr;

	Array<ResPtr>		m_Resources;
	Program*			m_Program;
   
public:
	RenderStream();
	~RenderStream();

    inline void			execute() const;
	void				clear();

private:
    static void			onRenderVertices(Mesh::Primitive ,unsigned int ,unsigned int );
    static void			onRenderIndices(Mesh::Primitive ,unsigned int ,unsigned int );
};


}; };

#endif
