/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_RENDERTARGET_INL
#define __GRAPHICS3D_RENDERTARGET_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> RenderTarget::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int RenderTarget::getWidth() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int RenderTarget::getHeight() const {
	return m_Size.getHeight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline RenderTarget::Type RenderTarget::getType() const {
	return m_Type;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool RenderTarget::isBuffer() const {
	return (m_OglRenderbuffer != 0);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool RenderTarget::isTexture() const {
	return (m_Texture != NULL);
}

}; };

#endif
