/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_RESOURCE_INL
#define __GRAPHICS3D_RESOURCE_INL

#include "graphics3d.context.h"

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Resource::Resource() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Resource::Resource(const char* name) : m_Name(name) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Resource::getName() const {
	return m_Name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Resource::setName(const char* name) {
	m_Name = name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Context* Resource::getContext() {
#if defined(__NATIVETLS__)
	Context* c = Context::g_Current;
#else
	Context* c = (Context *)Thread::getTLS(Context::g_Current);
#endif
	if(c != NULL) {
		ASSERT(c->m_OglContext == wglGetCurrentContext());
	}
	return c;
}


}; };

#endif
