/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_SHADERPROGRAM_H
#define __GRAPHICS3D_SHADERPROGRAM_H

#include "graphics3d.context.h"

namespace magnum { namespace graphics3d {

class ProgrammableShader;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ShaderProgram : public Resource, private magnum::object::Noncopyable {
DeclareClass(ShaderProgram, Resource);
friend ProgrammableShader;
private:
	unsigned int		m_OglShaderHandle;

protected:
	inline ShaderProgram(unsigned int handle);
	inline ~ShaderProgram();

public:
	void				setSource(const char* );
	String				getSource() const;
	
	void				compile();
	inline bool			isCompiled() const;

    inline String		getLog() const;

protected:
	virtual void		onSelect();
	virtual void		onDeselect();
};

}; };

#endif
