/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_SHADERPROGRAM_INL
#define __GRAPHICS3D_SHADERPROGRAM_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ShaderProgram::ShaderProgram(unsigned int handle) {
	ASSERT(handle != 0);
	m_OglShaderHandle = handle;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ShaderProgram::~ShaderProgram() {
	if (m_OglShaderHandle != 0)
		glDeleteShader(m_OglShaderHandle);
	m_OglShaderHandle = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ShaderProgram::isCompiled() const {
	GLint val;
	glGetShaderiv(m_OglShaderHandle, GL_COMPILE_STATUS, &val);
	return (val == GL_TRUE);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String ShaderProgram::getLog() const {
	char buffer[1024];
	buffer[0] = 0;
	glGetShaderInfoLog(m_OglShaderHandle, 1024, NULL, buffer);
	return String(buffer);
}


}; };

#endif
