/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_SKELETON_INL
#define __GRAPHICS3D_SKELETON_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Bone::setName(const char* n) {
	strncpy(m_Name, n, sizeof(m_Name));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Bone::getName() const {
	return String(m_Name);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Bone::setTorsoWeight(float w) {
	m_TorsoWeight = w;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Bone::getTorsoWeight() const {
	return m_TorsoWeight;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Bone::setDistance(float d) {
	m_Distance = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Bone::getDistance() const {
	return m_Distance;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Bone::setIndex(unsigned int d) {
	m_Index = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Bone::getIndex() const {
	return m_Index;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Bone* Bone::getParent() const {
	return m_Parent;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Skeleton* Bone::getSkeleton() const {
	return m_Skeleton;
}







/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Skeleton::Skeleton() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Skeleton::Skeleton(const char* n) : m_Name(n) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Skeleton::setName(const char* n) {
	m_Name = n;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Skeleton::getName() const {
	return m_Name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Skeleton::getSize() const {
	return m_Bones.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Skeleton::Iterator Skeleton::begin() const {
	return m_Bones.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Skeleton::Iterator Skeleton::end() const {
	return m_Bones.end();
}

}; };

#endif
