/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_SOLIDBACKGROUND_INL
#define __GRAPHICS3D_SOLIDBACKGROUND_INL

namespace magnum { namespace graphics3d {

/*--------------------------------------------------------------------------*/
/**
 */
inline void SolidBackground::setColourClear(bool c) {
	if (c)
		setClearFlag(Context::ClearColour);
	else
		resetClearFlag(Context::ClearColour);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool SolidBackground::getColourClear() {
	return ((getClearFlags() & Context::ClearColour) != 0);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void SolidBackground::setColourValue(const Colour<float>& c) {
	m_ColourValue = c;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Colour<float>& SolidBackground::getColourValue() const {
	return m_ColourValue;
}

}; };

#endif
