/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_SPOTLIGHT_H
#define __GRAPHICS3D_SPOTLIGHT_H

#include "graphics3d.pointlight.h"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SpotLight : public PointLight {
DeclareClass(SpotLight, PointLight);
protected:
	float						m_Cutoff;
	float						m_Exponent;
	Vector3<float>				m_Direction;

public:
	inline SpotLight();

	inline void					setCutoff(float );
	inline float				getCutoff() const;
	inline void					setDirection(const Vector3<float>& );
	inline const Vector3<float>& getDirection() const;
	inline void					setExponent(float );
	inline float				getExponent() const;
	
protected:
	virtual void				onSelect(unsigned int i) const;
};		

}; };

#endif
