/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_SPOTLIGHT_INL
#define __GRAPHICS3D_SPOTLIGHT_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline SpotLight::SpotLight() {
	m_Direction = Vector3<float>(0.0f, 0.0f, 0.0f);
	m_Cutoff = 1.0f;
	m_Exponent = 0.1f;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	SpotLight::setCutoff(float f) {
	m_Cutoff = f;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float SpotLight::getCutoff() const {
	return m_Cutoff;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SpotLight::setDirection(const Vector3<float>& d) {
	m_Direction = d;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& SpotLight::getDirection() const {
	return m_Direction;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SpotLight::setExponent(float e) {
	m_Exponent = e;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float SpotLight::getExponent() const {
	return m_Exponent;
}


}; };

#endif
