/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_STATICMODEL_H
#define __GRAPHICS3D_STATICMODEL_H

#include "graphics3d.model.h"
#include "graphics3d.mesh.h"
#include "graphics3d.renderstream.h"
#include "object.pointer.h"


namespace magnum { namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StaticModel : public Model {
DeclareClass(StaticModel, Model);
public:
	inline StaticModel();
	inline ~StaticModel();
	
	inline void				insertMesh(Mesh* );
	inline void				removeMesh(Mesh* );
	
	const Joint&			insertJoint(const char* ,const Matrix4<float>& );
	void					removeJoint(const char* );
	void					removeJoint(const Joint& );

	void					finish();

protected:
	virtual void			onRender(const ParameterBuffer* ) const;
	virtual void			onTransform(const ParameterBuffer* ,Matrix4<float>* ,Joint::Handle ) const;
	virtual bool			onOptimise();
	virtual void			onClear();

private:
	Pointer<RenderStream>	m_Stream;
	List<Matrix4<float> >	m_Joints;
	MeshList				m_Transparents;
};

}; };

#endif
