/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3d_STENCILSHADOW_H
#define __GRAPHICS3d_STENCILSHADOW_H

#include "graphics3d.projectionvolume.h"
#include "graphics3d.technique.h"
#include "graphics3d.shader.h"
#include "graphics3d.stencilmode.h"
#include "graphics3d.depthmode.h"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StencilShadow : public Technique {
DeclareClass(StencilShadow, Technique);
private:
	class ShadowShader : public Shader {
	public:
		ShadowShader();
	};

	ProjectionVolume	m_Volume;
	ShadowShader		m_Shader;
	StencilMode			m_StencilMode;
	DepthMode			m_DepthMode;
	Vector3<float>		m_LightPosition;
	float				m_LightRange;


public:
	StencilShadow();

	inline void			clear();
	inline bool			add(const Mesh* );
	inline bool			add(const TriangleMesh3<float>* );
	inline void			finish();

	inline void			setLight(const Vector3<float>& vec, float range);
	inline Vector3<float> getLightPosition() const;
	inline float		getLightRange() const;

protected:
	void				onRender();
};

}; };

#endif
