/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_STENCILSHADOW_INL
#define __GRAPHICS3D_STENCILSHADOW_INL

namespace magnum { namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StencilShadow::clear() {
	m_Volume.clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	StencilShadow::add(const Mesh* m) {
	return m_Volume.add(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	StencilShadow::add(const TriangleMesh3<float>* m) {
	return m_Volume.add(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	StencilShadow::finish() {
	m_Volume.finish();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StencilShadow::setLight(const Vector3<float>& vec, float r) {
	m_LightPosition = vec;
	m_LightRange = r;
	m_Volume.update(m_LightPosition, m_LightRange);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Vector3<float> StencilShadow::getLightPosition() const {
	return m_LightPosition;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float StencilShadow::getLightRange() const {
	return m_LightRange;
}


}; };

#endif
