/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_TEXTURE2D_INL
#define __GRAPHICS3D_TEXTURE2D_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> Texture2D::getMinSize() {
	return Context::getCurrent()->getCapabilities()->getTexture2DMinSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> Texture2D::getMaxSize() {
	return Context::getCurrent()->getCapabilities()->getTexture2DMaxSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<int> Texture2D::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Texture2D::getWidth() const {
	return m_Size.getWidth();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Texture2D::getHeight() const {
	return m_Size.getHeight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Texture2D::isLocked() const {
	return m_Locked;
}


}; };

#endif
