/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_TETUREFACTORY_H
#define __GRAPHICS3D_TETUREFACTORY_H

#include "object.pointer.h"
#include "graphics.translator.h"
#include "io.sysfilefactory.h"

namespace magnum { namespace graphics3d {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;
using magnum::io::FileFactory;
using magnum::io::SystemFileFactory;

class Texture;

/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
class TextureFactory : public Object, private magnum::object::Noncopyable {
DeclareClass(TextureFactory, Object);
private:
	magnum::graphics::TranslatorRoster	m_TranslatorRoster;
	Pointer<FileFactory> m_FileFactory;

public:
	inline TextureFactory();
	inline TextureFactory(FileFactory* );

	Texture*			create(const char* );
	void				release(Texture* );

	inline void			setFileFactory(FileFactory* );
	inline FileFactory* getFileFactory() const;
};

}; };

#endif
