/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_TETUREFACTORY_INL
#define __GRAPHICS3D_TETUREFACTORY_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
inline TextureFactory::TextureFactory() {
	m_FileFactory = new SystemFileFactory();
	m_FileFactory->release();
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
inline TextureFactory::TextureFactory(FileFactory* f) {
	m_FileFactory = f;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
inline void TextureFactory::setFileFactory(FileFactory* d) {
	m_FileFactory = d;
}


/*----------------------------------------------------------------------------------
----------------------------------------------------------------------------------*/
inline FileFactory* TextureFactory::getFileFactory() const {
	return m_FileFactory;
}

}; };

#endif
