#ifndef __GRAPHICS3D_TEXTUREMATERIAL_H
#define __GRAPHICS3D_TEXTUREMATERIAL_H

#include "graphics3d.colourmaterial.h"
#include "graphics3d.texture.h"


namespace magnum { namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class TextureMaterial : public ColourMaterial {
DeclareClass(TextureMaterial, ColourMaterial);
private:
	Texture*			m_Texture[Texture::MaxTextures];

protected:
	inline				TextureMaterial();

public:
	static TextureMaterial*	create();

	~TextureMaterial();

	inline void			attachTexture(Texture*, unsigned int stage=0);
	inline void			detachTexture(unsigned int stage=0);
	inline Texture*		getTexture(unsigned int stage=0) const;

protected:
	inline void			selectTextures() const;
	inline void			selectTexture(unsigned int = 0) const;
	inline void			deselectTexture(unsigned int = 0) const;

protected:
	virtual void		onSelect() const;
};


}; };

#endif
