/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3d_VERTEXCONVERTER_H
#define __GRAPHICS3d_VERTEXCONVERTER_H

#include "graphics3d.vertexbuffer.h"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class VertexConverter : public Object, private magnum::object::Noncopyable {
DeclareClass(VertexConverter, Object);
private:
	struct Attribute {
		VertexBuffer*		m_Buffer;
		unsigned int		m_BufferIdx;
		VertexFormat::Type	m_Type;
		unsigned int		m_TypeBase;
		unsigned int		m_TypeCount;
		unsigned int		m_TypeSize;
		unsigned int		m_Offset;
	};

	Attribute			m_InputAttribute[Attributes::MaxAttributes];
	Attribute			m_OutputAttribute[Attributes::MaxAttributes];
    
    VertexBuffer*		m_Output[VertexBuffer::MaxBuffers];
    VertexBuffer*		m_Input[VertexBuffer::MaxBuffers];

public:
    VertexConverter();
    ~VertexConverter();
    
    bool				attachInput(const VertexBuffer* );
	bool				detachInput(const VertexBuffer* );
    void				detachInput();
    
    bool				attachOutput(VertexBuffer* );
    bool				detachOutput(VertexBuffer* );
    void				detachOutput();
    
    bool				convert();

private:
	void				addAttributes(const VertexBuffer* , unsigned int idx, Attribute* );
	void				removeAttributes(const VertexBuffer* , Attribute* );
};


}; };

#endif
