/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRAPHICS3D_VIEWPORT_H
#define __GRAPHICS3D_VIEWPORT_H

#include "object.pointer.h"
#include "graphics.rectangle.h"
#include "graphics3d.layergroup.h"

namespace magnum { namespace graphics3d {
using magnum::graphics::Rectangle;
using magnum::object::Pointer;

class FrameBuffer;

/*--------------------------------------------------------------------------*/
/**
 */
class Viewport : public LayerGroup {
DeclareClass(Viewport, LayerGroup);
public:
	void					attachFrameBuffer(FrameBuffer* );
	inline void				detachFrameBuffer();
	inline FrameBuffer*		getFrameBuffer() const;
	
	inline void				setWindow(const Rectangle<float>& );
	inline const Rectangle<float>& getWindow() const;

protected:	
	virtual void			onRender();
	
private:
	Pointer<FrameBuffer>	m_FrameBuffer;
	Rectangle<float>		m_Window;
};

}; };

#endif
