/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GRID_GRID2D_H
#define __GRID_GRID2D_H

#include "grid.grid.h"
#include "container.array.h"

namespace magnum { namespace grid {
using magnum::container::Array;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
class Grid2d : public Grid<T,2> {
DeclareClass(Grid2d, Grid);
private:
	Array<T>			m_Data;
	unsigned int		m_Width;
	unsigned int		m_Height;

public:
	Grid2d();
	Grid2d(const T* ,unsigned int ,unsigned int );

	void				setSize(unsigned int ,unsigned int );
	inline unsigned int	getWidth() const;
	inline unsigned int	getHeight() const;

	inline T*			operator[](unsigned int );
	inline const T*		operator[](unsigned int ) const;

	inline T&			at(unsigned int ,unsigned int );
	inline const T&		at(unsigned int ,unsigned int ) const;
	
	template<class S>
	Grid2d<S>*			convert() const;
};

}; };

#endif
