/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI_BOX_H
#define __GUI_BOX_H

#include "gui.view.h"

namespace magnum { namespace gui {
using magnum::object::Object;
using magnum::types::String;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Box : public View {
DeclareClass(Box, View);
private:
	Colour<byte>	m_LineColour;
	Colour<byte>	m_FillColour;
	int				m_LineWidth;

public:
	Box(const Rectangle<float>& rect);

	inline void			setLineWidth(int );
	inline int			getLineWidth() const;
	inline void			setLineColour(const Colour<byte> col);
	inline const Colour<byte>& getLineColour() const;
	inline void			setFillColour(const Colour<byte> col);
	inline const Colour<byte>& getFillColour() const;

protected:
	virtual bool		onPaint(Context* , const Rectangle<float>& );
};

}; };
#endif
