/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI_CONTAINER_H
#define __GUI_CONTAINER_H

#include "application.handler.h"
#include "container.chain.h"
#include "graphics.rectangle.h"
#include "graphics.colour.h"
#include "gui.view.h"

namespace magnum { namespace gui {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Chain;
using magnum::container::Chainable;
using magnum::application::Handler;
using magnum::application::Message;

class Window;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Container : public View {
DeclareClass(Container, View);
private:
	Chain<View>			m_Views;
	Rectangle<float>	m_OldFrame;

public:
	typedef magnum::container::Chain<View>::Iterator	Iterator;

public:
	Container(const Rectangle<float>& frame);
	~Container();

	bool				insert(View* view);
	bool				remove(View *view);
	bool				clear();

	inline Iterator		begin() const;
	inline Iterator		at(View* ) const;
	inline Iterator		end() const;

	virtual Dimension<float> getPreferredSize() const;
	virtual bool		setPreferredSize(void);
						
protected:				
	virtual bool		onPaint(Context* , const Rectangle<float>& );
//	virtual bool		onPaintContainer(const Rectangle<int>& );
//	virtual bool		onPaintChildren(const Rectangle<int>& );
						
	virtual bool		onAttachWindow();
	virtual bool		onDetachWindow();
	virtual bool		onActivateWindow();
	virtual bool		onDeactivateWindow();
	virtual bool		onResize(const Rectangle<float>& );

private:
	virtual void		updateTransform();
};

}; };
#endif
