/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_BOX_H
#define __GUI3D_BOX_H

#include "gui3d.view.h"
#include "graphics.colour.h"

namespace magnum { namespace gui3d {
using magnum::graphics::Colour;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Box : public View {
DeclareClass(Box, View);
private:
	Colour<float>	m_LineColour;
	Colour<float>	m_FillColour;

public:
	Box(const Rectangle<float>& rect);

	inline void			setLineColour(const Colour<float> col);
	inline const Colour<float>& getLineColour() const;
	inline void			setFillColour(const Colour<float> col);
	inline const Colour<float>& getFillColour() const;

protected:
	virtual bool		onPaint();
};

}; };

#endif
