/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_FONTCACHE_INL
#define __GUI3D_FONTCACHE_INL

namespace magnum { namespace gui3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int FontCache::getSize() const {
	return m_Fonts.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool FontCache::isEmpty() const {
	return m_Fonts.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool FontCache::contains(const Font* f) const {
	return m_Fonts.contains(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FontCache::Iterator FontCache::begin() const {
	return m_Fonts.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FontCache::Iterator FontCache::at(const Font* f) const {
	return m_Fonts.at(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FontCache::Iterator FontCache::end() const {
	return m_Fonts.end();
}

}; };

#endif
