/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_FONTMAP_H
#define __GUI3D_FONTMAP_H

#include "object.pointer.h"
#include "freetype.font.h"
#include "gui3d.bitmap.h"


namespace magnum { namespace gui3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::freetype::Font;
using magnum::object::Pointer;

class Context;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FontMap : public Object {
DeclareClass(FontMap, Object);
friend class FontCache;
friend class Context;
public:
	struct Glyph {
		float tx0, ty0, tx1, ty1;
		float advance;
		float bv, bh;
		float width, depth;
	};
	
private:
	Bitmap*				m_Bitmap;
	Pointer<Font>		m_Font;
	Glyph				m_Glyphs[256];

protected:	
	FontMap();
	
public:
	~FontMap();
	
	static FontMap*		create(const Font* );
	
	inline Font*		getFont() const;
	inline Bitmap*		getBitmap() const;
	
	inline const Glyph&	operator[](unsigned int ) const;
	inline Glyph&		operator[](unsigned int );
};

}; };

#endif
