/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_ROOT_INL
#define __GUI3D_ROOT_INL

namespace magnum { namespace gui3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Root::invalidate() {
#if defined(__FORWINDOWS__)
	InvalidateRect(m_WindowHandle, NULL, TRUE);
#endif	
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Root::insertHandler(Handler* hnd) {
	return Messenger::insert(hnd);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Root::removeHandler(Handler* hnd) {
	return Messenger::remove(hnd);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dimension<float> Root::getSize(void) const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Root::setName(const char*  n) {
	m_Name = n;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Root::getName(void) const {
	return m_Name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline View* Root::getFocus() const {
	return m_Focus;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Root::remove(const Root::Iterator& iter) {
	return remove(&(*iter));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Root::Iterator Root::begin() const {
	return m_Views.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Root::Iterator Root::end() const {
	return m_Views.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Root::Iterator Root::at(View* v) const {
	return m_Views.at(v);
}

}; };

#endif
