/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_SLIDER_INL
#define __GUI3D_SLIDER_INL

namespace magnum { namespace gui3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Slider::setRange(const Range<float>& r) {
	m_Range = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Slider::setRange(float mi, float ma) {
	m_Range.setStart(mi);
	m_Range.setEnd(ma);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Range<float>& Slider::getRange() const {
	return m_Range;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Slider::setStepsize(float s) {
	m_Step = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Slider::getStepsize() const {
	return m_Step;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Slider::setValue(float v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Slider::getValue() const {
	return m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Slider::isPressed() const {
	return (m_State == PressedState);
}

}; };

#endif
