/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_STRINGVIEW_H
#define __GUI3D_STRINGVIEW_H

#include "gui3d.view.h"
#include "freetype.font.h"
#include "object.pointer.h"
#include "graphics.colour.h"

namespace magnum { namespace gui3d {
using magnum::freetype::Font;
using magnum::object::Pointer;
using magnum::graphics::Colour;

class FontMap;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StringView : public View {
DeclareClass(StringView, View);
public:
	StringView(const Rectangle<float>& );
	StringView(const Rectangle<float>& ,const char* );
	
	inline void			setText(const char* );
	inline const String& getText() const;
	
	inline void			setFont(const Font* font);
	inline const Font*	getFont();
	
	inline void			setColour(const Colour<float> col);
	inline const Colour<float>& getColour() const;
	

protected:
	virtual bool		onPaint();

private:
	String				m_Text;
	Pointer<Font>		m_Font;
	Pointer<FontMap>	m_FontMap;
	Colour<float>		m_Colour;
};

}; };

#endif
