/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_STRINGVIEW_INL
#define __GUI3D_STRINGVIEW_INL

namespace magnum { namespace gui3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StringView::setText(const char* t) {
	ASSERT(t != NULL);
	m_Text = t;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const String& StringView::getText() const {
	return m_Text;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StringView::setFont(const Font* font) {
	ASSERT(font != NULL);
	m_Font = const_cast<Font*>(font);
	m_FontMap = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Font* StringView::getFont() {
	return m_Font;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StringView::setColour(const Colour<float> col) {
	m_Colour = col;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& StringView::getColour() const {
	return m_Colour;
}


}; };

#endif
