/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __GUI3D_WINDOW_H
#define __GUI3D_WINDOW_H

#include "graphics.colour.h"
#include "gui3d.container.h"

namespace magnum { namespace gui3d {
using magnum::graphics::Colour;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Window : public Container {
DeclareClass(Window, Container);
public:
	Window(const Rectangle<float>& r);
	
protected:				
	virtual bool		onPaint();

	// Mouse related methods
	virtual bool		onMouseMove(const Point<float>& ,Mouse::Button );
	virtual bool		onMouseButton(const Point<float>& ,Mouse::Button );
	
	// Moving methods
	virtual bool		onMove(const Point<float>& );
	virtual bool		onResize(const Rectangle<float>& );
	
private:
	enum State {
		NormalState = 1,
		MovingState
	};
	
	State				m_State;
	Point<float>		m_MoveReference;
	Colour<float>		m_BackColour;
	Colour<float>		m_BorderColour;
};

}; };

#endif
