/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_BODY_H
#define __INPUT_BODY_H

#include "math.matrix.h"
#include "input.marker.h"

namespace magnum { namespace input {
using magnum::math::Matrix;
using magnum::math::Matrix4;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Body : public Marker, private Chainable<Body> {
DeclareClass(Body, Marker);
protected:
	Body();
	explicit Body(const char* );
	explicit Body(const String& );
	explicit Body(Space* );
	Body(Space* ,const char* );
	Body(Space* ,const String& );

public:
	inline const Matrix4<float>& getTransform() const;

	inline void		setCalibration(const Matrix<float,4>& );
	inline const Matrix4<float>& getCalibration() const;
	
protected:	
	void			updateTransform(const Matrix<float,4>& );

private:
	Matrix4<float>	m_Transform;
	Matrix4<float>	m_Calibration;
};

}; };

#endif
