/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_BODY_INL
#define __INPUT_BODY_INL

namespace magnum { namespace input {


/*--------------------------------------------------------------------------*/
/**
 */
inline const Matrix4<float>& Body::getTransform() const {
	return m_Transform;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Body::setCalibration(const Matrix<float,4>& m) {
	m_Calibration = m;
	Marker::setCalibration(Vector3<float>(m[0][3], m[1][3], m[2][3]));
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Matrix4<float>& Body::getCalibration() const {
	return m_Calibration;
}

}; };

#endif
