/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_CHARACTER_H
#define __INPUT_CHARACTER_H

#include "object.h"

namespace magnum { namespace input {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Character : public Object {
DeclareClass(Character, Object);
public:
	enum Modifier {
		Shift			=	0x00003,
		ShiftLeft		= 	0x00001,
		ShiftRight		= 	0x00002,
		Control			=	0x0000c,
		ControlLeft		=	0x00004,
		ControlRight	=	0x00008,
		Alt				=	0x00030,
		AltLeft 		=	0x00010,
		AltRight    	=   0x00020,
		Meta			=	0x000c0,
		MetaLeft		=	0x00040,
		MetaRight		=	0x00080
	};

	typedef unsigned int	Code;
};

}; };

#endif
