/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_DEVICE_H
#define __INPUT_DEVICE_H

#include "object.h"

namespace magnum { namespace input {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Device : public Object, private magnum::object::Noncopyable {
DeclareClass(Device, Object);
protected:
	inline Device();
	inline explicit Device(const char* );
	inline explicit Device(const String& );
	
public:
	inline void				setName(const char* );
	inline String			getName() const;
	
	inline void				loop();
	inline void				calibrate();
	
protected:
	virtual void			onLoop();
	virtual void			onCalibrate();
	
private:
	String					m_Name;	
};

}; };

#endif
