/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_DEVICE_INL
#define __INPUT_DEVICE_INL

namespace magnum { namespace input {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Device::Device() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Device::Device(const char* n) : m_Name(n) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Device::Device(const String& n) : m_Name(n) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Device::setName(const char* n) {
	m_Name = n;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Device::getName() const {
	return m_Name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Device::loop() {
	onLoop();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Device::calibrate() {
	onCalibrate();
}

}; };

#endif
