/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_FLIGHTSTICK_INL
#define __INPUT_FLIGHTSTICK_INL

namespace magnum { namespace input {

/*--------------------------------------------------------------------------*/
/**
 */
inline Flightstick::Flightstick() {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Flightstick::Flightstick(const char* n) : Body(n) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Flightstick::Flightstick(const String& n) : Body(n) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Flightstick::Flightstick(Space* s) : Body(s) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Flightstick::Flightstick(Space* s,const char* n) : Body(s,n) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Flightstick::Flightstick(Space* s,const String& n) : Body(s,n) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Flightstick::insertListener(FlightstickListener* l) {
	m_Dispatcher.insert(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Flightstick::removeListener(FlightstickListener* l) {
	m_Dispatcher.remove(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Flightstick::clearListeners() {
	m_Dispatcher.clear();
}

}; };

#endif

