/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_GLOVE_INL
#define __INPUT_GLOVE_INL

namespace magnum { namespace input {

/*--------------------------------------------------------------------------*/
/**
 */
inline Glove::Glove() {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Glove::Glove(const char* n) : Body(n) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Glove::Glove(const String& n) : Body(n) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glove::insertListener(GloveListener* l) {
	m_Dispatcher.insert(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glove::removeListener(GloveListener* l) {
	m_Dispatcher.remove(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Glove::clearListeners() {
	m_Dispatcher.clear();
}


/*--------------------------------------------------------------------------*/
/**
 */
inline float Glove::getFinger(Finger f) const {
	ASSERT(f < 5);
	return m_Fingers[f];
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Glove::updateFinger(Finger f,float v) {
	ASSERT(f < 5);
	m_Fingers[f] = v;
}

}; };

#endif

