/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_JOYSTICK_INL
#define __INPUT_JOYSTICK_INL

namespace magnum { namespace input {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int	Joystick::getButtons() const {
	return m_Buttons;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector<float,6>& Joystick::getAxes() const {
	return m_Axes;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Joystick::insertListener(JoystickListener* l) {
	m_Dispatcher.insert(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Joystick::removeListener(JoystickListener* l) {
	m_Dispatcher.remove(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Joystick::clearListeners() {
	m_Dispatcher.clear();
}

}; };

#endif
