/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_KEYBOARD_INL
#define __INPUT_KEYBOARD_INL

namespace magnum { namespace input {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Dispatcher<KeyboardListener>& Keyboard::getDispatcher() {
	return m_Dispatcher;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Dispatcher<KeyboardListener>& Keyboard::getDispatcher() const {
	return m_Dispatcher;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Keyboard::insertListener(KeyboardListener* l) {
	m_Dispatcher.insert(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Keyboard::removeListener(KeyboardListener* l) {
	m_Dispatcher.remove(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Keyboard::clear() {
	m_Dispatcher.clear();
}

}; };

#endif
