/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_MARKER_H
#define __INPUT_MARKER_H

#include "math.vector3.h"
#include "container.chain.h"
#include "input.device.h"

namespace magnum { namespace input {
using magnum::math::Vector3;
using magnum::container::Chainable;

class Space;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Marker : public Device, private Chainable<Marker> {
DeclareClass(Marker, Device);
protected:
	Marker();
	explicit Marker(const char* );
	explicit Marker(const String& );
	explicit Marker(Space* );
	Marker(Space* ,const char* );
	Marker(Space* ,const String& );
	
public:
	inline const Vector3<float>& getPosition() const;

	inline Space*	getSpace() const;

	inline void		setCalibration(const Vector3<float>& );
	inline const Vector3<float>& getCalibration() const;
	
protected:	
	void			updatePosition(const Vector3<float>& );

private:
	Vector3<float>	m_Position;
	Vector3<float>	m_Calibration;
	Space*			m_Space;
};

}; };

#endif
