/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_P5GLOVE_H
#define __INPUT_P5GLOVE_H

#include "input.glove.h"

namespace magnum { namespace input {

/*--------------------------------------------------------------------------*/
/**
 */
class P5Glove : public Glove {
DeclareClass(P5Glove, Glove);
public:
	static const int	FilterSize = 8;

public:
	P5Glove(unsigned int = 0);
	~P5Glove();
	
	static unsigned int	getGloves();
	
protected:
	virtual void		onLoop();
	virtual void		onCalibrate();
	
private:
	void				filterXYZ();
	void				filterYPR();
	void				filterRotation();
	
	static void			dllRefer();
	static void			dllRelease();
	
private:
	Vector3<float>		m_RawPositions[FilterSize];
	Vector3<float>		m_Position;
	Vector3<float>		m_RawRotations[FilterSize];
	Vector3<float>		m_Rotation;
	int					m_FilterIndex;
	int					m_Glove;
	
	static int			m_References;
};

}; };

#endif
