/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT_SPACE_INL
#define __INPUT_SPACE_INL

namespace magnum { namespace input {

/*--------------------------------------------------------------------------*/
/**
 */
inline void Space::setCalibration(const Matrix<float,4>& c) {
	m_Calibration = c;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Matrix4<float>& Space::getCalibration() const {
	return m_Calibration;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Vector3<float>& Space::getMinimum() const {
	return m_Minimum;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Vector3<float>& Space::getMaximum() const {
	return m_Maximum;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Space::setMinimum(const Vector3<float>& m) {
	m_Minimum = m;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Space::setMaximum(const Vector3<float>& m) {
	m_Maximum = m;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Chain<Marker>& Space::getMarkers() const {
	return m_Markers;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Chain<Body>& Space::getBodies() const {
	return m_Bodies;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Chain<Glove>& Space::getGloves() const {
	return m_Gloves;
}

}; };

#endif
