/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT3D_FLIGHTCONTROLLER_INL
#define __INPUT3D_FLIGHTCONTROLLER_INL

namespace magnum { namespace input3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FlightController::setDirection(const Vector3<float>& v) {
	m_Direction = v;
	m_Right = m_Up % m_Direction;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& FlightController::getDirection() const {
	return m_Direction;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FlightController::setUp(const Vector3<float>& v) {
	m_Up = v;
	m_Right = m_Up % m_Direction;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& FlightController::getUp() const {
	return m_Up;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void FlightController::setSpeed(float r) {
	m_Speed = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float FlightController::getSpeed() const {
	return m_Speed;
}

}; };

#endif
