/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __INPUT3D_TRACKBALLCONTROLLER_INL
#define __INPUT3D_TRACKBALLCONTROLLER_INL

namespace magnum { namespace input3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool TrackballController::getAutoCenter() const {
	return m_AutoCenter;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void TrackballController::setCenter(const Vector3<float>& v) {
	m_Center = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& TrackballController::getCenter() const {
	return m_Center;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void TrackballController::setRadius(float r) {
	m_Radius = r;
	m_Radius2 = r*r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float TrackballController::getRadius() const {
	return m_Radius;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void TrackballController::setSpeed(float r) {
	m_Speed = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float TrackballController::getSpeed() const {
	return m_Speed;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float TrackballController::projectToSphere(const Point<float>& p) const {
    float d = p.getX() * p.getX() + p.getY() * p.getY();

    if (d < m_Radius2 * 0.5f) {
        return sqrt(m_Radius2 - d);
    } else {
        return m_Radius2 / (2.0f * sqrt(d));
    }
}

}; };

#endif
