/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_ARCHIVE_INL
#define __IO_ARCHIVE_INL

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Directory* Archive::list() {
	return onList();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveDirectory::rawWrite(const void *buf, size_t size) {
	size_t ret = m_Archive->rawWrite(buf, m_Position, size);
	m_Position += ret;
	return ret;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveDirectory::rawRead(void *buf, size_t size) {
	size_t ret = m_Archive->rawRead(buf, m_Position, size);
	m_Position += ret;
	return ret;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 ArchiveDirectory::rawGetPosition() {
	return m_Position;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 ArchiveDirectory::rawSetPosition(int64 where) {
	m_Position = where;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 ArchiveDirectory::rawGetSize() {
	return m_Archive->rawGetSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveDirectory::rawWrite(const void *buf, int64 where, size_t size) {
	return m_Archive->rawWrite(buf, where, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveDirectory::rawRead(void *buf, int64 where, size_t size) {
	return m_Archive->rawRead(buf, where, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveFile::rawWrite(const void *buf, size_t size) {
	size_t ret = m_Archive->rawWrite(buf, m_Position, size);
	m_Position += ret;
	return ret;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveFile::rawRead(void *buf, size_t size) {
	size_t ret = m_Archive->rawRead(buf, m_Position, size);
	m_Position += ret;
	return ret;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 ArchiveFile::rawGetPosition() {
	return m_Position;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 ArchiveFile::rawSetPosition(int64 where) {
	m_Position = where;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 ArchiveFile::rawGetSize() {
	return m_Archive->rawGetSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveFile::rawWrite(const void *buf, int64 where, size_t size) {
	return m_Archive->rawWrite(buf, where, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t ArchiveFile::rawRead(void *buf, int64 where, size_t size) {
	return m_Archive->rawRead(buf, where, size);
}

}; };

#endif
