/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_CONTENT_INL
#define __IO_CONTENT_INL

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Content::Content(File* file) {
	readBuffer(file->getInputStream());
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Content::Content(InputStream* in) {
	readBuffer(in);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Content::Content(InputStream& in) {
	readBuffer(&in);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t Content::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Content::operator const char*() const {
	return (const char*)m_Buffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* Content::toChars() const {
	return (const char*)m_Buffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const byte* Content::toBytes() const {
	return (const byte*)m_Buffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const word* Content::toWords() const {
	return (const word*)m_Buffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const dword* Content::toDword() const {
	return (const dword*)m_Buffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const float* Content::toFloats() const {
	return (const float*)m_Buffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const double* Content::toDoubles() const {
	return (const double*)m_Buffer;
}

}; };

#endif
