/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_DIRECTORY_INL
#define __IO_DIRECTORY_INL

namespace magnum { namespace io {
using magnum::types::uint64;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Directory::Directory() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Directory::Directory(const char* name) {
	open(name);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Directory::getName() const {
	return m_Directory;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* Directory::getDirectory() const {
	return m_Directory;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Directory::Iterator Directory::begin() const {
	return m_Files.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Directory::Iterator Directory::end() const {
	return m_Files.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Directory::getSize() const {
	return m_Files.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FileInfo& Directory::insert(const char* n,int64 s, unsigned int f) {
	FileInfo* info = m_Files.append();
	info->m_Size = s;
	info->m_Flags = f;
	strncpy(info->m_Name, n, sizeof(info->m_Name));
	return *info;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FileInfo& Directory::insert(const char* n,int64 s,const Timestamp& ct,const Timestamp& mt,const Timestamp& at,unsigned int f) {
	FileInfo* info = m_Files.append();
	info->m_Size = s;
	info->m_Flags = f;
	info->m_CreationTime = ct.getTime();
	info->m_ModificationTime = mt.getTime();
	info->m_AccessTime = at.getTime();
	strncpy(info->m_Name, n, sizeof(info->m_Name));
	return *info;
}


}; };

#endif
