/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_FILEFACTORY_H
#define __IO_FILEFACTORY_H

#include "io.file.h"

namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;

class Directory;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FileFactory : public Object {
DeclareClass(FileFactory, Object);
protected:
	inline FileFactory();
	
public:
	inline File*		create(const char* );
	inline File*		open(const char* ,File::OpenFlags = File::ReadOnly);
	inline bool			exists(const char* );
	inline Directory*	list();
	
protected:
	virtual bool		onExists(const char* ) = 0;
	virtual File*		onCreate(const char* ) = 0;
	virtual File*		onOpen(const char* ,File::OpenFlags ) = 0;
	virtual Directory*	onList() = 0;
};

}; };

#endif
