/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_FILEFACTORY_INL
#define __IO_FILEFACTORY_INL

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FileFactory::FileFactory() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Directory* FileFactory::list() {
	return onList();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline File* FileFactory::create(const char* name) {
	ASSERT(name != NULL);
	return onCreate(name);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline File* FileFactory::open(const char* name,File::OpenFlags flags) {
	ASSERT(name != NULL);
	return onOpen(name, flags);
}
	

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool FileFactory::exists(const char* name) {
	ASSERT(name != NULL);
	return onExists(name);
}

}; };

#endif
