/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_FILESTREAM_H
#define __IO_FILESTREAM_H

#include "io.inputstream.h"
#include "io.outputstream.h"


namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;

class File;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FileInputStream : public InputStream {
DeclareClass(FileInputStream, InputStream);
public:
	explicit FileInputStream(File* );
	~FileInputStream();

protected:
	inline size_t 	onRead(void *buffer, size_t  size);
	inline size_t 	onSkip(size_t size);
	inline int64 	onAvailable();
	bool			onClose();

private:
	File*			m_File;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FileOutputStream : public OutputStream {
DeclareClass(FileOutputStream, OutputStream);
public:
	explicit FileOutputStream(File* );
	~FileOutputStream();

protected:
	inline size_t	onWrite(const void *buffer, size_t size);
	inline bool		onFlush();
	bool			onClose();

private:
	File*			m_File;
};

}; };

#endif
