/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_FILESTREAM_INL
#define __IO_FILESTREAM_INL

namespace magnum { namespace io {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t FileInputStream::onRead(void *buffer, size_t size) {
	return m_File->read(buffer, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t FileInputStream::onSkip(size_t size) {
	int64 pos = m_File->getPosition();
	m_File->setPosition(size, File::Current);
	return (size_t)(m_File->getPosition() - pos);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 FileInputStream::onAvailable() {
	return m_File->getSize() - m_File->getPosition();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t FileOutputStream::onWrite(const void *buffer, size_t size) {
	return m_File->write(buffer, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	FileOutputStream::onFlush() {
	return m_File->flush();
}

}; };

#endif

