/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_FILTER_H
#define __IO_FILTER_H

#include "object.h"
#include "container.chain.h"

namespace magnum {namespace io {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Chain;
using magnum::container::Chainable;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S,class T = S> 
class Filter : public Object, private Chainable<Filter<S,T> > {
DeclareClass(Filter, Object);
public:
	inline T*			process(const S* );

protected:
	virtual T*			onProcess(const S* ) = 0;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
class FilterChain : public Filter<T> {
DeclareClass(FilterChain, Filter);
private:
	Chain<Filter<T> >	m_Filters;

public:
	inline FilterChain();
	inline FilterChain(Filter<T>& );
	inline FilterChain(Filter<T>& , Filter<T>& );

	inline const FilterChain& operator=(FilterChain& );

	inline void			append(Filter& );

protected:
	virtual T*			onProcess(const T* );
};

template<class S,class T> inline T* operator<<(Filter<S,T>& ,const S* );
template<class T> inline FilterChain<T> operator<<(Filter<T>& ,Filter<T>& );
template<class T> inline FilterChain<T>& operator<<(FilterChain<T>& ,Filter<T>& );

}; };


#endif
