/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_INPUTBUFFER_H
#define __IO_INPUTBUFFER_H

#include "object.softpointer.h"
#include "io.inputstream.h"
#include "io.outputstream.h"


namespace magnum { namespace io {
using magnum::object::SoftPointer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class InputBuffer : public InputStream {
DeclareClass(InputBuffer, InputStream);
public:
	InputBuffer(size_t bufsize = 16384);
	InputBuffer(InputStream* ,size_t bufsize = 16384);
	InputBuffer(InputStream& ,size_t bufsize = 16384);
	~InputBuffer();

	inline InputStream*		getStream() const;
	void					setStream(InputStream* );
	void					setStream(InputStream& );

protected:
	virtual size_t 			onRead(void *buffer, size_t size);
	virtual size_t 			onSkip(size_t size);
	virtual int64 			onAvailable();
	virtual bool		  	onClose();

private:
	SoftPointer<InputStream> m_Stream;
	byte*					m_Buffer;
	byte*					m_BufferCurrent;
	size_t					m_BufferSize;
	size_t					m_BufferLeft;
};


}; };

#endif
