/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_INPUTSTREAM_H
#define __IO_INPUTSTREAM_H

#include "io.stream.h"
#include "base.string.h"


namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;
using magnum::types::int64;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class InputStream : public Stream {
DeclareClass(InputStream, Stream);
public:
	enum {
		EndOfFile = -1
	};
	
protected:
	inline InputStream();
	
public:
	template<class T>
	inline size_t 		read(T *buf);
	inline size_t		read(void *buffer, size_t size);
	inline size_t		skip(size_t size);
	inline int64		available();
	inline bool			close();

protected:
	virtual size_t 		onRead(void *buffer, size_t size) = 0;
	virtual size_t 		onSkip(size_t size) = 0;
	virtual int64 		onAvailable() = 0;
	virtual bool		onClose() = 0;
};


InputStream& operator>>(InputStream&, String& str);
InputStream* operator>>(InputStream*, String& str);

}; };

#endif
