/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_INPUTSTREAM_INL
#define __IO_INPUTSTREAM_INL

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputStream::InputStream() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>
inline size_t InputStream::read(T *buf) {
	return read(bug, sizeof(T));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t InputStream::read(void *buffer, size_t size) {
	return onRead(buffer, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline size_t InputStream::skip(size_t size) {
	return onSkip(size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int64 InputStream::available() {
	return onAvailable();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool InputStream::close() {
	return onClose();
}



}; };

#endif
