/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_MEMFILE_H
#define __IO_MEMFILE_H

#include "io.file.h"
#include "container.array.h"

namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Array;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MemoryFile : public File {
DeclareClass(MemoryFile, File);
public:
	MemoryFile(unsigned int bs = 16384);
	~MemoryFile();

protected:
	size_t			onWrite(const void *buf, size_t size);
	size_t			onRead(void *buf, size_t size);
	bool			onFlush();

	int64			onSetPosition(long where,PositionMode mode);
	int64			onGetPosition() const;
	bool			onRewind();

	int64			onGetSize() const;
	int64			onSetSize(int64 newSize);

private:
	bool			append(size_t addSize);
	bool			truncate(size_t delSize);

private:
	size_t			m_Size;
	size_t			m_Position;
	size_t			m_Blocksize;
	Array<void*>	m_Blocks;
};

}; };

#endif
