/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_OUTPUTBUFFER_H
#define __IO_OUTPUTBUFFER_H

#include "object.softpointer.h"
#include "io.inputstream.h"
#include "io.outputstream.h"


namespace magnum { namespace io {
using magnum::object::SoftPointer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class OutputBuffer : public OutputStream {
DeclareClass(OutputBuffer, OutputStream);
public:
	OutputBuffer(size_t size = 16384);
	OutputBuffer(OutputStream* ,size_t size = 16384);
	OutputBuffer(OutputStream& ,size_t size = 16384);
	~OutputBuffer();

	inline OutputStream*	getStream() const;
	void					setStream(OutputStream* );
	void					setStream(OutputStream& );

protected:
	virtual size_t			onWrite(const void *buffer, size_t size);
	virtual bool			onFlush();
	virtual bool			onClose();

private:
	SoftPointer<OutputStream> m_Stream;
	byte*					m_Buffer;
	byte*					m_BufferCurrent;
	size_t					m_BufferSize;
	size_t					m_BufferUsed;
};

}; };

#endif
