/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_OUTPUTSTREAM_H
#define __IO_OUTPUTSTREAM_H

#include "io.stream.h"
#include "base.string.h"


namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class OutputStream : public Stream {
DeclareClass(OutputStream, Stream);
private:
	int			m_FloatDigits;

protected:
	inline OutputStream();

public:
	template<class T>
	inline size_t 			write(const T *buf);
	inline size_t			write(const void *buffer, size_t size);
	inline bool				flush();
	inline bool				close();

	inline OutputStream& 	operator<<(const char* str);
	inline OutputStream& 	operator<<(signed char val);
	inline OutputStream& 	operator<<(unsigned char val);
	inline OutputStream& 	operator<<(signed short val);
	inline OutputStream& 	operator<<(unsigned short val);
	inline OutputStream& 	operator<<(signed int val);
	inline OutputStream& 	operator<<(unsigned int val);
	inline OutputStream& 	operator<<(signed long val);
	inline OutputStream& 	operator<<(unsigned long val);
	inline OutputStream& 	operator<<(float val);
	inline OutputStream& 	operator<<(double val);

protected:
	virtual size_t			onWrite(const void *buffer, size_t size) = 0;
	virtual bool			onFlush() = 0;
	virtual bool			onClose() = 0;
};

inline OutputStream& operator<<(OutputStream&, const String& str);
inline OutputStream* operator<<(OutputStream*, const String& str);
inline OutputStream& operator<<(OutputStream&, const Object& str);
inline OutputStream* operator<<(OutputStream*, const Object& str);

}; };
#endif
