/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_STREAMTOKENISER_INL
#define __IO_STREAMTOKENISER_INL

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputStream* StreamTokeniser::getStream() const {
	return m_Input;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline StreamTokeniser::Token StreamTokeniser::getType() const {
	return m_Type;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline double StreamTokeniser::getNumber() const {
	return m_Number;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const String& StreamTokeniser::getString() const {
	return m_String;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StreamTokeniser::setWhitespaces(const char* w) {
	m_Whitespaces = w;
	mapChars(m_Whitespaces, Whitespace);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* StreamTokeniser::getWhitespaces() const {
	return m_Whitespaces;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StreamTokeniser::setOrdinaryChars(const char* o) {
	m_Ordinaries = o;
	mapChars(m_Ordinaries, Ordinary);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* StreamTokeniser::getOrdinaryChars() const {
	return m_Ordinaries;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StreamTokeniser::setQuoteChars(const char* q) {
	m_Quotes = q;
	mapChars(m_Quotes, Quote);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* StreamTokeniser::getQuoteChars() const {
	return m_Quotes;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StreamTokeniser::setCommentChars(const char* c) {
	m_Comments = c;
	mapChars(m_Comments, Comment);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* StreamTokeniser::getCommentChars() const {
	return m_Comments;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StreamTokeniser::setWordChars(const char* w) {
	m_Words = w;
	mapChars(m_Words, Word);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* StreamTokeniser::getWordChars() const {
	return m_Words;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StreamTokeniser::enableSlashSlashComments(bool b) {
	m_SlashSlashComments = b;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void StreamTokeniser::enableSlashStarComments(bool b) {
	m_SlashStarComments = b;
}

}; };

#endif
