/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_SYSTEMDIRECTORY_H
#define __IO_SYSTEMDIRECTORY_H

#include "io.directory.h"

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SystemDirectory : public Directory {
DeclareClass(SystemDirectory, Directory);
public:
	inline SystemDirectory();
	inline SystemDirectory(const char* );

	static bool			create(const char* );
	static bool			remove(const char* );
	static String		getCurrent();

protected:
	virtual void		onRefresh();
	virtual void		onOpen(const char* );
	
private:
#if defined(__FORWINDOWS__)
	void				insert(const WIN32_FIND_DATA& );
#endif
};

}; };

#endif
