/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __IO_SYSTEMFILEFACTORY_H
#define __IO_SYSTEMFILEFACTORY_H

#include "io.filefactory.h"

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SystemFileFactory : public FileFactory {
DeclareClass(SystemFileFactory, FileFactory);
public:
	inline SystemFileFactory();
	inline SystemFileFactory(const char* );
	
	inline void			setDirectory(const char* );
	inline const char*	getDirectory() const;
	
protected:
	virtual bool		onExists(const char* );
	virtual File*		onCreate(const char* );
	virtual File*		onOpen(const char* ,File::OpenFlags );
	virtual Directory*	onList();

	String				getAbsName(const char* );
		
private:
	String				m_Directory;	
};

}; };

#endif
