/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __MATH_BICUBICINTERPOLATOR_H
#define __MATH_BICUBICINTERPOLATOR_H

#include "math.interpolator2d.h"

namespace magnum { namespace math {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T> class BicubicInterpolator : public Interpolator2d<S,T> {
DeclareClass(BicubicInterpolator, Interpolator2d);
private:

public:
	inline BicubicInterpolator();
	inline BicubicInterpolator(const T* ,unsigned int ,unsigned int );
	inline BicubicInterpolator(const T* ,unsigned int ,unsigned int ,const Vector<S,2>& );

	inline T			operator()(const Vector<S,2>& ) const;
	T					operator()(const S& ,const S& ) const;
};

}; };

#endif
