/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __MATH_INTERPOLATOR1D_H
#define __MATH_INTERPOLATOR1D_H

#include "math.interpolator.h"
#include "container.array.h"

namespace magnum { namespace math {
using magnum::container::Array;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
class Interpolator1d : public Interpolator<S,T> {
DeclareClass(Interpolator1d, Interpolator);
private:
	S					m_Step;
	S					m_Origin;
	Array<T>			m_Data;

public:
	Interpolator1d();
	Interpolator1d(const T* ,unsigned int ,S = S(1));

	inline unsigned int	getSize() const;
	void				setSize(unsigned int );
	
	inline S			getStep() const;
	inline void			setStep(const S& );
	
	inline S			getOrigin() const;
	inline void			setOrigin(const S& );

	inline T&			operator[](unsigned int );
	inline const T&		operator[](unsigned int ) const;

	inline T&			at(unsigned int );
	inline const T&		at(unsigned int ) const;
};

}; };

#endif
