/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __MATH_INTERPOLATOR1D_INL
#define __MATH_INTERPOLATOR1D_INL

namespace magnum { namespace math {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
Interpolator1d<S,T>::Interpolator1d() {
	m_Step = S(1);
	m_Origin = S(0);
}	


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
Interpolator1d<S,T>::Interpolator1d(const T* data,unsigned int count,S step) {
	m_Step = S;
	m_Origin = S(0);
	m_Array.copy(data, count);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline unsigned int	Interpolator1d<S,T>::getSize() const {
	return m_Array.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
void Interpolator1d<S,T>::setSize(unsigned int c) {
	m_Array.setSize(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline S Interpolator1d<S,T>::getStep() const {
	return m_Step;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline void	Interpolator1d<S,T>::setStep(const S& s) {
	m_Step = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline S Interpolator1d<S,T>::getOrigin() const {
	return m_Origin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline void	Interpolator1d<S,T>::setOrigin(const S& o) {
	m_Origin = o;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline T& Interpolator1d<S,T>::operator[](unsigned int i) {
	return m_Data[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline const T& Interpolator1d<S,T>::operator[](unsigned int i) const {
	return m_Data[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline T& Interpolator1d<S,T>::at(unsigned int i) {
	return m_Data[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline const T& Interpolator1d<S,T>::at(unsigned int i) const {
	return m_Data[i];
}

}; };

#endif
