/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __MATH_INTERPOLATOR2D_H
#define __MATH_INTERPOLATOR2D_H

#include "math.vector.h"
#include "math.interpolator.h"
#include "container.array.h"

namespace magnum { namespace math {
using magnum::container::Array;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
class Interpolator2d : public Interpolator<S,T> {
DeclareClass(Interpolator2d, Interpolator);
private:
	Vector<S,2>			m_Step;
	Vector<S,2>			m_Origin;
	Array<T>			m_Data;
	unsigned int		m_Width;
	unsigned int		m_Height;

public:
	Interpolator2d();
	Interpolator2d(const T* ,unsigned int ,unsigned int );
	Interpolator2d(const T* ,unsigned int ,unsigned int ,const Vector<S,2>& );

	void				setSize(unsigned int ,unsigned int );
	inline unsigned int	getWidth() const;
	inline unsigned int	getHeight() const;
	
	inline const Vector<S,2>& getStep() const;
	inline void			setStep(const S& ,const S& );
	inline void			setStep(const Vector<S,2>& );
	
	inline const Vector<S,2>& getOrigin() const;
	inline void			setOrigin(const S& ,const S& );
	inline void			setOrigin(const Vector<S,2>& );

	inline T*			operator[](unsigned int );
	inline const T*		operator[](unsigned int ) const;

	inline T&			at(unsigned int ,unsigned int );
	inline const T&		at(unsigned int ,unsigned int ) const;
};

}; };

#endif
