/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __MATH_LINEARINTERPOLATOR_INL
#define __MATH_LINEARINTERPOLATOR_INL

namespace magnum { namespace math {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline LinearInterpolator<S,T>::LinearInterpolator() {
}	


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline LinearInterpolator<S,T>::LinearInterpolator(const T* data,unsigned int count,S step) : Interpolator1d(data, count, step) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class S, class T>
inline T LinearInterpolator<S,T>::operator()(const S& s) const {
	S t = (s - m_Origin) / m_Step;
	S is = floor(t);
	int idx = (int)is;
	if (idx < 0)
		return at(0);
	else if (idx > getSize()-1)
		return at(getSize()-1);
		
	t -= is;
	return t*at(idx+1) + (S(1)-t)*at(idx);
}

}; };

#endif
