/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_BUFFER_INL
#define __MEDIA_BUFFER_INL

#include <string.h>

namespace magnum { namespace media {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void* Buffer::getBuffer() const {
	return m_Buffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Buffer::setSize(unsigned int s) {
	ASSERT(s <= m_MaxSize);
	m_Size = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Buffer::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Buffer::getMaxSize() const {
	return m_MaxSize;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputPin* Buffer::getConsumer() const {
	return m_Consumer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline OutputPin* Buffer::getProducer() const {
	return m_Producer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node* Buffer::getOwner() const {
	return m_Owner;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void* Buffer::getOwnerData() const {
	return m_OwnerData;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Buffer::resetOwner() {
	m_Owner = NULL;
	m_OwnerData = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Buffer::setUserData(void* data) {
	m_UserData = data;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void* Buffer::getUserData() const {
	return m_UserData;
}

}; };

#endif
