/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_FORMAT_INL
#define __MEDIA_FORMAT_INL

namespace magnum { namespace media {

/*--------------------------------------------------------------------------*/
/**
 */
inline void AudioFormat::setChannels(unsigned int n) {
	m_Channels = n;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int	AudioFormat::getChannels() const {
	return m_Channels;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void AudioFormat::setSamplerate(unsigned int r) {
	m_Samplerate = r;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int	AudioFormat::getSamplerate() const {
	return m_Samplerate;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void AudioFormat::setFormat(AudioFormat::Format f) {
	m_Format = f;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline AudioFormat::Format AudioFormat::getFormat() const {
	return m_Format;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void VideoFormat::setWidth(unsigned int w) {
	m_Width = w;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int VideoFormat::getWidth() const {
	return m_Width;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void VideoFormat::setHeight(unsigned int h) {
	m_Height = h;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int	VideoFormat::getHeight() const {
	return m_Height;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void VideoFormat::setFormat(VideoFormat::Format f) {
	m_Format = f;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline VideoFormat::Format VideoFormat::getFormat() const {
	return m_Format;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void VideoFormat::setAspect(float a) {
	m_Aspect = a;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline float VideoFormat::getAspect() const {
	return m_Aspect;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void VideoFormat::setSpeed(float a) {
	m_Speed = a;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline float VideoFormat::getSpeed() const {
	return m_Speed;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Format::Format() {
	m_Type = Unknown;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Format::Type Format::getType() const {
	return m_Type;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Format::setBufferSize(unsigned int i) {
	m_BufferSize = i;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int Format::getBufferSize() const {
	return m_BufferSize;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Format::setBitrate(unsigned int b) {
	m_Bitrate = b;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int	Format::getBitrate() const {
	return m_Bitrate;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Format::setCodec(const char* c) {
	m_Codec = c;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const String& Format::getCodec() const {
	return m_Codec;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline AudioFormat&	Format::audio() {
	ASSERT(m_Type == Audio);
	return m_Audio;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const AudioFormat& Format::audio() const {
	ASSERT(m_Type == Audio);
	return m_Audio;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline VideoFormat&	Format::video() {
	ASSERT(m_Type == Video);
	return m_Video;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const VideoFormat& Format::video() const {
	ASSERT(m_Type == Video);
	return m_Video;
}

}; };

#endif
