/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_GRAPH_INL
#define __MEDIA_GRAPH_INL

namespace magnum { namespace media {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Graph::contains(Node* node) const {
	return m_Nodes.contains(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graph::Iterator Graph::begin() const {
	return m_Nodes.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graph::Iterator Graph::end() const {
	return m_Nodes.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Graph::isEmpty() const {
	return m_Nodes.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Graph::getSize() const {
	return m_Nodes.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graph::State Graph::getState() const {
	return m_State;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Graph::connect(InputPin* dst, OutputPin* src) {
	return connect(src,dst);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Graph::connect(InputPin* src, OutputPin* dst, const Format& fmt) {
	return connect(dst, src, fmt);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Graph::disconnect(InputPin* dst, OutputPin* src) {
	return disconnect(src,dst);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Graph::insertListener(MediaListener* l) {
	m_Dispatcher.insert(l);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Graph::removeListener(MediaListener* l) {
	m_Dispatcher.remove(l);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool Graph::containsListener(MediaListener* l) const {
	return m_Dispatcher.contains(l);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Graph::clearListeners() {
	m_Dispatcher.clear();
}

}; };

#endif
