/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_LISTENER_H
#define __MEDIA_LISTENER_H

#include "application.listener.h"

namespace magnum { namespace media {
using magnum::application::Listener;

class Graph;
class Node;
class InputPin;
class OutputPin;

/*--------------------------------------------------------------------------*/
/**
 */
class MediaListener : public Listener<MediaListener> {
friend class Graph;
protected:
	virtual void		onStart(Graph* );
	virtual void		onStop(Graph* );
	virtual void		onPause(Graph* );
	virtual void		onResume(Graph* );
	virtual void		onReset(Graph* );
	
	virtual void		onEndOfInput(Graph* ,InputPin* );
	virtual void		onEndOfOutput(Graph* ,OutputPin* );
};

}; };

#endif
