/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_MESSAGE_INL
#define __MEDIA_MESSAGE_INL

namespace magnum { namespace media {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(unsigned int cmd) {
	m_Command = cmd;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(unsigned int cmd,Pin* pin) {
	m_Command = cmd;
	m_Pin = pin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message::Message(unsigned int cmd,Pin* pin,void* parm) {
	m_Command = cmd;
	m_Pin = pin;
	m_Pointer = parm;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Message::setCommand(unsigned int cmd) {
	m_Command = cmd;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Message::getCommand() const {
	return m_Command;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Message::setPin(Pin* pin) {
	m_Pin = pin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Pin* Message::getPin() const {
	return m_Pin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Message::setPointer(void* parm) {
	m_Pointer = parm;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void* Message::getPointer() const {
	return m_Pointer;
}
		

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Message::setFloat(float parm) {
	m_Float = parm;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Message::getFloat() const {
	return m_Float;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Message::setInteger(int parm) {
	m_Integer = parm;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int Message::getInteger() const {
	return m_Integer;
}

}; };

#endif
