/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_PIN_INL
#define __MEDIA_PIN_INL

namespace magnum { namespace media {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Pin::Pin(Node* node) {
	ASSERT(node != NULL);
	m_Node = node;
	m_Connection = NULL;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Pin* Pin::getConnection() const {
	return m_Connection;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graph* Pin::getGraph() const {
	return m_Node->getGraph();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node* Pin::getNode() const {
	return m_Node;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Format& Pin::getFormat() const {
	return m_Format;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Pin::isConnected() const {
	return (m_Connection != NULL);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputPin* OutputPin::getConnection() const {
	return (InputPin *)Pin::getConnection();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline OutputPin* InputPin::getConnection() const {
	return (OutputPin *)Pin::getConnection();
}



}; };
#endif
