/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_READER_OGG_H
#define __MEDIA_READER_OGG_H

#include "media.reader.h"

#include <vorbis/vorbisfile.h>

namespace magnum { namespace media {
using magnum::types::int64;

/*--------------------------------------------------------------------------*/
/**
 */
class ReaderOGG : public Reader {
DeclareClass(ReaderOGG, Reader);
public:
	ReaderOGG(File* );
	ReaderOGG(InputStream* );
	~ReaderOGG();
	
protected:
	virtual bool	onSetFormat(const Format& );
	virtual bool	onAdjustFormat(Format& );
	virtual bool	onRead(Buffer* );
	virtual bool	onReset();

private:
	bool			openFile();
	bool			setupFormat();
	
	static size_t	file_read_func(void *ptr, size_t size, size_t nmemb, void *datasource);
	static int		file_seek_func(void *datasource, ogg_int64_t offset, int whence);
	static int		file_close_func(void *datasource);
	static long		file_tell_func(void *datasource);	

	static size_t	stream_read_func(void *ptr, size_t size, size_t nmemb, void *datasource);
	static int		stream_seek_func(void *datasource, ogg_int64_t offset, int whence);
	static int		stream_close_func(void *datasource);
	static long		stream_tell_func(void *datasource);	

private:
	OggVorbis_File	m_File;
	int				m_Wordsize;
	int				m_Signed;
	int64			m_FileStart;
};

}; };

#endif
