/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_READER_WAV_H
#define __MEDIA_READER_WAV_H

#include "media.reader.h"


namespace magnum { namespace media {
using magnum::types::dword;
using magnum::types::word;
using magnum::types::int64;

/*--------------------------------------------------------------------------*/
/**
 */
class ReaderWAV : public Reader {
DeclareClass(ReaderWAV, Reader);
public:
	ReaderWAV(File* );
	ReaderWAV(InputStream* );
	~ReaderWAV();
	
protected:
	virtual bool	onSetFormat(const Format& );
	virtual bool	onAdjustFormat(Format& );
	virtual bool	onRead(Buffer* );
	virtual bool	onReset();

private:
	bool			openFile();
	bool			setupFormat();
	
private:
	struct RIFFHeader {
		dword		m_ChunkId;
		dword		m_ChunkSize;
		dword		m_Format;
	};

	struct ChunkHeader {
		dword		m_ChunkId;
		dword		m_ChunkSize;
	};

	struct FormatHeader {
		word		m_Format;
		word		m_Channels;
		dword		m_SampleRate;
		dword		m_ByteRate;
		word		m_BlockAlign;
		word		m_BitDepth;
	};
	
	FormatHeader*	m_Format;
	unsigned int	m_DataLeft;
	unsigned int	m_ListLeft;
	int64			m_FileStart;
};

}; };

#endif
