/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __MEDIA_VIDEO_INL
#define __MEDIA_VIDEO_INL

namespace magnum { namespace media {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline VideoProducer* VideoDevice::createInput() {
	return (VideoProducer *)Device::createNode(Node::DefaultInput);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline VideoConsumer* VideoDevice::createOutput() {
	return (VideoConsumer *)Device::createNode(Node::DefaultOutput);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline VideoProducer::VideoProducer(Device* dev, const char*name) : Node(dev, name, Node::Input) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline VideoConsumer::VideoConsumer(Device* dev, const char*name) : Node(dev, name, Node::Output) {
}

}; };

#endif
