/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_HTTPCLIENT_H
#define __NET_HTTPCLIENT_H

#include "container.chain.h"
#include "net.httprequest.h"
#include "net.httpresponse.h"

namespace magnum { namespace net {
using magnum::container::Chain;

class HttpClientConnection;

/*--------------------------------------------------------------------------*/
/**
 */
class HttpClient : public Object, private magnum::object::Noncopyable {
DeclareClass(HttpClient, Object);
public:
	HttpResponse			request(const HttpRequest& );
	
private:
	HttpClientConnection*	getConnection(const HttpRequest& );
	
private:
	Chain<HttpClientConnection> m_Connections;	
};

}; };

#endif
