/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_HTTPCLIENTCONNECTION_H
#define __NET_HTTPCLIENTCONNECTION_H

#include "container.chain.h"
#include "net.streamsocket.h"
#include "net.httpinputstream.h"

namespace magnum { namespace net {
using magnum::container::Chainable;

class HttpClient;
class URL;
class HttpRequest;
class HttpResponse;

/*--------------------------------------------------------------------------*/
/**
 */
class HttpClientConnection : public Object, private Chainable<HttpClientConnection>, private magnum::object::Noncopyable {
DeclareClass(HttpClientConnection, Object);
friend class HttpClient;
private:
	HttpClientConnection(HttpClient* );
	
public:
	HttpClientConnection();
	~HttpClientConnection();
	
	inline HttpClient*		getClient() const;
	inline HttpInputStream*	getInputStream() const;
	inline StreamSocket*	getSocket();
	
	inline bool				isConnected();
	bool					connect(const URL& );
	bool					disconnect();

	HttpResponse			request(const HttpRequest& );
	inline bool				isBusy() const;

	
private:
	StreamSocket			m_Socket;
	HttpInputStream*		m_Stream;
	HttpClient*				m_Client;
};


}; };

#endif
