/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_HTTPCLIENTCONNECTION_INL
#define __NET_HTTPCLIENTCONNECTION_INL

namespace magnum { namespace net {

/*--------------------------------------------------------------------------*/
/**
 */
inline HttpClient* HttpClientConnection::getClient() const {
	return m_Client;
}


/*--------------------------------------------------------------------------*/
/** Returns the input stream of the last connection made with this
 * object. Note that every new request will result in a new input
 * stream being created.
 */
inline HttpInputStream*	HttpClientConnection::getInputStream() const {
	return m_Stream;
}


/*--------------------------------------------------------------------------*/
/** Returns the underlaying socket of this connection. The socket of
 * a connection will never change during its life time.
 */
inline StreamSocket* HttpClientConnection::getSocket() {
	return &m_Socket;
}


/*--------------------------------------------------------------------------*/
/** Returns if this connection is currently used for receiving data, or
 * if the connection is idle and might be reused by HttpClient
 */
inline bool HttpClientConnection::isBusy() const {
	if (m_Stream == NULL)
		return false;
	return (m_Stream->available() != 0);
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpClientConnection::isConnected() {
	return m_Socket.isConnected();
}

}; };

#endif
