/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_HTTPREQUEST_H
#define __NET_HTTPREQUEST_H

#include "net.url.h"
#include "net.mimeheaders.h"
#include "net.httpversion.h"

namespace magnum { namespace net {

/*--------------------------------------------------------------------------*/
/**
 */
class HttpRequest : public Object {
DeclareClass(HttpRequest, Object);
public:
	HttpRequest();
	HttpRequest(const URL& );
	
	inline unsigned int		getConnectionTimeout() const;
	inline unsigned int		getTimeout() const;
	inline void				setConnectionTimeout(unsigned int );
	inline void				setTimeout(unsigned int );
	
	inline const HttpVersion& getVersion() const;
	inline void				setVersion(const HttpVersion& );

	inline const URL&		getURL() const;
	inline void				setURL(const URL& );
	
	inline const String&	getMethod() const;
	inline void				setMethod(const char* );
	
	inline void				setHeaders(const MimeHeaders& );
	inline MimeHeaders&		getHeaders();
	inline const MimeHeaders& getHeaders() const;
	
private:
	URL						m_Url;
	MimeHeaders				m_Headers;
	unsigned int			m_ConnectionTimeout;
	unsigned int			m_Timeout;
	String					m_Method;
	HttpVersion				m_Version;
};

}; };

#endif
