/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_HTTPRESPONSE_INL
#define __NET_HTTPRESPONSE_INL

namespace magnum { namespace net {

/*--------------------------------------------------------------------------*/
/**
 */
inline const URL& HttpResponse::getURL() const {
	return m_Url;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void HttpResponse::setURL(const URL& u) {
	m_Url = u;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void HttpResponse::setCode(HttpResponse::ResponseCode c) {
	m_Response = c;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline HttpResponse::ResponseCode HttpResponse::getCode() const {
	return m_Response;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const HttpVersion& HttpResponse::getVersion() const {
	return m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void HttpResponse::setVersion(const HttpVersion& v) {
	m_Version = v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const String& HttpResponse::getMethod() const {
	return m_Method;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void HttpResponse::setMethod(const char* m) {
	m_Method = m;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void HttpResponse::setHeaders(const MimeHeaders& h) {
	m_Headers = h;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline MimeHeaders& HttpResponse::getHeaders() {
	return m_Headers;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const MimeHeaders& HttpResponse::getHeaders() const {
	return m_Headers;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void HttpResponse::setInputStream(InputStream* is) {
	m_InputStream = is;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline InputStream* HttpResponse::getInputStream() {
	return m_InputStream;
}

}; };

#endif
