/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_HTTPVERSION_H
#define __NET_HTTPVERSION_H

namespace magnum { namespace net {

/*--------------------------------------------------------------------------*/
/**
 */
class HttpVersion {
public:
	enum Version {
		Unknown,  	 
  		Http_0_9,  	
  		Http_1_0,  	
  		Http_1_1
	};
	
public:
	inline HttpVersion();
	inline HttpVersion(Version );
	inline HttpVersion(unsigned int ,unsigned int );

	inline void			setVersion(Version );
	inline Version		getVersion() const;
	
	inline bool			operator==(const HttpVersion& ) const;
	inline bool			operator==(Version ) const;
	inline bool			operator!=(const HttpVersion& ) const;
	inline bool			operator!=(Version ) const;
	inline bool			operator<(const HttpVersion& ) const;
	inline bool			operator<(Version ) const;
	inline bool			operator<=(const HttpVersion& ) const;
	inline bool			operator<=(Version ) const;
	inline bool			operator>(const HttpVersion& ) const;
	inline bool			operator>(Version ) const;
	inline bool			operator>=(const HttpVersion& ) const;
	inline bool			operator>=(Version ) const;
	
private:
	Version				m_Version;
};

}; };

#endif
