/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_HTTPVERSION_INL
#define __NET_HTTPVERSION_INL

namespace magnum { namespace net {

/*--------------------------------------------------------------------------*/
/**
 */
inline HttpVersion::HttpVersion() : m_Version(HttpVersion::Http_1_1) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline HttpVersion::HttpVersion(HttpVersion::Version v) : m_Version(v) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline HttpVersion::HttpVersion(unsigned int major,unsigned int minor) {
	if (major == 1) {
		if (minor == 0)
			m_Version = Http_1_0;
		else if (minor == 1)
			m_Version = Http_1_1;
		else
			m_Version = Unknown;
	} else if ((minor == 0) && (major == 9)) {
		m_Version = Http_0_9;
	} else {
		m_Version = Unknown;
	}
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void HttpVersion::setVersion(HttpVersion::Version v) {
	m_Version = v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline HttpVersion::Version HttpVersion::getVersion() const {
	return m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator==(const HttpVersion& v) const {
	return m_Version == v.m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator==(HttpVersion::Version v) const {
	return m_Version == v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator!=(const HttpVersion& v) const {
	return m_Version != v.m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator!=(HttpVersion::Version v) const {
	return m_Version != v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator<(const HttpVersion& v) const {
	return m_Version < v.m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator<(HttpVersion::Version v) const {
	return m_Version < v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator<=(const HttpVersion& v) const {
	return m_Version <= v.m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator<=(HttpVersion::Version v) const {
	return m_Version <= v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator>(const HttpVersion& v) const {
	return m_Version > v.m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator>(HttpVersion::Version v) const {
	return m_Version > v;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator>=(const HttpVersion& v) const {
	return m_Version >= v.m_Version;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline bool HttpVersion::operator>=(HttpVersion::Version v) const {
	return m_Version >= v;
}

}; };

#endif
