/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_MIMEHEADERS_H
#define __NET_MIMEHEADERS_H

#include "container.list.h"
#include "container.pair.h"
#include "io.outputstream.h"

namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::List;
using magnum::container::ListAllocator;
using magnum::container::Pair;
using magnum::io::OutputStream;

/*--------------------------------------------------------------------------*/
/**
 */
class MimeHeaders : public Object {
DeclareClass(MimeHeaders, Object);
public:
	typedef List<Pair<String, String>, ListAllocator<Pair<String, String>,16> >::Iterator Iterator;
	
public:
	void				insert(const char* ,const char* ); 
	void				remove(const char* );
	bool				contains(const char* );
	const char*			find(const char* ) const;
	
	inline bool			isEmpty() const;
	inline unsigned int	getSize() const;
	
	inline Iterator		begin() const;
	Iterator			at(const char* ) const;
	inline Iterator		end() const;
	
	inline void			writeTo(OutputStream& ) const;
	void				writeTo(OutputStream* ) const;

private:
	List<Pair<String, String>, ListAllocator<Pair<String, String>,16> > m_Headers;
};

}; };

#endif
