/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_MULTICASTSOCKET_H
#define __NET_MULTICASTSOCKET_H

#include "net.datagramsocket.h"

namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MulticastSocket : public DatagramSocket {
DeclareClass(MulticastSocket, DatagramSocket);
private:
	Address				m_Interface;

public:
	inline MulticastSocket();
	inline MulticastSocket(unsigned int port);

	inline unsigned int		getTimeToLive() const;
	inline void				setTimeToLive(unsigned int ttl);

	inline bool				getLoopback() const;
	inline void				setLoopback(bool b);

	const Address&			getInterface();
	void					setInterface(const Address& adr);

	bool					joinGroup(const Address& adr);
	bool					leaveGroup(const Address& adr);
};

}; };
#endif
