/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_SERVER_INL
#define __NET_SERVER_INL

namespace magnum { namespace net {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	Server::bind(const Address& localAdr, unsigned int localPort) {
	return m_Socket.bind(localAdr, localPort);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Server::bind(const String& localAdr, unsigned int localPort) {
	return m_Socket.bind(localAdr, localPort);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	Server::bind(unsigned int localPort) {
	return m_Socket.bind(localPort);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	Server::listen(unsigned int logback) {
	return m_Socket.listen(logback);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Server::getPort() const {
	return m_Socket.getPort();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ServerThread::disconnect() {
	m_Socket->disconnect();
	m_Socket->release();
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputStream* ServerThread::getInputStream() {
	return m_Socket->getInputStream();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ServerThread::shutdownInput() {
	m_Socket->shutdownInput();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline OutputStream* ServerThread::getOutputStream() {
	return m_Socket->getOutputStream();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	ServerThread::shutdownOutput() {
	m_Socket->shutdownOutput();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ServerThread::getSendBufferSize() const {
	return m_Socket->getSendBufferSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ServerThread::setSendBufferSize(unsigned int size) {
	m_Socket->setSendBufferSize(size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ServerThread::getReceiveBufferSize() const {
	return m_Socket->getReceiveBufferSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	ServerThread::setReceiveBufferSize(unsigned int size) {
	m_Socket->setReceiveBufferSize(size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Address& ServerThread::getAddress() const {
	return m_Socket->getAddress();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ServerThread::getPort() const {
	return m_Socket->getPort();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Address& ServerThread::getLocalAddress() const {
	return m_Socket->getLocalAddress();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ServerThread::getLocalPort() const {
	return m_Socket->getLocalPort();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ServerThread::wait(Socket::WaitMode mode) {
	return m_Socket->wait(mode);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool ServerThread::wait(Socket::WaitMode mode, unsigned int millis) {
	return m_Socket->wait(mode, millis);
}

}; };
#endif
