/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_SERVERSOCKET_H
#define __NET_SERVERSOCKET_H

#include "net.socket.h"


namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;

class Socket;
class StreamSocket;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ServerSocket : public Object {
DeclareClass(ServerSocket, Object);
private:
	Address				m_Address;
	unsigned short		m_Port;
	SOCKET				m_Socket;
	unsigned int		m_SelectIndex;

public:
	ServerSocket();
	~ServerSocket();

	bool					bind(const Address& lcoalAdr, unsigned int localPort);
	bool					bind(const String& lcoalAdr, unsigned int localPort);
	bool					bind(unsigned int localPort);

	inline bool				listen(unsigned int backlog);
	StreamSocket*			accept();
	bool					wait();
	bool					wait(unsigned int millis);

	inline const Address&	getAddress() const;
	inline unsigned int		getPort() const;

	inline bool				getKeepAlive() const;
	inline void				setKeepAlive(bool val);

	inline bool				getNoDelay() const;
	inline void				setNoDelay(bool val);

	inline unsigned int		getSendTimeout() const;
	inline void				setSendTimeout(unsigned int to);

	inline unsigned int		getReceiveTimeout() const;
	inline void				setReceiveTimeout(unsigned int to);

	inline unsigned int		getSendBufferSize() const;
	inline void				setSendBufferSize(unsigned int size);

	inline unsigned int		getReceiveBufferSize() const;
	inline void				setReceiveBufferSize(unsigned int size);
};

/*

int getSoTimeout() 
          Retrive setting for SO_TIMEOUT. 
void setSoTimeout(int timeout) 
          Enable/disable SO_TIMEOUT with the specified timeout, in milliseconds. 
*/

}; };
#endif
