/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_SOCKETSTREAM_H
#define __NET_SOCKETSTREAM_H

#include "io.inputstream.h"
#include "io.outputstream.h"

namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;
using magnum::types::int64;
using magnum::io::InputStream;
using magnum::io::OutputStream;

class Socket;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SocketInputStream : public InputStream {
DeclareClass(SocketInputStream, InputStream);
public:
	SocketInputStream(Socket* );
	~SocketInputStream();
	
	inline Socket*	getSocket() const;

protected:
	size_t			onRead(void *buffer, size_t size);
	size_t			onSkip(size_t size);
	int64			onAvailable();
	bool			onClose();

private:
	Socket*			m_Socket;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SocketOutputStream : public OutputStream {
DeclareClass(SocketOutputStream, OutputStream);
public:
	SocketOutputStream(Socket* );
	~SocketOutputStream();

	inline Socket*	getSocket() const;

protected:
	size_t			onWrite(const void *buffer, size_t size);
	bool			onFlush();
	bool			onClose();

private:
	Socket*			m_Socket;
};

}; };

#endif
