/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_URL_H
#define __NET_URL_H

#include "object.h"
#include "base.string.h"


namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;

/*--------------------------------------------------------------------------*/
/**
 */
class URL : public Object {
DeclareClass(URL, Object);
public:
	URL();
	explicit URL(const char* );
	URL(const URL& ,const char* );
	URL(const char* prot, const char* host);
	URL(const char* prot, const char* host, const char* file);
	URL(const char* prot, const char* host, unsigned int port, const char* file);

	void			setProtocol(const char* );
	inline const String& getProtocol() const;
	
	void			setHost(const char* );
	inline const String& getHost() const;
	bool			isHostNumeric() const;
	
	void			setFile(const char* );
	inline const String& getFile() const;
	
	void			setPath(const char* );
	inline const String& getPath() const;

	inline void		setPort(unsigned int );	
	inline unsigned int	getPort() const;

	void			setQuery(const char* );
	inline const String& getQuery() const;
	
private:
	void			buildQuery();
		
private:
	String			m_Query;
	String			m_Protocol;
	String			m_Host;
	String			m_File;
	String			m_Path;
	unsigned int	m_Port;
	bool			m_Dirty;
};

}; };

#endif
