/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __NET_URL_INL
#define __NET_URL_INL

namespace magnum { namespace net {


/*--------------------------------------------------------------------------*/
/**
 */
inline const String& URL::getProtocol() const {
	return m_Protocol;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const String& URL::getHost() const {
	return m_Host;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const String& URL::getFile() const {
	return m_File;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const String& URL::getPath() const {
	return m_Path;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void URL::setPort(unsigned int p) {
	m_Port = p;
	m_Dirty = true;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int	URL::getPort() const {
	return m_Port;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const String& URL::getQuery() const {
	if (m_Dirty)
		const_cast<URL*>(this)->buildQuery();
	return m_Query;
}

}; };

#endif
