/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __OBJECT_EXCEPTION_H
#define __OBJECT_EXCEPTION_H

#include "object.h"
#include "base.string.h"

namespace magnum { namespace object {
using magnum::object::Object;
using magnum::types::String;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Exception : public Object {
DeclareClass(Exception, Object);
private:
	String		m_Message;

public:
	inline Exception();
	inline Exception(const String& string);
	inline Exception(const char* string);

	inline String		getName() const;
	inline String		toString() const;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
#define DeclareException(Exception, base)											\
	class Exception : public base {													\
		DeclareClass(Exception, base);												\
		public:																		\
			inline Exception() : base(#Exception) {};								\
			inline Exception(const String& string) : base(string) {};				\
			inline Exception(const char* string) : base(string) {};					\
																					\
			inline String		getName() const {return String(#Exception);};		\
	};

}; };
#endif
