/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __OBJECT_TRAITS_H
#define __OBJECT_TRAITS_H

namespace magnum { namespace object {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Noncopyable {
protected:
	inline Noncopyable(){}
	inline ~Noncopyable(){}

private: 
	Noncopyable( const Noncopyable& );
	const Noncopyable& operator=( const Noncopyable& );
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Nonassignable {
protected:
	inline Nonassignable(){}
	inline ~Nonassignable(){}
	inline Nonassignable( const Nonassignable& ) {};

private: 
	const Nonassignable& operator=( const Nonassignable& );
};

}; };

#endif
