/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __PLOTS3D_FUNCTIONPLOT3D_INL
#define __PLOTS3D_FUNCTIONPLOT3D_INL

namespace magnum { namespace plots3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class F>
void FunctionPlot3d::plot(const F& fn,const Vector2<float> mi,const Vector2<float> ma) {
	beginPlot();
	
	unsigned int width = getResolution().x;
	unsigned int height = getResolution().y;

	const float dx = (ma.x - mi.x) / width;
	const float dy = (ma.y - mi.y) / height;
	
	Vertex* vertex = getVertices();
	for (unsigned int i = 0; i < height; i++) {
		Vector2<float> arg;
		arg.y = mi.y + i*dy;
		for (unsigned int j = 0; j < width; j++) {
			arg.x = mi.x + j*dx;
			vertex->position.x = arg.x;
			vertex->position.y = arg.y;
			vertex->position.z = (float)fn(arg);
			vertex->normal.null();
			vertex++;
		}
	}

	finishPlot();
}


}; };

#endif
