/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __PLOTS3D_LINEPLOT3D_H
#define __PLOTS3D_LINEPLOT3D_H

#include "container.array.h"
#include "math.function.h"
#include "math.vector3.h"
#include "graphics3d.vertexmesh.h"
#include "plots3d.plot3d.h"

namespace magnum { namespace plots3d {
using magnum::container::Array;
using magnum::math::Function;
using magnum::math::Vector3;
using magnum::graphics3d::VertexMesh;
using magnum::graphics3d::VertexBuffer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class LinePlot3d : public Plot3d {
DeclareClass(LinePlot3d, Plot3d);
public:
	struct Vertex {
		Vector3<float>	position;
	};
	
public:
	LinePlot3d();
	
	inline void			setResolution(unsigned int );
	inline unsigned int	getResolution() const;

protected:
	virtual void		onRender(const Matrix4<float>& ) const;
	virtual void		onClear();
	
	void				beginPlot();	
	void				finishPlot();
	
	inline Vertex*		getVertices();
	
private:
	unsigned int			m_Resolution;
	unsigned int			m_OldResolution;
	VertexMesh				m_Mesh;
	Array<Vertex>			m_Vertices;
	Vector3<float>			m_Minimum;
	Vector3<float>			m_Maximum;
};

}; };

#endif
