/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __PLOTS3D_PARAMETRICPLOT3D_INL
#define __PLOTS3D_PARAMETRICPLOT3D_INL

namespace magnum { namespace plots3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class F>
void ParametricPlot3d::plot(const F& fn,float mi,float ma) {
	beginPlot();

	unsigned int size = getResolution();
	const float dt = (ma - mi) / size;
	
	Vertex* vertex = getVertices();
	for (unsigned int i = 0; i < size; i++) {
		vertex->position = (Vector3<float>)fn(mi + i*dt);
		vertex++;
	}

	finishPlot();
}

}; };

#endif
