/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __PLOTS3D_PLOT_H
#define __PLOTS3D_PLOT_H

#include "object.pointer.h"
#include "math.matrix.h"
#include "graphics3d.resource.h"
#include "graphics3d.appearance.h"

namespace magnum { namespace plots3d {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;
using magnum::math::Matrix4;
using magnum::graphics3d::Resource;
using magnum::graphics3d::Appearance;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Plot : public Resource {
DeclareClass(Plot, Resource);
public:
	Plot();
	
	inline void			render(const Matrix4<float>& ) const;
	inline void			clear();
	
	inline void			attachAppearance(Appearance* );
	inline void			detachAppearance();
	inline Appearance*	getAppearance() const;
	
protected:
	virtual void		onRender(const Matrix4<float>& ) const;
	virtual void		onClear();
	
private:
	Pointer<Appearance>	m_Appearance;
};

}; };

#endif
