/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __PLOTS3D_PLOT_INL
#define __PLOTS3D_PLOT_INL

namespace magnum { namespace plots3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Plot::attachAppearance(Appearance* a) {
	ASSERT(a != NULL);
	m_Appearance = a;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Plot::detachAppearance() {
	m_Appearance.setNull();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Appearance* Plot::getAppearance() const {
	return m_Appearance;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Plot::render(const Matrix4<float>& mtx) const {
	onRender(mtx);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Plot::clear() {
	onClear();
}

}; };

#endif
