/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __PLOTS3D_SURFACEPLOT3D_INL
#define __PLOTS3D_SURFACEPLOT3D_INL

namespace magnum { namespace plots3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SurfacePlot3d::setResolution(const Vector2<unsigned int>& v) {
	m_Resolution = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SurfacePlot3d::setResolution(unsigned int r) {
	m_Resolution.x = m_Resolution.y = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void SurfacePlot3d::setResolution(unsigned int x,unsigned int y) {
	m_Resolution.x = x;
	m_Resolution.y = y;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector2<unsigned int>& SurfacePlot3d::getResolution() const {
	return m_Resolution;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline SurfacePlot3d::Vertex* SurfacePlot3d::getVertices() {
	return &m_Vertices[0];
}


}; };

#endif
