/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __PLOTS3D_VOLUMEPLOT3D_H
#define __PLOTS3D_VOLUMEPLOT3D_H

#include "object.pointer.h"
#include "grid.grid3d.h"
#include "graphics3d.texture3d.h"
#include "graphics3d.vertexmesh.h"
#include "plots3d.plot3d.h"

namespace magnum { namespace plots3d {
using magnum::grid::Grid3d;
using magnum::object::Pointer;
using magnum::graphics3d::Texture3D;
using magnum::graphics3d::VertexMesh;
using magnum::graphics3d::VertexBuffer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class VolumePlot3d : public Plot3d {
DeclareClass(VolumePlot3d, Plot3d);
public:
	VolumePlot3d();
	
	template<class T>
	void				plot(const Grid3d<T>* );

	void				setResolution(unsigned int );
	inline unsigned int	getResolution() const;

protected:
	virtual void		onRender(const Matrix4<float>& ) const;
	virtual void		onClear();
	
private:
	VertexMesh			m_Mesh;
	Pointer<Texture3D>	m_Texture;
	unsigned int		m_Resolution;
};

}; };

#endif
