/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_ACTIVATOR_H
#define __SCENE3D_ACTIVATOR_H

#include "scene3d.behaviour.h"
#include "geometry.transform.h"
#include "geometry.alignedbox.h"
#include "math.vector3.h"

namespace magnum { namespace scene3d { 
using magnum::object::Object;
using magnum::types::String;
using magnum::geometry::Transform3;
using magnum::geometry::AlignedBox3;
using magnum::math::Vector3;

class Locale;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Activator : public Behaviour {
DeclareClass(Activator, Behaviour);
protected:
	Activator(const Activator& );
public:
	inline Activator();
	
	inline void			setTransform(const Transform3<float>& );
	inline const Transform3<float>& getTransform() const;
	inline const Transform3<float>& getWorldTransform() const;

	inline const AlignedBox3<float>& getVolume() const;

protected:
	virtual Activator*	onClone() const;
	virtual void		onAttachLocale(Locale* );
	virtual void		onDetachLocale(Locale* );
	virtual void		onEnable();
	virtual void		onDisable();
	virtual void		onTransform(const Transform3<float>& );

private:
	Transform3<float>	m_Transform;
	Transform3<float>	m_WorldTransform;
	AlignedBox3<float>	m_Volume;
};

}; };

#endif
