/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_BEHAVIOUR_INL
#define __SCENE3D_BEHAVIOUR_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Behaviour::Behaviour(const Behaviour& b) : Leaf<Behaviour>(b) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Behaviour::Behaviour() : Leaf<Behaviour>(Node::BehaviourType) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Behaviour::Behaviour(Behaviour::Type t) : Leaf<Behaviour>((Node::Type)(Node::BehaviourType | t)) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Behaviour::isActive() const {
	return m_Active;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Behaviour::isScheduled() const {
	return (getScheduler() != NULL);
}

}; };

#endif
