/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_BEHAVIOURSCHEDULER_H
#define __SCENE3D_BEHAVIOURSCHEDULER_H

#include "system.timer.h"
#include "container.scheduler.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::object::Noncopyable;
using magnum::types::String;
using magnum::container::Scheduler;

class Behaviour;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class BehaviourScheduler : public Object, public Noncopyable {
DeclareClass(BehaviourScheduler, Object);
public:
	inline BehaviourScheduler();
	inline ~BehaviourScheduler();

	inline void			insert(Behaviour* );
	inline void			remove(Behaviour* );
	inline bool			contains(const Behaviour* ) const;

	void				clear();
	
	void				process(const Timer& );

private:
	Scheduler<Behaviour> m_ActiveBehaviours;
};


}; };

#endif
