/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_BEHAVIOURSCHEDULER_INL
#define __SCENE3D_BEHAVIOURSCHEDULER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BehaviourScheduler::BehaviourScheduler() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline BehaviourScheduler::~BehaviourScheduler() {
	clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void BehaviourScheduler::insert(Behaviour* node) {
	node->m_Active = true;
	if (node->getScheduler() != NULL)
		return;
	node->m_WasActive = false;
	m_ActiveBehaviours.insert(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	BehaviourScheduler::remove(Behaviour* node) {
	node->m_Active = false;
	node->m_WasActive = false;
	m_ActiveBehaviours.remove(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	BehaviourScheduler::contains(const Behaviour* m) const {
	return m_ActiveBehaviours.contains(m);
}

}; };

#endif
