/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_CONTROLLER_H
#define __SCENE3D_CONTROLLER_H

#include "object.pointer.h"
#include "scene3d.behaviour.h"

namespace magnum { namespace scene3d {
using magnum::object::Pointer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Controller : public Behaviour {
DeclareClass(Controller, Behaviour);
protected:
	inline Controller(const Controller& );
	inline Controller();
	inline explicit Controller(T* );

public:
	inline void			setTarget(T* );
	inline T*			getTarget() const;

protected:
	virtual Controller*	onClone() const;

protected:
	Pointer<T>			m_Target;
};

}; };

#endif
