/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_CONTROLLER_INL
#define __SCENE3D_CONTROLLER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline Controller<T>::Controller() : Behaviour(Behaviour::ControllerType) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline Controller<T>::Controller(const Controller& c) 
	: Behaviour(c), 
	m_Target(c.m_Target) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline Controller<T>::Controller(T* t) : Behaviour(Behaviour::ControllerType) {
	ASSERT(t != NULL);
	m_Target = t;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline void Controller<T>::setTarget(T* m) {
	ASSERT(m != NULL);
	m_Target = m;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline T* Controller<T>::getTarget() const {
	return m_Target;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
Controller<T>* Controller<T>::onClone() const {
	return new Controller(*this);
}

}; };

#endif
