/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_CUBEMAPGENERATOR_H
#define __SCENE3D_CUBEMAPGENERATOR_H

#include "object.pointer.h"
#include "graphics3d.camera.h"
#include "graphics3d.cubemapgenerator.h"
#include "scene3d.node.h"
#include "scene3d.graphicscontext.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;
using magnum::math::Matrix4;
using magnum::graphics3d::Camera;
using magnum::graphics3d::CubeTexture;

class Marker;

/*--------------------------------------------------------------------------*/
/**
 */
class CubemapGenerator : public magnum::graphics3d::CubemapGenerator {
DeclareClass(CubemapGenerator, magnum::graphics3d::CubemapGenerator);
public:
	CubemapGenerator(Universe* ,magnum::graphics3d::Context* );
		
	inline Marker*			getMarker() const;
	inline void				attachMarker(Marker* );
	inline void				detachMarker();
	
	inline Universe*		getUniverse() const;

	void					render();
	
protected:
	virtual void			onRender(const Matrix4<float>& ,CubeTexture::Face );
	
private:
	Pointer<Marker>			m_Marker;
	Pointer<Universe>		m_Universe;
	GraphicsContext			m_GraphicsContext;
};

}; };

#endif
