/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_DIRECTIONCONTROLLER_H
#define __SCENE3D_DIRECTIONCONTROLLER_H

#include "scene3d.controller.h"

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class DirectionController : public Controller<T> {
DeclareClass(DirectionController, Controller<T>);
protected:
	inline DirectionController(const DirectionController& );

public:
	inline DirectionController();
	inline explicit DirectionController(T* );

	inline void				setRotation(const Vector3<float>& );
	inline Vector3<float>	getRotation() const;

	inline void				setVelocity(const Vector3<float>& );
	inline Vector3<float>	getVelocity() const;

protected:
	virtual DirectionController* onClone() const;
	virtual void			onProcess(const Timer& );

private:
	Vector3<float>		m_Velocity;
};

}; };

#endif
