/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_DIRECTIONCONTROLLER_INL
#define __SCENE3D_DIRECTIONCONTROLLER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline DirectionController<T>::DirectionController() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline DirectionController<T>::DirectionController(const DirectionController& d)
	: Controller<T>(d),
	m_Velocity(d.m_Velocity) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline DirectionController<T>::DirectionController(T* m) : Controller<T>(m) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline void DirectionController<T>::setVelocity(const Vector3<float>& v) {
	m_Velocity = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline Vector3<float> DirectionController<T>::getVelocity() const {
	return m_Velocity;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
DirectionController<T>* DirectionController<T>::onClone() const {
	return new DirectionController(*this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
void DirectionController<T>::onProcess(const Timer& ) {
	ASSERT(m_Target != NULL);
	Vector<float> t;
	m_Target->setDirection(t);
}


}; };

#endif
