/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_DIRLIGHTNODE_INL
#define __SCENE3D_DIRLIGHTNODE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline DirectionalLightNode::DirectionalLightNode() {
	attachLight(&m_Light);
	m_Direction = Vector3<float>(1, 0, 0);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline DirectionalLightNode::~DirectionalLightNode() {
	detachLight();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& DirectionalLightNode::getAmbient() const {
	return m_Light.getAmbient();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLightNode::setAmbient(const Colour<float>& c) {
	m_Light.setAmbient(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& DirectionalLightNode::getDiffuse() const {
	return m_Light.getDiffuse();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLightNode::setDiffuse(const Colour<float>& c) {
	m_Light.setDiffuse(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Colour<float>& DirectionalLightNode::getSpecular() const {
	return m_Light.getSpecular();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLightNode::setSpecular(const Colour<float>& c) {
	m_Light.setSpecular(c);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<float>& DirectionalLightNode::getDirection() const {
	return m_Direction;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void DirectionalLightNode::setDirection(const Vector3<float>& d) {
	m_Direction = d;
	updateTransform();
}

}; };

#endif
