/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_GEOMETRY_H
#define __SCENE3D_GEOMETRY_H

#include "scene3d.graphics.h"

namespace magnum { namespace scene3d {

class GraphicsContext;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Geometry : public Graphics {
DeclareClass(Geometry, Graphics);
protected:
	Geometry(const Geometry& );
	
public:
	inline Geometry();
	
	inline void			setTransform(const Transform3<float>& );
	inline const Transform3<float>& getTransform() const;
	inline const Transform3<float>& getWorldTransform() const;

protected:
	virtual Geometry*	onClone() const;
	virtual void		onTransform(const Transform3<float>& parent);
	virtual void		onRender(GraphicsContext* ,const Transform3<float>& );

private:
	Transform3<float>	m_Transform;
	Transform3<float>	m_WorldTransform;
};	

}; }; 

#endif
