/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_GRAPHICS_H
#define __SCENE3D_GRAPHICS_H

#include "geometry.ray.h"
#include "scene3d.leaf.h"

namespace magnum { namespace scene3d {
using magnum::geometry::Ray;

class GraphicsContext;
class Intersection;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Graphics : public Leaf<Graphics> {
DeclareClass(Graphics, Leaf<Graphics>);
public:
	enum Type {
		GeometryType	= 0x00000200,
		ModifierType	= 0x00000400,
		LightType		= 0x00000800,
		BackgroundType	= 0x00001000,
		AllGraphics		= 0x0000ff00,
	};
	
protected:
	inline Graphics();
	inline explicit Graphics(Type t);
	inline Graphics(const Graphics& );

public:
	inline void			render(GraphicsContext* ,const Transform3<float>& ) const;
	inline bool			intersect(const Ray<float,3>& ,Intersection* = NULL) const;

protected:	
	virtual Graphics*	onClone() const;
	virtual void		onRender(GraphicsContext* ,const Transform3<float>& ) const;
	virtual bool		onIntersect(const Ray<float,3>& ,Intersection* ) const;
};

}; };

#endif
