/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_GRAPHICS_INL
#define __SCENE3D_GRAPHICS_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graphics::Graphics() : Leaf<Graphics>(Node::GraphicsType) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graphics::Graphics(const Graphics& g) : Leaf<Graphics>(g) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graphics::Graphics(Graphics::Type t) : Leaf<Graphics>((Node::Type)(Node::GraphicsType | t)) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Graphics::render(GraphicsContext* c,const Transform3<float>& t) const {
	onRender(c,t);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Graphics::intersect(const Ray<float,3>& ray,Intersection* is) const {
	return onIntersect(ray, is);
}

}; };

#endif
