/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_GRAPHICSCONTEXT_INL
#define __SCENE3D_GRAPHICSCONTEXT_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline magnum::graphics3d::Context* GraphicsContext::getContext() {
	return m_Accelerator.getContext();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline magnum::graphics3d::Accelerator* GraphicsContext::getAccelerator() {
	return &m_Accelerator;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void GraphicsContext::insertModifier(Modifier* node) {
	if (node->getChain() != NULL)
		return;
	m_Modifiers.insert(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	GraphicsContext::removeModifier(Modifier* node) {
	m_Modifiers.remove(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	GraphicsContext::containsModifier(const Modifier* m) const {
	return m_Modifiers.contains(m);
}

}; };

#endif
