/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_IMAGEGENERATOR_H
#define __SCENE3D_IMAGEGENERATOR_H

#include "object.pointer.h"
#include "graphics3d.framebuffer.h"
#include "graphics3d.camera.h"
#include "scene3d.graphicscontext.h"
#include "scene3d.node.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;
using magnum::graphics::Rectangle;
using magnum::graphics3d::Camera;
using magnum::graphics3d::FrameBuffer;

class Viewer;

/*--------------------------------------------------------------------------*/
/**
 */
class ImageGenerator : public Object {
DeclareClass(ImageGenerator, Object);
public:
	ImageGenerator(Universe* ,magnum::graphics3d::Context* );
		
	inline void				attachViewer(Viewer* );
	inline void				detachViewer();
	inline Viewer*			getViewer() const;

	void					attachFrameBuffer(FrameBuffer* );
	inline void				detachFrameBuffer();
	inline FrameBuffer*		getFrameBuffer() const;

	inline void				setViewport(const Rectangle<float>& );
	inline const Rectangle<float>& getViewport() const;

	inline Universe*		getUniverse() const;
	
	void					render();

private:
	Pointer<FrameBuffer>	m_FrameBuffer;
	Pointer<Viewer>			m_Viewer;
	Pointer<Universe>		m_Universe;
	GraphicsContext			m_GraphicsContext;
	Rectangle<float>		m_Viewport;
};

}; };

#endif
