/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_IMAGEGENERATOR_INL
#define __SCENE3D_IMAGEGENERATOR_INL

namespace magnum { namespace scene3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Universe* ImageGenerator::getUniverse() const {
	return m_Universe;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Viewer* ImageGenerator::getViewer() const {
	return m_Viewer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ImageGenerator::attachViewer(Viewer* v) {
	ASSERT(v != NULL);
	m_Viewer = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ImageGenerator::detachViewer() {
	m_Viewer = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ImageGenerator::detachFrameBuffer() {
	m_FrameBuffer = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameBuffer* ImageGenerator::getFrameBuffer() const {
	return m_FrameBuffer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ImageGenerator::setViewport(const Rectangle<float>& r) {
	m_Viewport = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Rectangle<float>& ImageGenerator::getViewport() const {
	return m_Viewport;
}

}; };

#endif