/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_LIGHTNODE_H
#define __SCENE3D_LIGHTNODE_H

#include "object.pointer.h"
#include "scene3d.modifier.h"
#include "graphics3d.light.h"

namespace magnum { namespace scene3d {
using magnum::object::Pointer;
using magnum::graphics3d::Light;

class NodePath;
class Observer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class LightNode : public Modifier {
DeclareClass(LightNode, Modifier);
friend class Observer;
protected:
	inline LightNode(const LightNode& );
	
public:
	inline LightNode();
	inline explicit LightNode(Light* );
	inline ~LightNode();

	inline void			attachLight(Light* );
	inline void			detachLight();
	inline Light*		getLight() const;

protected:
	virtual LightNode*	onClone() const;
	virtual void		onSelect() const;
	virtual void		onDeselect() const;

private:
	Pointer<Light>		m_Light;
};


}; };

#endif
