/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_LIGHTNODE_INL
#define __SCENE3D_LIGHTNODE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline LightNode::LightNode() : Modifier(Graphics::LightType) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline LightNode::LightNode(const LightNode& l) : Modifier(l), m_Light(l.m_Light) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline LightNode::LightNode(Light* lg) : Modifier(Graphics::LightType) {
	m_Light = lg;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline LightNode::~LightNode() {
	m_Light.setNull();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void LightNode::attachLight(Light* l) {
	m_Light = l;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	LightNode::detachLight() {
	m_Light = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Light* LightNode::getLight() const {
	return m_Light;
}


}; };

#endif
