/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_LISTENER_H
#define __SCENE3D_LISTENER_H

#include "object.pointer.h"
#include "math.vector3.h"
#include "scene3d.audio.h"
#include "audio3d.listener.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;
using magnum::math::Vector3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Listener : public Audio {
DeclareClass(Listener, Audio);
protected:
	Listener(const Listener& );
	
public:
	Listener();
	
	inline magnum::audio3d::Listener* getListener();
	inline const magnum::audio3d::Listener*	getListener() const;

	inline Vector3<float>	getPosition() const;
	inline void				setPosition(const Vector3<float>& );

	inline Vector3<float>	getVelocity() const;
	inline void				setVelocity(const Vector3<float>& );

protected:
	Listener*				onClone() const;

private:
	Vector3<float>			m_Position;
	Vector3<float>			m_Velocity;
	magnum::audio3d::Listener m_Listener;
};

}; };

#endif
