/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_LISTENER_INL
#define __SCENE3D_LISTENER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline magnum::audio3d::Listener* Listener::getListener() {
	return &m_Listener;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const magnum::audio3d::Listener*	Listener::getListener() const {
	return &m_Listener;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Vector3<float> Listener::getPosition() const {
	return m_Position;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setPosition(const Vector3<float>& p) {
	m_Position = p;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Vector3<float> Listener::getVelocity() const {
	return m_Velocity;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Listener::setVelocity(const Vector3<float>& v) {
	m_Velocity = v;
}

}; };

#endif
