/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_LISTENTRAVERSER_H
#define __SCENE3D_LISTENTRAVERSER_H

#include "scene3d.traverser.h"
#include "scene3d.audiocontext.h"

namespace magnum { namespace scene3d {

class Listener;
class Universe;
class Audio;

/*------------------------------------------------------------------------
------------------------------------------------------------------------*/
class ListenTraverser : public Traverser<ListenTraverser, Audio> {
friend class Traverser<ListenTraverser, Audio>;
public:
	ListenTraverser(Universe* ,AudioContext* );

	void				traverse(const Listener* );
	
private:
	inline void			onVisit(Audio* ) const;

private:
	AudioContext*		m_Context;
};

}; };

#endif
