/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_LOCALE_INL
#define __SCENE3D_LOCALE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Universe* Locale::getUniverse() const {
	return m_Universe;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Vector3<double>& Locale::getOrigin() const {
	return m_Origin;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::setOrigin(const Vector3<double>& p) {
	m_Origin = p;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Locale::isOptimised() const {
	return m_Optimised;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Locale::isEmpty() const {
	return m_Roots.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Locale::Iterator Locale::begin() const {
	return m_Roots.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Locale::Iterator Locale::end() const {
	return m_Roots.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::insert(Graphics* l) {
	m_GraphicsSpace.insert(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::remove(Graphics* l) {
	m_GraphicsSpace.remove(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::insert(Audio* l) {
	m_AudioSpace.insert(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::remove(Audio* l) {
	m_AudioSpace.remove(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::insert(Behaviour* l) {
	m_BehaviourSpace.insert(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::remove(Behaviour* l) {
	m_BehaviourSpace.remove(l);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Locale::getSpace(const Space<float, 3, Graphics>* & s) const {
	s = &m_GraphicsSpace;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Locale::getSpace(const Space<float, 3, Audio>* & s) const {
	s = &m_AudioSpace;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Locale::getSpace(const Space<float, 3, Behaviour>* & s) const {
	s = &m_BehaviourSpace;
}

}; };

#endif
