/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_MARKER_H
#define __SCENE3D_MARKER_H

#include "scene3d.node.h"

namespace magnum { namespace scene3d {

/*--------------------------------------------------------------------------*/
/**
 */
class Marker : public Node {
DeclareClass(Marker, Node);
protected:
	Marker(const Marker& );
	
public:
	inline Marker();
	
	inline void			setTransform(const Transform3<float>& );
	inline const Transform3<float>& getTransform() const;
	inline const Transform3<float>& getWorldTransform() const;

protected:
	virtual Marker*		onClone() const;
	virtual void		onTransform(const Transform3<float>& parent);

private:
	Transform3<float>	m_Transform;
	Transform3<float>	m_WorldTransform;
};

}; };

#endif
