/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_MARKER_INL
#define __SCENE3D_MARKER_INL

#include "scene3d.node.h"

namespace magnum { namespace scene3d {


/*--------------------------------------------------------------------------*/
/**
 */
inline Marker::Marker() : Node(Node::MarkerType) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline void Marker::setTransform(const Transform3<float>& t) {
	m_Transform = t;
	updateTransform();
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Transform3<float>& Marker::getTransform() const {
	return m_Transform;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline const Transform3<float>& Marker::getWorldTransform() const {
	if (hasParentTransform())
		return m_WorldTransform;
	else
		return m_Transform;
}

}; };

#endif
