/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_MESHGROUP_H
#define __SCENE3D_MESHGROUP_H

#include "graphics3d.meshgroup.h"
#include "object.pointer.h"
#include "scene3d.geometry.h"

namespace magnum { namespace scene3d {
using magnum::graphics3d::Mesh;
using magnum::object::Pointer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MeshGroup : public Geometry {
DeclareClass(MeshGroup, Geometry);
public:
	typedef magnum::graphics3d::MeshGroup::Iterator	Iterator;

protected:
	MeshGroup(const MeshGroup& );
			
public:						
	inline MeshGroup();		
							
	inline void			insertMesh(Mesh* );
	inline void			removeMesh(Mesh* );
	inline bool			contains(Mesh* ) const;
	inline void			clear();
	inline Mesh*		getMesh(unsigned int ) const;
	
	inline Iterator		begin() const;
	inline Iterator		end() const;
	inline Iterator		at(unsigned int ) const;

protected:
	virtual MeshGroup*	onClone() const;
	virtual void		onRender(GraphicsContext* ,const Transform3<float>& ) const;
	
private:
	magnum::graphics3d::MeshGroup	m_Meshes;
};

}; };

#endif
