/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_MESHGROUP_INL
#define __SCENE3D_MESHGROUP_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MeshGroup::MeshGroup() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void MeshGroup::insertMesh(Mesh* mesh) {
	m_Meshes.insert(mesh);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void MeshGroup::removeMesh(Mesh* mesh) {
	m_Meshes.remove(mesh);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool MeshGroup::contains(Mesh* m) const {
	return m_Meshes.contains(m);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void MeshGroup::clear() {
	m_Meshes.clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Mesh* MeshGroup::getMesh(unsigned int i) const {
	return m_Meshes[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MeshGroup::Iterator MeshGroup::begin() const {
	return m_Meshes.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MeshGroup::Iterator MeshGroup::end() const {
	return m_Meshes.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline MeshGroup::Iterator MeshGroup::at(unsigned int i) const {
	return m_Meshes.at(i);
}

}; };

#endif
