/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_MODIFIER_H
#define __SCENE3D_MODIFIER_H

#include "container.chain.h"
#include "geometry.bounds.h"
#include "scene3d.graphics.h"

namespace magnum { namespace scene3d {
using magnum::container::Chainable;
using magnum::container::Chain;
using magnum::geometry::Bounds3;
using magnum::geometry::Transform3;

class GraphicsContext;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Modifier : public Graphics, private Chainable<Modifier> {
DeclareClass(Modifier, Graphics);
friend GraphicsContext;
protected:
	inline Modifier(const Modifier& );
	inline explicit Modifier(Type t);
	
public:
	inline bool			isQueued() const;
		
	inline void			select(const Transform3<float>& ) const;
	inline void			deselect() const;

	inline void			setRange(const Bounds3<float>& );
	inline const Bounds3<float>& getRange() const;

protected:
	virtual Modifier*	onClone() const;
	virtual void		onSelect(const Transform3<float>& ) const;
	virtual void		onDeselect() const;

private:
	Bounds3<float>		m_Range;
};

}; };

#endif
