/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_MODIFIER_INL
#define __SCENE3D_MODIFIER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Modifier::Modifier(Type t) :Graphics(t) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Modifier::Modifier(const Modifier& m) : Graphics(m) {
	m_Range = m.m_Range;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Modifier::isQueued() const {
	return (getChain() != NULL);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Modifier::select(const Transform3<float>& t) const {
	onSelect(t);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Modifier::deselect() const {
	onDeselect();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Modifier::setRange(const Bounds3<float>& b) {
	m_Range = b;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Bounds3<float>& Modifier::getRange() const {
	return m_Range;
}


}; };

#endif
