/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_NODEPATH_H
#define __SCENE3D_NODEPATH_H

#include "object.h"
#include "container.stack.h"
#include "scene3d.reference.h"

namespace magnum { namespace scene3d {
using magnum::container::Stack;
using magnum::object::Object;
using magnum::types::String;

class Node;
class Locale;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class NodePath : public Object {
DeclareClass(NodePath, Object);
private:
	Stack<Reference>	m_Nodes;
	Locale*				m_Locale;

public:
	typedef magnum::container::Stack<Reference>::Iterator	Iterator;

public:
	inline NodePath();
	inline explicit NodePath(Locale* );

	inline void				push(Node* );
	inline void				push(Node* ,const Transform3<float>& );
	inline void				push(const Reference& );
	inline Reference		pop();
	inline const Reference&	peek() const;
	inline Reference&		peek();

	inline const Transform3<float>& getTransform() const;
	inline Node*			getNode() const;

	inline Locale*			getLocale() const;
	inline void				setLocale(Locale* );
							
	inline void				clear();
	inline bool				isEmpty() const;
	inline unsigned int		getSize() const;
							
	inline Iterator			begin() const;
	inline Iterator			at(unsigned int ) const;
	inline Iterator			end() const;
							
	inline const Reference&	operator[](unsigned int) const;
	inline Reference&		operator[](unsigned int);
};


}; };

#endif
