/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_OBSERVER_INL
#define __SCENE3D_OBSERVER_INL

namespace magnum { namespace scene3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Universe* Observer::getUniverse() const {
	return m_Universe;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Viewer* Observer::getViewer() const {
	return m_Viewer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Observer::attachViewer(Viewer* v) {
	ASSERT(v != NULL);
	m_Viewer = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Observer::detachViewer() {
	m_Viewer = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Listener* Observer::getListener() const {
	return m_Listener;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::attachListener(Listener* l) {
	ASSERT(l != NULL);
	m_Listener = l;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::detachListener() {
	m_Listener = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Activator* Observer::getActivator() const {
	return m_Activator;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::attachActivator(Activator* l) {
	ASSERT(l != NULL);
	m_Activator = l;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Observer::detachActivator() {
	m_Activator = NULL;
}

}; };

#endif
