/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_POSITIONCONTROLLER_INL
#define __SCENE3D_POSITIONCONTROLLER_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline PositionController<T>::PositionController() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline PositionController<T>::PositionController(const PositionController<T>& p) 
	: Controller<T>(p),
	m_Velocity(p.m_Velocity) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline PositionController<T>::PositionController(T* m) : Controller<T>(m) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline void PositionController<T>::setPosition(const Vector3<float>& v) {
	ASSERT(m_Target != NULL);
	m_Target->setPosition(v);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline Vector3<float> PositionController<T>::getPosition() const {
	ASSERT(m_Target != NULL);
	return m_Target->getPosition();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline void PositionController<T>::setVelocity(const Vector3<float>& v) {
	m_Velocity = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
inline Vector3<float> PositionController<T>::getVelocity() const {
	return m_Velocity;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
PositionController<T>* PositionController<T>::onClone() const {
	return new PositionController(*this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> 
void PositionController<T>::onProcess(const Timer& ) {
	ASSERT(m_Target != NULL);
	Vector<float> t;
	m_Target->setPosition(t);
}

}; };

#endif
