/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_RENDERTRAVERSER_H
#define __SCENE3D_RENDERTRAVERSER_H

#include "geometry.frustum.h"
#include "scene3d.traverser.h"
#include "scene3d.graphicscontext.h"

namespace magnum { namespace scene3d {
using magnum::geometry::Frustum3;

class Viewer;
class Universe;
class Graphics;
class Marker;

/*------------------------------------------------------------------------
------------------------------------------------------------------------*/
class RenderTraverser : public Traverser<RenderTraverser, Graphics> {
friend class Traverser<RenderTraverser, Graphics>;
public:
	RenderTraverser(Universe* ,GraphicsContext* );

	void				traverse(const Viewer* );
	void				traverse(const Marker* ,const Frustum3<float>& );
	
private:
	inline void			onVisit(Graphics* ) const;

private:
	GraphicsContext*	m_Context;
};

}; };

#endif
