/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_SCHEDULETRAVERSER_H
#define __SCENE3D_SCHEDULETRAVERSER_H

#include "scene3d.traverser.h"
#include "scene3d.behaviourscheduler.h"

namespace magnum { namespace scene3d {

class Activator;
class Universe;
class Behaviour;

/*------------------------------------------------------------------------
------------------------------------------------------------------------*/
class ScheduleTraverser : public Traverser<ScheduleTraverser, Behaviour> {
friend class Traverser<ScheduleTraverser, Behaviour>;
public:
	ScheduleTraverser(Universe* ,BehaviourScheduler* );

	void				traverse(const Activator* );
	
private:
	inline void			onVisit(Behaviour* ) const;

private:
	BehaviourScheduler*	m_Scheduler;
};

}; };

#endif
