/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_SPOTLIGHTNODE_H
#define __SCENE3D_SPOTLIGHTNODE_H

#include "scene3d.lightnode.h"
#include "graphics3d.spotlight.h"

namespace magnum { namespace scene3d {
using magnum::graphics3d::SpotLight;
using magnum::graphics::Colour;
using magnum::math::Vector3;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SpotLightNode : public LightNode {
DeclareClass(SpotLightNode, LightNode);
protected:
	SpotLightNode(const SpotLightNode& );
	
public:
	inline SpotLightNode();
	inline ~SpotLightNode();

	inline const Colour<float>&	getAmbient() const;
	inline void 				setAmbient(const Colour<float>& );
	inline const Colour<float>&	getDiffuse() const;
	inline void					setDiffuse(const Colour<float>& );
	inline const Colour<float>&	getSpecular() const;
	inline void					setSpecular(const Colour<float>& );
								
	inline const Vector3<float>& getPosition() const;
	inline void					setPosition(const Vector3<float>& );
								
	inline const Vector3<float>& getAttenuation() const;
	inline void					setAttenuation(const Vector3<float>& );
								
	inline void					setCutoff(float );
	inline float				getCutoff() const;
	inline void					setDirection(const Vector3<float>& );
	inline const Vector3<float>& getDirection() const;
	inline void					setExponent(float );
	inline float				getExponent() const;

protected:
	virtual SpotLightNode*		onClone() const;
	virtual void				onTransform(const Transform3<float>& parent);

private:
	SpotLight					m_Light;
	Vector3<float>				m_Position;
	Vector3<float>				m_Direction;
};

}; };

#endif
