/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_SWITCHGROUP_H
#define __SCENE3D_SWITCHGROUP_H

#include "scene3d.group.h"

namespace magnum {namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class SwitchGroup : public Group {
DeclareClass(SwitchGroup, Group);
protected:
	SwitchGroup(const SwitchGroup& );
	
public:
	SwitchGroup();
	
	void				select(Node* );
	void				select(unsigned int idx);
	void				selectNone();
	
	inline unsigned int	getIndex() const;
	inline Node*		getNode() const;
	
protected:
	virtual SwitchGroup* onClone() const;
	virtual void		onInsert(Node* );
	virtual void		onRemove(Node* );

private:
	unsigned int		m_Index;
	Node*				m_Node;
	
};

}; };

#endif
