/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_TRANSFORMCONTROLLER_H
#define __SCENE3D_TRANSFORMCONTROLLER_H

#include "math.vector3.h"
#include "scene3d.controller.h"

namespace magnum { namespace scene3d {
using magnum::math::Vector3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class TransformController : public Controller<T> {
DeclareClass(TransformController, Controller<T>);
protected:
	inline TransformController(const TransformController& );
	
public:
	inline TransformController();
	inline explicit TransformController(T* );

	inline void				setPosition(const Vector3<float>& );
	inline Vector3<float>	getPosition() const;

	inline void				setLinearVelocity(const Vector3<float>& );
	inline Vector3<float>	getLinearVelocity() const;

	inline void				setRotation(const Vector3<float>& );
	inline Vector3<float>	getRotation() const;

	inline void				setAngularVelocity(const Vector3<float>& );
	inline Vector3<float>	getAngularVelocity() const;

protected:
	virtual TransformController* onClone() const;
	virtual void			onProcess(const Timer& );

private:
	Vector3<float>		m_LinVelocity;
	Vector3<float>		m_AngVelocity;
};


}; };

#endif
