/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_UNIVERSE_H
#define __SCENE3D_UNIVERSE_H

#include "object.h"
#include "container.chain.h"
#include "system.timer.h"
#include "scene3d.node.h"

namespace magnum { namespace scene3d {
using magnum::container::Chainable;
using magnum::container::Chain;
using magnum::system::Timer;
using magnum::object::Object;
using magnum::types::String;

class Locale;
class Node;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Universe : public Object {
DeclareClass(Universe, Object);
friend Locale;
friend Node;
public:
	typedef magnum::container::Chain<Locale>::Iterator Iterator;

public:
	Universe();
	~Universe();

	void					clear();
							
	inline bool				isEmpty() const;

	inline Iterator			begin() const;
	inline Iterator			end() const;
	Iterator				at(const char* ) const;

	inline const Timer*		getTimer() const;
	inline Timer*			getTimer();
	
	void					update();

private:
	class DirtyNode : public Node {
	public:
		inline DirtyNode() : Node(Node::Unknown) {};
	};

	DirtyNode				m_DirtyNodes;
	Chain<Locale>			m_Locales;
	Timer					m_Timer;
};

}; };

#endif
