/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_VIEWER_INL
#define __SCENE3D_VIEWER_INL

namespace magnum { namespace scene3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Camera* Viewer::getCamera() {
	return &m_Camera;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Camera* Viewer::getCamera() const {
	return &m_Camera;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewer::setTransform(const Transform3<float>& t) {
	m_Transform = t;
	updateTransform();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& Viewer::getTransform() const {
	return m_Transform;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& Viewer::getWorldTransform() const {
	return m_WorldTransform;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Frustum3<float>& Viewer::getFrustum() const {
	return m_Frustum;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Viewer::setViewWindow(const Rectangle<float>& w) {
	m_Camera.setViewWindow(w);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Viewer::setNearPlane(float f) {
	m_Frustum.setNear(f);
	m_Camera.setProjectionPlane(f);
	m_Camera.setNearPlane(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Viewer::getNearPlane() const {
	return m_Camera.getNearPlane();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewer::setFarPlane(float f) {
	m_Frustum.setFar(f);
	m_Camera.setFarPlane(f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Viewer::getFarPlane() const {
	return m_Camera.getFarPlane();
}

}; };

#endif
