/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_VIEWPORT_H
#define __SCENE3D_VIEWPORT_H

#include "graphics3d.viewport.h"
#include "scene3d.graphicscontext.h"
#include "scene3d.node.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::object::Pointer;
using magnum::types::String;
using magnum::graphics3d::Layer;
using magnum::graphics3d::FrameBuffer;

class Viewer;

/*--------------------------------------------------------------------------*/
/**
 */
class Viewport : public Object {
DeclareClass(Viewport, Object);
public:
	inline void				attachViewer(Viewer* );
	inline void				detachViewer();
	inline Viewer*			getViewer() const;
	
	void					attachBackground(Layer* );
	void					detachBackground();
	inline Layer*			getBackground() const;

	void					attachForeground(Layer* );
	void					detachForeground();
	inline Layer*			getForeground() const;

	inline void				attachFrameBuffer(FrameBuffer* );
	inline void				detachFrameBuffer();
	inline FrameBuffer*		getFrameBuffer() const;
	
	inline void				setWindow(const Rectangle<float>& );
	inline const Rectangle<float>& getWindow() const;
	
	inline void				render();

protected:
	virtual void			onRender();
	
	
private:
	magnum::graphics3d::Viewport m_Viewport;
	Pointer<Viewer>			m_Viewer;
	Pointer<Layer>			m_Background;
	Pointer<Layer>			m_Foreground;
};

}; };

#endif
