/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SCENE3D_VIEWPORT_H
#define __SCENE3D_VIEWPORT_H

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Viewer* Viewport::getViewer() const {
	return m_Viewer;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewport::attachViewer(Viewer* v) {
	ASSERT(v != NULL);
	m_Viewer = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewport::detachViewer() {
	m_Viewer = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Layer*	Viewport::getBackground() const {
	return m_Background;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Layer*	Viewport::getForeground() const {
	return m_Foreground;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewport::attachFrameBuffer(FrameBuffer* fb) {
	m_Viewport.attachFrameBuffer(fb);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewport::detachFrameBuffer() {
	m_Viewport.detachFrameBuffer();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline FrameBuffer* Viewport::getFrameBuffer() const {
	return m_Viewport.getFrameBuffer();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewport::setWindow(const Rectangle<float>& w) {
	m_Viewport.setWindow(w);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Rectangle<float>& Viewport::getWindow() const {
	return m_Viewport.getWindow();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Viewport::render() {
	onRender();
}

}; };

#endif
