/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __STATS_DISCRETE_H
#define __STATS_DISCRETE_H

#include "stats.random.h"
#include "container.array.h"

namespace magnum { namespace stats {
using magnum::container::Array;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Discrete : public Random {
DeclareClass(Discrete, Random);
private:
	Array<float>		m_Weights;
	
public:
	inline Discrete();
	
	void				setWeights(const float* ,unsigned int );
	const float*		getWeights() const;
	unsigned int		getSize() const;
	
	unsigned int		operator()();
};

}; };

#endif
