/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __STATS_DISCRETEUNIFORM_H
#define __STATS_DISCRETEUNIFORM_H

#include "stats.random.h"
#include "math.range.h"

namespace magnum { namespace stats {
using magnum::math::Range;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class DiscreteUniform : public Random {
DeclareClass(DiscreteUniform, Random);
private:
	Range<int>			m_Range;
	
public:
	inline DiscreteUniform();
	inline DiscreteUniform(const Range<int>& );
	inline DiscreteUniform(int ,int );

	inline void			setRange(const Range<int>& );
	inline void			setRange(int min, int max);
	inline const Range<int>& getRange() const;

	unsigned int		operator()();
};

}; };

#endif
