/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __STATS_RANDOM_H
#define __STATS_RANDOM_H

#include "object.h"

namespace magnum { namespace stats {
using magnum::object::Object;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Random : public Object {
DeclareClass(Random, Object);
private:
	unsigned long		m_Seed;

public:

public:
	inline Random();
	inline explicit Random(unsigned long );

	inline unsigned long 	operator()();
	
	inline unsigned long	getSeed() const;
	inline void				setSeed(unsigned long );

protected:
	inline unsigned long	randl();
	inline float			randf();
	inline double			randd();
};

}; };

#endif
