/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __STATS_RANDOM_INL
#define __STATS_RANDOM_INL

namespace magnum { namespace stats {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Random::Random() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Random::Random(unsigned long s) {
	m_Seed = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long Random::getSeed() const {
	return m_Seed;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Random::setSeed(unsigned long s) {
	m_Seed = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long Random::randl() {
	m_Seed = (m_Seed * 214013) + 2531011;
	return m_Seed;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline double Random::randd() {
	m_Seed = (m_Seed * 214013) + 2531011;
	return (double)(m_Seed & 0x7fffffff)*4.656612875245796924105750827168e-10;

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline float Random::randf() {
	m_Seed = (m_Seed * 214013) + 2531011;
	return (float)((m_Seed & 0x7fffffff)*4.656612875245796924105750827168e-10);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long Random::operator()() {
	m_Seed = (m_Seed * 214013) + 2531011;
	return m_Seed;
}

}; };

#endif
