/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __STATS_UNIFORM_H
#define __STATS_UNIFORM_H

#include "stats.random.h"
#include "math.range.h"

namespace magnum { namespace stats {
using magnum::math::Range;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Uniform : public Random {
DeclareClass(Uniform, Random);
private:
	Range<float>		m_Range;
	
public:
	inline Uniform();
	inline explicit Uniform(const Range<float>& );
	inline Uniform(float, float);
	
	inline void			setRange(const Range<float>& );
	inline void			setRange(float min, float max);
	inline const Range<float>& getRange() const;

	inline float		operator()();
};


}; };

#endif
