/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SYSTEM_ASSEMBLER_INL
#define __SYSTEM_ASSEMBLER_INL

namespace magnum { namespace system {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1>	
void Assembler::asmCall(void (__stdcall *adr)(P1), P1 p1) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opStdCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2>	
void Assembler::asmCall(void (__stdcall *adr)(P1 ,P2 ), P1 p1, P2 p2) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opStdCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2, typename P3>	
void Assembler::asmCall(void (__stdcall *adr)(P1, P2, P3), P1 p1, P2 p2, P3 p3) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opStdCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2, typename P3, typename P4>	
void Assembler::asmCall(void (__stdcall *adr)(P1, P2, P3, P4), P1 p1, P2 p2, P3 p3, P4 p4) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opStdCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2, typename P3, typename P4, typename P5>	
void Assembler::asmCall(void (__stdcall *adr)(P1, P2, P3, P4, P5), P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p5;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opStdCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1>	
void Assembler::asmCall(void (__cdecl *adr)(P1), P1 p1) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opCCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2>	
void Assembler::asmCall(void (__cdecl *adr)(P1, P2), P1 p1, P2 p2) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opCCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2, typename P3>	
void Assembler::asmCall(void (__cdecl *adr)(P1, P2, P3), P1 p1, P2 p2, P3 p3) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opCCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2, typename P3, typename P4>	
void Assembler::asmCall(void (__cdecl *adr)(P1, P2, P3, P4), P1 p1, P2 p2, P3 p3, P4 p4) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opCCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<typename P1, typename P2, typename P3, typename P4, typename P5>	
void Assembler::asmCall(void (__cdecl *adr)(P1, P2, P3, P4, P5), P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) {
	Command cmd;
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p5;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opCCall;
	cmd.m_Pointer[0] = adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>	
void Assembler::asmCall(void (T::*adr)(), T* obj) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1>	
void Assembler::asmCall(void (T::*adr)(P1), T* obj,P1 p1) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2>	
void Assembler::asmCall(void (T::*adr)(P1, P2), T* obj,P1 p1 ,P2 p2) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2, typename P3>	
void Assembler::asmCall(void (T::*adr)(P1, P2, P3), T* obj,P1 p1 ,P2 p2, P3 p3) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2, typename P3, typename P4>	
void Assembler::asmCall(void (T::*adr)(P1, P2, P3, P4), T* obj,P1 p1 ,P2 p2, P3 p3, P4 p4) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2, typename P3, typename P4, typename P5>	
void Assembler::asmCall(void (T::*adr)(P1, P2, P3, P4, P5), T* obj,P1 p1 ,P2 p2, P3 p3, P4 p4, P5 p5) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p5;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T>	
void Assembler::asmCall(void (T::*adr)() const, const T* obj) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1>	
void Assembler::asmCall(void (T::*adr)(P1) const, const T* obj,P1 p1) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2>	
void Assembler::asmCall(void (T::*adr)(P1, P2) const, const T* obj,P1 p1 ,P2 p2) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2, typename P3>	
void Assembler::asmCall(void (T::*adr)(P1, P2, P3) const, const T* obj,P1 p1 ,P2 p2, P3 p3) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2, typename P3, typename P4>	
void Assembler::asmCall(void (T::*adr)(P1, P2, P3, P4) const, const T* obj,P1 p1 ,P2 p2, P3 p3, P4 p4) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, typename P1, typename P2, typename P3, typename P4, typename P5>	
void Assembler::asmCall(void (T::*adr)(P1, P2, P3, P4, P5) const, const T* obj,P1 p1 ,P2 p2, P3 p3, P4 p4, P5 p5) {
	Command cmd;
	cmd.m_Opcode = opThis;
	cmd.m_Pointer[0] = (void *)obj;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opParameter;
	cmd.m_Integer[0] = *(int *)(void *)&p1;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p2;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p3;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p4;
	m_Commands.insert(cmd);
	cmd.m_Integer[0] = *(int *)(void *)&p5;
	m_Commands.insert(cmd);
	cmd.m_Opcode = opThisCall;
	cmd.m_Pointer[0] = *(void **)&adr;
	m_Commands.insert(cmd);
};

}; };

#endif
