/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SYSTEM_ATOM_H
#define __SYSTEM_ATOM_H

#include "base.h"

namespace magnum { namespace system {

/*--------------------------------------------------------------------------*/
/**
 */
class Atom {
public:
	inline Atom();
	inline Atom(unsigned int );
	
	inline operator unsigned int() const;
	
	inline unsigned int	getValue() const;
	inline void			setValue(unsigned int );
	
	inline unsigned int	operator++();
	inline unsigned int	operator++(int );
	inline unsigned int	operator--();
	inline unsigned int	operator--(int );
	inline unsigned int	operator=(unsigned int );
	
private:
	volatile unsigned int m_Value;	
};

}; };

#endif
