/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SYSTEM_ATOM_INL
#define __SYSTEM_ATOM_INL

namespace magnum { namespace system {

/*--------------------------------------------------------------------------*/
/**
 */
inline Atom::Atom() {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Atom::Atom(unsigned int v) : m_Value(v) {
}


/*--------------------------------------------------------------------------*/
/**
 */
inline Atom::operator unsigned int() const {
	return m_Value;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int Atom::getValue() const {
	return m_Value;
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int Atom::operator++() {
#if defined(__FORWINDOWS__)
	return InterlockedIncrement((LONG*)&m_Value);
#else
	return ++m_Value;
#endif
}

	
/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int Atom::operator++(int ) {
#if defined(__FORWINDOWS__)
	unsigned int old = m_Value;
	InterlockedIncrement((LONG*)&m_Value);
	return m_Value;
#else
	return m_Value++;
#endif
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int Atom::operator--() {
#if defined(__FORWINDOWS__)
	return InterlockedDecrement((LONG*)&m_Value);
#else
	return --m_Value;
#endif
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int Atom::operator--(int ) {
#if defined(__FORWINDOWS__)
	unsigned int old = m_Value;
	InterlockedDecrement((LONG*)&m_Value);
	return m_Value;
#else
	return m_Value--;
#endif
}


/*--------------------------------------------------------------------------*/
/**
 */
inline unsigned int Atom::operator=(unsigned int v) {
	return m_Value = v;
}
	
}; };

#endif
