/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/
#ifndef __SYSTEM_BARRIER_H
#define __SYSTEM_BARRIER_H

#include "object.h"

namespace magnum {namespace system {
using magnum::object::Object;
using magnum::object::Noncopyable;
using magnum::types::String;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Barrier : public Object, public Noncopyable {
DeclareClass(Barrier, Object);
private:
	unsigned int		m_Waiters;
	unsigned int		m_Current;
	HANDLE				m_Mutex;
    HANDLE				m_Semaphore;

public:
	explicit Barrier(unsigned int = 2);
	
	inline void			setWaiters(unsigned int );
	inline unsigned int getWaiters() const;
	
	inline void			wait(unsigned int );
	void				wait();
};

}; };

#endif
