/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SYSTEM_PROCESS_H
#define __SYSTEM_PROCESS_H

#include "object.h"
#include "base.types.h"

# if defined(__FORUNIX__)
#	include <pthread.h>
# endif

namespace magnum { namespace system {
using magnum::object::Object;
using magnum::object::Noncopyable;
using magnum::types::String;
using magnum::types::dword;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Process : public Object, public Noncopyable {
DeclareClass(Thread, Object);
public:
	enum Priority {
		AboveNormal = ABOVE_NORMAL_PRIORITY_CLASS,
		BelowNormal = BELOW_NORMAL_PRIORITY_CLASS,
		High = HIGH_PRIORITY_CLASS,
		Idle = IDLE_PRIORITY_CLASS,
		Normal = NORMAL_PRIORITY_CLASS,
		Realtime = REALTIME_PRIORITY_CLASS
		
	};
public:
	Priority			getPriority() const;
	void				setPriority(Priority );

	static void			exit(int status = 0);

	inline static Process* getCurrent();

private:
	Process();
	~Process();

private:
#if defined(__FORWINDOWS__)
	HANDLE				m_Handle;
#endif
	static Process		g_Process;
};

}; };
#endif
