/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SYSTEM_STDIO_H
#define __SYSTEM_STDIO_H

#include "io.inputstream.h"
#include "io.outputstream.h"

namespace magnum { namespace system {
using magnum::object::Object;
using magnum::types::String;
using magnum::types::int64;
using magnum::io::InputStream;
using magnum::io::OutputStream;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StandardInputStream : public InputStream {
protected:
	size_t		onRead(void *buffer, size_t size);
	size_t		onSkip(size_t size);
	int64		onAvailable();
	bool		onClose();
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StandardOutputStream : public OutputStream {
protected:
	size_t		onWrite(const void *buffer, size_t size);
	bool		onFlush();
	bool		onClose();
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StandardErrorStream : public OutputStream {
protected:
	size_t		onWrite(const void *buffer, size_t size);
	bool		onFlush();
	bool		onClose();
};


extern StandardInputStream		In;
extern StandardOutputStream		Out;
extern StandardErrorStream		Err;

}; };
#endif
