/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SYSTEM_TICKER_H
#define __SYSTEM_TICKER_H

#include "system.thread.h"

namespace magnum { namespace system {
using magnum::object::Object;
using magnum::object::Noncopyable;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Ticker : public Object, public Noncopyable {
DeclareClass(Ticker, Object);
private:
	class TickerThread : public Thread {
	DeclareClass(TickerThread, Thread);
	friend Ticker;
	private:
		Ticker*			m_Ticker;

	protected:
		bool			run();
	};

	friend class TickerThread;

	TickerThread		m_Thread;
	unsigned int		m_Period;
	bool				m_Alive;
	HANDLE				m_Timer;

public:
	Ticker();
	~Ticker();

	void				setPeriod(unsigned int millis);
	inline unsigned int	getPeriod() const;

	void				start();
	void				stop();
	void				kill();

	inline bool			isAlive() const;

	inline const Thread* getThread() const;

protected:
	virtual void		onTick();
};

}; };

#endif
