/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#ifndef __SYSTEM_TIMER_H
#define __SYSTEM_TIMER_H

#include "system.timestamp.h"

namespace magnum { namespace system {
using magnum::object::Object;
using magnum::types::String;
using magnum::types::uint64;
using magnum::types::int64;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Timer : public Object {
DeclareClass(Timer, Object);
private:
	Timestamp		m_Timestamp;
	int64			m_Difference;
	uint64			m_Current;
	uint64			m_Previous;
	uint64			m_Elapsed;
	
public:
	enum {
		Millisecond = 1,
		Second		= 1000,
		Minute		= 60000,
		Hour		= 3600000,
	};
	
public:
	inline explicit Timer(uint64 = 0);

	void			init(uint64 );
	void			update();
	
	inline uint64	getCurrent() const;
	inline uint64	getPrevious() const;
	inline uint64	getElapsed() const;
};

}; };

#endif
