/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "application.message.h"
#include "system.thread.h"
#include "application.looper.h"
#include "application.handler.h"

#include "base.string.inl"
#include "object.inl"
#include "system.thread.inl"
#include "system.signal.inl"
#include "application.looper.inl"
#include "application.messenger.inl"


namespace magnum { namespace application {
using namespace magnum::container;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Looper::Looper() {
#if defined(__FORX11__)
	m_Display = NULL;
	m_MessageQueue = 0;
#endif
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Looper::~Looper() {
	if (getThread() != NULL) {
		stop();
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::start() {
	if (getThread() != NULL) 
		return false;

	// Create Looper-Thread	
	Thread* thread = new LooperThread(this);
	thread->start();
	attachThread(thread);

	// Wait for message queue
	m_Signal.wait();

	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::stop() {
	if (getThread() == NULL)
		return false;

	// Post Quit Message
	sysStop();

	if (getThread()->join()) {
		getThread()->release();
		detachThread();
	}
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Looper::LooperThread::LooperThread(Looper *looper) {
	m_Looper = looper;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Looper::LooperThread::~LooperThread() {

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Looper::LooperThread::run() {
	m_Looper->sysLoop();
	return true;
}

}; };
