/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "application.performer.h"
#include "application.task.h"

#include "application.performer.inl"
#include "application.task.inl"

namespace magnum { namespace application {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Task::run() {
	onStart();
	
	do {
		// do the fancy stuff here
		onProcess();
		
		// wait for barrier
		getPerformer()->m_Barrier.wait();
		
		// wait for synchronisation
		getPerformer()->m_SyncBarrier.wait();
	} while (!getPerformer()->m_StopSignal.isRaised());
	
	onStop();
	
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Task::onStart() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Task::onStop() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Task::onSync() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Task::onProcess() {
}

}; };
