/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "audio3d.device.h"
#include "audio3d.context.h"

#include "audio3d.device.inl"
#include "audio3d.context.inl"

namespace magnum { namespace audio3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Device::Device() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Device::~Device() {
	alcCloseDevice(m_Device);
}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Device* Device::create(const char* name) {
	ALCdevice* alcdev = alcOpenDevice(NULL);
	if (alcdev == NULL)
		return NULL;
	Device* dev = new Device();
	dev->m_Device = alcdev;
	return dev;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Context* Device::createContext() {
	int attr = 0;
	ALCcontext* alccon = alcCreateContext(m_Device, &attr);
	Context* con = new Context(this, alccon);
	con->makeCurrent();
	return con;
}

}; };
