/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "graphics3d.constant.h"

#include "graphics3d.constant.inl"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void ConstantList::remove(const char* name) {
	unsigned int size = 0;
	for (unsigned int i = 0; i < m_Constants.getSize(); i++) {
		if (strncmp(m_Constants[i]->m_Name, name, sizeof(m_Constants[i]->m_Name)) == 0) {
			m_Constants.remove(i);
			break;
		}
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool ConstantList::contains(const char* name) const {
	for (unsigned int i = 0; i < m_Constants.getSize(); i++) {
		if (strncmp(m_Constants[i]->m_Name, name, sizeof(m_Constants[i]->m_Name)) == 0)
			return true;
	}
	return false;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
ConstantList::Iterator ConstantList::at(const char* name) const {
	for (unsigned int i = 0; i < m_Constants.getSize(); i++) {
		if (strncmp(m_Constants[i]->m_Name, name, sizeof(m_Constants[i]->m_Name)) == 0)
			return m_Constants.at(i);
	}
	return m_Constants.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Constant* ConstantList::operator[](const char* name) const {
	for (unsigned int i = 0; i < m_Constants.getSize(); i++) {
		if (strncmp(m_Constants[i]->m_Name, name, sizeof(m_Constants[i]->m_Name)) == 0)
			return m_Constants[i];
	}
	ASSERT(false);
	return NULL;
}


}; };
