/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "graphics3d.pixelprogram.h"
#include "graphics3d.exception.h"

#include "graphics3d.resource.inl"
#include "graphics3d.shaderprogram.inl"
#include "graphics3d.pixelprogram.inl"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
PixelProgram* PixelProgram::create() {
	if (glCreateShader == NULL)
		throw UnsupportedFeatureException();
		unsigned int handle = glCreateShader(GL_FRAGMENT_SHADER);
	if (glGetError() != GL_NO_ERROR)
		throw InvalidOperationException();
		
	return new PixelProgram(handle);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
PixelProgram* PixelProgram::create(const char* src) {
	if (glCreateShader == NULL)
		throw UnsupportedFeatureException();
	unsigned int handle = glCreateShader(GL_FRAGMENT_SHADER);
	if (glGetError() != GL_NO_ERROR)
		throw InvalidOperationException();
		
	glShaderSource(handle, 1, &src, NULL);
	if (glGetError() != GL_NO_ERROR) {
		glDeleteShader(handle);
		throw InvalidOperationException();
	}
		
	glCompileShader(handle);
	if (glGetError() != GL_NO_ERROR) {
		glDeleteShader(handle);
		throw ShaderCompilerException();
	}
	GLint val;
	glGetShaderiv(handle, GL_COMPILE_STATUS, &val);
	if (val != GL_TRUE) {
		char buffer[1024];
		buffer[0] = 0;
		glGetShaderInfoLog(handle, 1024, NULL, buffer);
		glDeleteShader(handle);
		throw ShaderCompilerException(buffer);
	}
	
	return new PixelProgram(handle);
}

}; };
