#include "graphics3d.shadowvolume.h"
#include "graphics3d.material.h"
#include "graphics3d.shader.h"
#include "graphics3d.context.h"
#include "graphics3d.indexmesh.h"

#include "object.inl"
#include "base.string.inl"
#include "graphics3d.material.inl"
#include "graphics3d.shader.inl"
#include "graphics3d.projectionvolume.inl"
#include "graphics3d.shadowvolume.inl"
#include "graphics3d.ressource.inl"
#include "graphics3d.mesh.inl"
#include "graphics3d.context.inl"
#include "graphics3d.mode.inl"

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
ShadowVolume::ShadowVolume() {
	attachShader(&m_Shader);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void ShadowVolume::onRender() {
	if (m_IndexRange == 0)
		return;

	if (m_Material != NULL)
		m_Material->select();
	if (m_Shader != NULL)
		m_Shader->select();
	m_IndexBuffer->select();
	m_VertexBuffer->selectVertices();
	getContext()->selectAttributes(VertexFormat::Vertex);
	getContext()->renderIndices(Mesh::TriangleList, m_IndexRange);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void ShadowVolume::Shader::onSelect() {

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void ShadowVolume::Shader::onDeselect() {

}


}; };
