/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "input.flightstick.h"

#include "object.inl"
#include "math.vector.inl"
#include "math.matrix.inl"
#include "application.listener.inl"
#include "input.device.inl"
#include "input.marker.inl"
#include "input.body.inl"
#include "input.flightstick.inl"

namespace magnum { namespace input {


/*--------------------------------------------------------------------------*/
/**
 */
void Flightstick::fireConnect() {
	for (Dispatcher<FlightstickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onFlightstickConnect();
}


/*--------------------------------------------------------------------------*/
/**
 */
void Flightstick::fireDisconnect() {
	for (Dispatcher<FlightstickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onFlightstickDisconnect();
}


/*--------------------------------------------------------------------------*/
/**
 */
void Flightstick::fireMove(const Matrix4<float>& p,Flightstick::Button b) {
	for (Dispatcher<FlightstickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onFlightstickMove(p,b);
}


/*--------------------------------------------------------------------------*/
/**
 */
void Flightstick::fireButton(const Matrix4<float>& p,Flightstick::Button b) {
	for (Dispatcher<FlightstickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onFlightstickButton(p,b);
}


/*--------------------------------------------------------------------------*/
/**
 */
void FlightstickListener::onFlightstickConnect() {
}


/*--------------------------------------------------------------------------*/
/**
 */
void FlightstickListener::onFlightstickDisconnect() {
}


/*--------------------------------------------------------------------------*/
/**
 */
void FlightstickListener::onFlightstickMove(const Matrix4<float>& ,Flightstick::Button ) {
}


/*--------------------------------------------------------------------------*/
/**
 */
void FlightstickListener::onFlightstickButton(const Matrix4<float>& ,Flightstick::Button ) {
}

}; };
