/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "input.glove.h"
#include "input.space.h"

#include "object.inl"
#include "math.vector.inl"
#include "math.matrix.inl"
#include "container.allocator.inl"
#include "container.iterator.inl"
#include "container.chain.inl"
#include "container.list.inl"
#include "application.listener.inl"
#include "input.device.inl"
#include "input.marker.inl"
#include "input.body.inl"
#include "input.glove.inl"
#include "input.space.inl"

namespace magnum { namespace input {

/*--------------------------------------------------------------------------*/
/**
 */
Glove::Glove(Space* s) : Body(s) {
	getSpace()->m_Gloves.insert(this);
	release();
}


/*--------------------------------------------------------------------------*/
/**
 */
Glove::Glove(Space* s,const char* n) : Body(s,n) {
	getSpace()->m_Gloves.insert(this);
	release();
}


/*--------------------------------------------------------------------------*/
/**
 */
Glove::Glove(Space* s,const String& n) : Body(s,n) {
	getSpace()->m_Gloves.insert(this);
	release();
}


/*--------------------------------------------------------------------------*/
/**
 */
void Glove::fireConnect() {
	for (Dispatcher<GloveListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onGloveConnect();
}


/*--------------------------------------------------------------------------*/
/**
 */
void Glove::fireDisconnect() {
	for (Dispatcher<GloveListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onGloveDisconnect();
}


/*--------------------------------------------------------------------------*/
/**
 */
void Glove::fireMove(const Matrix4<float>& p,Glove::Button b) {
	for (Dispatcher<GloveListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onGloveMove(p,b);
}


/*--------------------------------------------------------------------------*/
/**
 */
void Glove::fireButton(const Matrix4<float>& p,Glove::Button b) {
	for (Dispatcher<GloveListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onGloveButton(p,b);
}


/*--------------------------------------------------------------------------*/
/**
 */
void GloveListener::onGloveConnect() {
}


/*--------------------------------------------------------------------------*/
/**
 */
void GloveListener::onGloveDisconnect() {
}


/*--------------------------------------------------------------------------*/
/**
 */
void GloveListener::onGloveMove(const Matrix4<float>& ,Glove::Button ) {
}


/*--------------------------------------------------------------------------*/
/**
 */
void GloveListener::onGloveButton(const Matrix4<float>& ,Glove::Button ) {
}

}; };
