/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "input.joystick.h"

#include "math.vector.inl"
#include "container.iterator.inl"
#include "container.list.inl"
#include "application.listener.inl"
#include "input.joystick.inl"

namespace magnum { namespace input {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Joystick::fireConnect() {
	for (Dispatcher<JoystickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onJoystickConnect();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Joystick::fireDisconnect() {
	for (Dispatcher<JoystickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onJoystickDisconnect();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Joystick::fireMove(const Vector<float,6>& p,Joystick::Button b) {
	for (Dispatcher<JoystickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onJoystickMove(p,b);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Joystick::fireButton(const Vector<float,6>& p,Joystick::Button b) {
	for (Dispatcher<JoystickListener>::Iterator iter = m_Dispatcher.begin(); iter != m_Dispatcher.end(); ++iter)
		(*iter)->onJoystickButton(p,b);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void JoystickListener::onJoystickConnect() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void JoystickListener::onJoystickDisconnect() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void JoystickListener::onJoystickMove(const Vector<float,6>& ,Joystick::Button ) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void JoystickListener::onJoystickButton(const Vector<float,6>& ,Joystick::Button ) {
}

}; };
