/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "input.mouse.h"

#include "container.iterator.inl"
#include "container.list.inl"
#include "application.listener.inl"
#include "graphics.point.inl"
#include "graphics.rectangle.inl"
#include "input.mouse.inl"

namespace magnum { namespace input {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseDispatcher::fireArea(const Rectangle<float>& r) {
	for (Iterator iter = begin(); iter != end(); ++iter)
		(*iter)->onMouseArea(r);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseDispatcher::fireMove(const Point<float>& p,Mouse::Button b) {
	for (Iterator iter = begin(); iter != end(); ++iter)
		(*iter)->onMouseMove(p,b);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseDispatcher::fireButton(const Point<float>& p,Mouse::Button b) {
	for (Iterator iter = begin(); iter != end(); ++iter)
		(*iter)->onMouseButton(p,b);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseDispatcher::fireWheel(float a) {
	for (Iterator iter = begin(); iter != end(); ++iter)
		(*iter)->onMouseWheel(a);
}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseListener::onMouseArea(const Rectangle<float>& ) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseListener::onMouseMove(const Point<float>& ,Mouse::Button ) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseListener::onMouseButton(const Point<float>& ,Mouse::Button ) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void MouseListener::onMouseWheel(float ) {
}

}; };
