/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "io.sysfilefactory.h"
#include "io.sysdirectory.h"
#include "io.sysfile.h"

#include "object.inl"
#include "base.string.inl"
#include "container.allocator.inl"
#include "container.list.inl"
#include "io.file.inl"
#include "io.filefactory.inl"
#include "io.sysfilefactory.inl"
#include "io.fileinfo.inl"
#include "io.directory.inl"
#include "io.sysdirectory.inl"

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
String SystemFileFactory::getAbsName(const char* fname) {
	String name = m_Directory;
	unsigned int len = name.getLength();
	if (len > 0) {
		if (name[len-1] != '\\')
			name += "\\";
	}
	name += fname;
	return name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool SystemFileFactory::onExists(const char* fname) {
	return SystemFile::exists(getAbsName(fname));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
File* SystemFileFactory::onCreate(const char* fname) {
	return SystemFile::create(getAbsName(fname));
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
File* SystemFileFactory::onOpen(const char* fname,File::OpenFlags flags) {
	return SystemFile::open(getAbsName(fname), flags);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Directory* SystemFileFactory::onList() {
	return new SystemDirectory(m_Directory);
}

}; };

