/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "media.listener.h"
#include "media.pin.h"
#include "media.graph.h"

#include "container.allocator.inl"
#include "container.list.inl"
#include "application.listener.inl"

namespace magnum { namespace media {

/*--------------------------------------------------------------------------*/
/** This method will be called when the media graph has been started
 */
void MediaListener::onStart(Graph* ) {
}


/*--------------------------------------------------------------------------*/
/** This method will be called when the media graph has been stopped
 */
void MediaListener::onStop(Graph* ) {
}


/*--------------------------------------------------------------------------*/
/** This method will be called when the media graph has been paused
 */
void MediaListener::onPause(Graph* ) {
}


/*--------------------------------------------------------------------------*/
/** This method will be called when the media graph has been resumed
 */
void MediaListener::onResume(Graph* ) {
}


/*--------------------------------------------------------------------------*/
/** This method will be called when the media graph has been reset
 */
void MediaListener::onReset(Graph* ) {
}


/*--------------------------------------------------------------------------*/
/** This method will be called when the pin has received an end of input
 * message, that means that the connected pin will not produce any output
 * any more (unless the application interferes)
 */
void MediaListener::onEndOfInput(Graph* ,InputPin* ) {
}


/*--------------------------------------------------------------------------*/
/** This method will be called when the pin has received an end of output
 * message, that means that the connected pin will not process any data
 * any more (unless the application interferes)
 */
void MediaListener::onEndOfOutput(Graph* ,OutputPin* ) {
}

}; };

