/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "scene3d.geometry.h"
#include "scene3d.locale.h"
#include "scene3d.universe.h"
#include "scene3d.observer.h"
#include "scene3d.root.h"
#include "scene3d.soundnode.h"
#include "scene3d.behaviour.h"
#include "scene3d.modifier.h"

#include "container.allocator.inl"
#include "container.chain.inl"
#include "geometry.space.inl"
#include "geometry.cube.inl"
#include "geometry.box.inl"
#include "geometry.bounds.inl"
#include "geometry.transform.inl"
#include "math.vector.inl"
#include "scene3d.geometry.inl"
#include "scene3d.graphics.inl"
#include "scene3d.observer.inl"
#include "scene3d.node.inl"
#include "scene3d.leaf.inl"
#include "scene3d.locale.inl"
#include "scene3d.graphicscontext.inl"


namespace magnum { namespace scene3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Geometry::Geometry(const Geometry& g) : Graphics(g) {
	m_Transform = g.m_Transform;
	m_WorldTransform = g.m_WorldTransform;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Geometry* Geometry::onClone() const {
	return new Geometry(*this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Geometry::onTransform(const Transform3<float>& parent) {
	if (hasParentTransform()) {
		m_WorldTransform = parent * m_Transform;
		setWorldBounds(m_WorldTransform * getBounds());
	} else {
		setWorldBounds(m_Transform * getBounds());
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Geometry::onRender(GraphicsContext* ,const Transform3<float>& ) {
}

}; }; 
