/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "scene3d.switchgroup.h"

#include "scene3d.switchgroup.inl"


namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
SwitchGroup::SwitchGroup() {
	m_Index = 0;
	m_Node = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
SwitchGroup::SwitchGroup(const SwitchGroup& g) : Group(g) {
	m_Index = 0;
	m_Node = NULL;
	select(g.getIndex());
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void SwitchGroup::select(Node* node) {
	ASSERT(node != NULL);
	ASSERT(node->getParent() == this);
	
	if (m_Node == node) {
		if (isEnabled())
			node->enable();
		return;
	}
	
	if (m_Node != NULL)
		m_Node->disable();
	
	m_Node = node;
	m_Node->enable();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void SwitchGroup::select(unsigned int idx) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void SwitchGroup::selectNone() {
	if (m_Node == NULL)
		return;
		
	m_Node->disable();
	m_Node = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
SwitchGroup* SwitchGroup::onClone() const {
	return new SwitchGroup(*this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void SwitchGroup::onInsert(Node* ) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void SwitchGroup::onRemove(Node* node) {
	// Test if node to be removed is currently selected node
	if (m_Node == node)
		m_Node = NULL;
}



}; };
