/* 
  Magnum 
  Copyright (C) 2002-2006 Kaya Kupferschmidt. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Kupferschmidt  (k.kupferschmidt@dimajix.de)
*/

#include "system.stdio.h"

#include "base.string.inl"
#include "object.class.inl"
#include "object.inl"
#include "io.stream.inl"
#include "io.inputstream.inl"
#include "io.outputstream.inl"
#include "system.stdio.inl"

#include <stdio.h>

namespace magnum { namespace system {

StandardInputStream In;
StandardOutputStream Out;
StandardErrorStream Err;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
size_t StandardInputStream::onRead(void *buffer, size_t size) {
	if (fread(buffer, size, 1, stdin) < 1)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
size_t StandardInputStream::onSkip(size_t size) {
	if (fseek(stdin,(long)size,SEEK_CUR) != 0)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
int64 StandardInputStream::onAvailable() {
	return 1;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool StandardInputStream::onClose() {
	return false;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
size_t StandardOutputStream::onWrite(const void *buffer, size_t size) {
	if (fwrite(buffer, size, 1, stdout) < 1)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool StandardOutputStream::onFlush() {
	fflush(stdout);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool StandardOutputStream::onClose() {
	return false;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
size_t StandardErrorStream::onWrite(const void *buffer, size_t size) {
	if (fwrite(buffer, size, 1, stderr) < 1)
		return 0;
	return size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool StandardErrorStream::onFlush() {
	fflush(stderr);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool StandardErrorStream::onClose() {
	return false;
}

}; };
