#include "magnum.net.h"
#include "magnum.system.h"

using namespace magnum::net;
using namespace magnum::io;

void printUrl(const URL& url) {
	printf("query = %s\n", (const char*)url.getQuery());
	printf("protocol = %s\n", (const char*)url.getProtocol());
	printf("host = %s\n", (const char*)url.getHost());
	printf("port = %d\n", url.getPort());
	printf("file = %s\n", (const char*)url.getFile());
	printf("path = %s\n", (const char*)url.getPath());
	printf("\n");
}


void UrlTest(void) {
	const char* urls[] = {
		"www.heise.de",
		"www.heise.de:80",
		"www.heise.de/",
		"www.heise.de:80/",
		"www.heise.de/index.html",
		"www.heise.de/index.html?q=lala",
		"www.heise.de/sub/index.html?q=lala",
		"www.heise.de:80/sub/index.html?q=lala",
		"http://www.heise.de",
		"http://www.heise.de:80",
		"http://www.heise.de/",
		"http://www.heise.de:80/",
		"http://www.heise.de/index.html",
		"http://www.heise.de/index.html?q=lala",
		"http://www.heise.de/sub/index.html?q=lala",
		"http://www.heise.de:80/sub/index.html?q=lala",
		0 };
		
	for (const char** urlptr = urls; *urlptr != 0; ++urlptr) {
		URL url(*urlptr);
		printf("url = %s\n", *urlptr);
		printUrl(url);
	}

	URL url1("http","www.heise.de");
	printUrl(url1);

	URL url2("http","www.heise.de","index.html");
	printUrl(url2);

	URL url3("http","www.heise.de","/index.html");
	printUrl(url3);

	URL url4("http","www.heise.de",80,"index.html");
	printUrl(url4);

	URL url5("http","www.heise.de",80,"/index.html");
	printUrl(url5);
}


int main(void) {
//	URL url("http://magnum.dimajix.de/download/magnum-src-12-29-05.zip");
//	URL url("http://212.72.165.23:9524/switch.ogg");
	URL url("http://66.90.75.75:8030/flash.ogg");
	printUrl(url);
	
	SystemFile* file = SystemFile::create("test.ogg");
	
	HttpClient client;
	HttpRequest request(url);
	HttpResponse response = client.request(request);
	InputStream* in = response.getInputStream();

	unsigned int bytes = 0;
	for (;;) {
		char buffer[16001];
		int ret = (int)in->read(buffer, 16000);
		if (ret <= 0)
			break;
		bytes += ret;
		printf("kbytes: %d\n",bytes / 1024);
		buffer[ret] = 0;
		file->write(buffer, ret);
//		printf(buffer);
	}	
	
	file->release();
	
	return 1;
}
