#include "magnum.media.h"
#include "magnum.io.h"
#include "magnum.net.h"


using namespace magnum::media;
using magnum::io::SystemFile;
using magnum::io::InputStream;
using magnum::net::URL;
using magnum::net::HttpClient;
using magnum::net::HttpResponse;
using magnum::net::HttpRequest;
using magnum::object::Object;
using magnum::object::AutoPointer;

#define TEST_STREAM

magnum::system::Signal stop;


class MediaController : public MediaListener, public Object {
	virtual void onEndOfInput(Graph* ,InputPin* ) {
		printf("endOfInput\n");
		stop.raise();
	}
	virtual void onEndOfOutput(Graph* ,OutputPin* ) {
		printf("endOfOutput\n");
		stop.raise();
	}
};


int main(void) {
#if defined TEST_STREAM
	URL url("http://66.90.75.75:8030/flash.ogg");
	HttpClient client;
	HttpResponse response = client.request(HttpRequest(url));
	InputStream* in = response.getInputStream();
	ReaderOGG reader(in);
#elif defined TEST_OGG
	AutoPointer<SystemFile> file = SystemFile::open("data/music.ogg");
	if (!file)
		return -1;
	ReaderOGG reader(file);
#elif defined TEST_WAV
	AutoPointer<SystemFile> file = SystemFile::open("data/200puls.wav");
	if (!file)
		return -1;
	ReaderWAV reader(file);
#endif
		
	Graph graph;
	WaveDevice wdev;
	AutoPointer<Node> out = wdev.createOutput();
	graph.insert(out);
	graph.insert(&reader);
	graph.connect(out->getInputPin(), reader.getOutputPin());
	
	AutoPointer<MediaController> controller = new MediaController();
	graph.insertListener(controller);

	printf("Starting... ");
	graph.start();
	printf("ok\n");
	stop.wait();
	
	printf("Waiting for end of output... ");
	graph.stop();
	printf("ok\n");


	printf("Stopping... ");
	graph.stop();
	printf("ok\n");

	graph.clear();	
	return 1;
}
